/*===========================================================================*/
/*   (Reduce/walk.scm)                                                       */
/*   Bigloo (2.6e)                                                           */
/*   Inria -- Sophia Antipolis (c)       Wed Jun 9 12:37:31 CEST 2004        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc-2.95 -lib-dir /users/serrano/prgm/project/bigloo/lib/2.6e -unsafev -no-hello -O2 -rm -unsafe -s -indent Reduce/walk.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_feffectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_readz00;
   obj_t BgL_writez00;
} *BgL_feffectz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_argszd2typezd2;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castzd2nullzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
} *BgL_castzd2nullzd2_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;


BGL_IMPORT double BGl_roundflz00zz__r4_numbers_6_5_flonumz00(double);
static obj_t BGl_methodzd2initzd2zzreduce_walkz00();
BGL_IMPORT obj_t open_input_string(obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t);
extern obj_t BGl_za2optimzd2dataflowzf3za2z21zzengine_paramz00;
extern obj_t BGl_reducezd2conditionalz12zc0zzreduce_condz00(obj_t);
extern obj_t BGl_za2optimzd2reducezd2betazf3za2zf3zzengine_paramz00;
extern obj_t BGl_reducezd21occz12zc0zzreduce_1occz00(obj_t);
extern obj_t BGl_reducezd2typezd2checkz12z12zzreduce_typecz00(obj_t);
static obj_t BGl_cnstzd2initzd2zzreduce_walkz00();
extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
BGL_IMPORT obj_t BGl_displayzd22zd2zz__r4_output_6_10_3z00(obj_t, obj_t);
extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
static obj_t BGl_importedzd2moduleszd2initz00zzreduce_walkz00();
extern obj_t BGl_reducezd2betaz12zc0zzreduce_betaz00(obj_t);
BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
static obj_t BGl__reducezd2walkz12zc0zzreduce_walkz00(obj_t, obj_t);
extern obj_t BGl_reducezd2csez12zc0zzreduce_csez00(obj_t);
BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzreduce_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzreduce_copyz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzreduce_csez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzreduce_condz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzreduce_typecz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzreduce_1occz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzreduce_betaz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_removez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_reducezd2walkz12zc0zzreduce_walkz00(obj_t);
extern obj_t BGl_za2optimza2z00zzengine_paramz00;
extern obj_t BGl_removezd2varzd2zzast_removez00(obj_t, obj_t);
BGL_IMPORT obj_t display_string(obj_t, obj_t);
extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
extern obj_t BGl_reducezd2copyz12zc0zzreduce_copyz00(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzreduce_walkz00 = BUNSPEC;
static obj_t BGl_libraryzd2moduleszd2initz00zzreduce_walkz00();
static obj_t __cnst[ 2 ] ;


DEFINE_STRING( BGl_string3172z00zzreduce_walkz00, BgL_bgl_string3172za700za7za7reduce_walkza7003200z00, "reduce pass-started ", 20 );
DEFINE_STRING( BGl_string3171z00zzreduce_walkz00, BgL_bgl_string3171za700za7za7reduce_walkza7003201z00, "reduce_walk", 11 );
DEFINE_STRING( BGl_string3170z00zzreduce_walkz00, BgL_bgl_string3170za700za7za7reduce_walkza7003202z00, "failure during postlude hook", 28 );
DEFINE_STRING( BGl_string3169z00zzreduce_walkz00, BgL_bgl_string3169za700za7za7reduce_walkza7003203z00, " occured, ending ...", 20 );
DEFINE_STRING( BGl_string3168z00zzreduce_walkz00, BgL_bgl_string3168za700za7za7reduce_walkza7003204z00, "", 0 );
DEFINE_STRING( BGl_string3167z00zzreduce_walkz00, BgL_bgl_string3167za700za7za7reduce_walkza7003205z00, "s", 1 );
DEFINE_STRING( BGl_string3166z00zzreduce_walkz00, BgL_bgl_string3166za700za7za7reduce_walkza7003206z00, " error", 6 );
DEFINE_STRING( BGl_string3165z00zzreduce_walkz00, BgL_bgl_string3165za700za7za7reduce_walkza7003207z00, "failure during prelude hook", 27 );
DEFINE_STRING( BGl_string3164z00zzreduce_walkz00, BgL_bgl_string3164za700za7za7reduce_walkza7003208z00, "   . ", 5 );
DEFINE_STRING( BGl_string3163z00zzreduce_walkz00, BgL_bgl_string3163za700za7za7reduce_walkza7003209z00, "Reduction", 9 );
DEFINE_EXPORT_PROCEDURE( BGl_reducezd2walkz12zd2envz12zzreduce_walkz00, BgL_bgl__reduceza7d2walkza712za7c0za7za7reduce_walkza7003210z00, BGl__reducezd2walkz12zc0zzreduce_walkz00, 0L, 1 );



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzreduce_walkz00(long BgL_checksumz00_1113, char * BgL_fromz00_1114)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzreduce_walkz00))
{ 
BGl_requirezd2initializa7ationz75zzreduce_walkz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzreduce_walkz00(); 
BGl_cnstzd2initzd2zzreduce_walkz00(); 
BGl_importedzd2moduleszd2initz00zzreduce_walkz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzreduce_walkz00()
{ AN_OBJECT;
{ /* ./Reduce/walk.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)0), "reduce_walk"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "reduce_walk"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "reduce_walk"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "reduce_walk"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "reduce_walk"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzreduce_walkz00()
{ AN_OBJECT;
{ /* ./Reduce/walk.scm 15 */
{ /* ./Reduce/walk.scm 15 */
obj_t BgL_cportz00_1106;
BgL_cportz00_1106 = 
open_input_string(BGl_string3172z00zzreduce_walkz00); 
{ 
long BgL_iz00_1107;
BgL_iz00_1107 = ((long)1); 
BgL_loopz00_1108:
{ /* ./Reduce/walk.scm 15 */
bool_t BgL_test3174z00_1109;
BgL_test3174z00_1109 = 
(BgL_iz00_1107==((long)-1)); 
if(BgL_test3174z00_1109)
{ /* ./Reduce/walk.scm 15 */
return BUNSPEC;}  else 
{ /* ./Reduce/walk.scm 15 */
{ /* ./Reduce/walk.scm 15 */
obj_t BgL_arg3176z00_1110;
{ /* ./Reduce/walk.scm 15 */
obj_t BgL_list3179z00_1111;
BgL_list3179z00_1111 = 
MAKE_PAIR(BgL_cportz00_1106, BNIL); 
BgL_arg3176z00_1110 = 
BGl_readz00zz__readerz00(BgL_list3179z00_1111); } 
{ /* ./Reduce/walk.scm 15 */
int BgL_auxz00_1131;
BgL_auxz00_1131 = 
(int)(BgL_iz00_1107); 
CNST_TABLE_SET(BgL_auxz00_1131, BgL_arg3176z00_1110); } } 
{ /* ./Reduce/walk.scm 15 */
int BgL_auxz00_1112;
BgL_auxz00_1112 = 
(int)(
(BgL_iz00_1107-((long)1))); 
{ 
long BgL_iz00_1136;
BgL_iz00_1136 = 
(long)(BgL_auxz00_1112); 
BgL_iz00_1107 = BgL_iz00_1136; 
goto BgL_loopz00_1108;} } } } } } } 
}



/* reduce-walk! */
BGL_EXPORTED_DEF obj_t BGl_reducezd2walkz12zc0zzreduce_walkz00(obj_t BgL_globalsz00_1)
{ AN_OBJECT;
{ /* ./Reduce/walk.scm 35 */
if(
CBOOL(BGl_za2optimzd2dataflowzf3za2z21zzengine_paramz00))
{ /* ./Reduce/walk.scm 36 */
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_list2706z00_671;
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_arg2709z00_673;
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_arg2713z00_675;
BgL_arg2713z00_675 = 
MAKE_PAIR(
BCHAR(((unsigned char)'\n')), BNIL); 
BgL_arg2709z00_673 = 
MAKE_PAIR(BGl_string3163z00zzreduce_walkz00, BgL_arg2713z00_675); } 
BgL_list2706z00_671 = 
MAKE_PAIR(BGl_string3164z00zzreduce_walkz00, BgL_arg2709z00_673); } 
BGl_verbosez00zztools_speekz00(
BINT(((long)1)), BgL_list2706z00_671); } 
BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = 
BINT(((long)0)); 
BGl_za2currentzd2passza2zd2zzengine_passz00 = BGl_string3163z00zzreduce_walkz00; 
{ 
obj_t BgL_hooksz00_676;obj_t BgL_hnamesz00_677;
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_arg2717z00_679;
BgL_arg2717z00_679 = BNIL; 
BgL_hooksz00_676 = BgL_arg2717z00_679; 
BgL_hnamesz00_677 = BNIL; 
BgL_loopz00_678:
{ /* ./Reduce/walk.scm 38 */
bool_t BgL_test2722z00_682;
BgL_test2722z00_682 = 
NULLP(BgL_hooksz00_676); 
if(BgL_test2722z00_682)
{ /* ./Reduce/walk.scm 38 */
CNST_TABLE_REF(((long)0)); }  else 
{ /* ./Reduce/walk.scm 38 */
bool_t BgL_test2723z00_683;
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_fun2738z00_689;
BgL_fun2738z00_689 = 
CAR(BgL_hooksz00_676); 
BgL_test2723z00_683 = 
CBOOL(
PROCEDURE_ENTRY(BgL_fun2738z00_689)(BgL_fun2738z00_689, BEOA)); } 
if(BgL_test2723z00_683)
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_arg2725z00_684;obj_t BgL_arg2726z00_685;
BgL_arg2725z00_684 = 
CDR(BgL_hooksz00_676); 
BgL_arg2726z00_685 = 
CDR(BgL_hnamesz00_677); 
{ 
obj_t BgL_hnamesz00_1158;obj_t BgL_hooksz00_1157;
BgL_hooksz00_1157 = BgL_arg2725z00_684; 
BgL_hnamesz00_1158 = BgL_arg2726z00_685; 
BgL_hnamesz00_677 = BgL_hnamesz00_1158; 
BgL_hooksz00_676 = BgL_hooksz00_1157; 
goto BgL_loopz00_678;} }  else 
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_arg2733z00_688;
BgL_arg2733z00_688 = 
CAR(BgL_hnamesz00_677); 
BGl_internalzd2errorzd2zztools_errorz00(BGl_string3163z00zzreduce_walkz00, BGl_string3165z00zzreduce_walkz00, BgL_arg2733z00_688); } } } } } 
BGl_reducezd2copyz12zc0zzreduce_copyz00(BgL_globalsz00_1); 
{ /* ./Reduce/walk.scm 40 */
bool_t BgL_test2742z00_690;
{ /* ./Reduce/walk.scm 40 */
long BgL_n1z00_1085;
BgL_n1z00_1085 = 
(long)CINT(BGl_za2optimza2z00zzengine_paramz00); 
BgL_test2742z00_690 = 
(BgL_n1z00_1085>=((long)2)); } 
if(BgL_test2742z00_690)
{ /* ./Reduce/walk.scm 40 */
BGl_reducezd2csez12zc0zzreduce_csez00(BgL_globalsz00_1); }  else 
{ /* ./Reduce/walk.scm 40 */BFALSE; } } 
BGl_reducezd2typezd2checkz12z12zzreduce_typecz00(BgL_globalsz00_1); 
BGl_reducezd2copyz12zc0zzreduce_copyz00(BgL_globalsz00_1); 
BGl_reducezd2conditionalz12zc0zzreduce_condz00(BgL_globalsz00_1); 
BGl_reducezd21occz12zc0zzreduce_1occz00(BgL_globalsz00_1); 
if(
CBOOL(BGl_za2optimzd2reducezd2betazf3za2zf3zzengine_paramz00))
{ /* ./Reduce/walk.scm 45 */
BGl_reducezd2betaz12zc0zzreduce_betaz00(BgL_globalsz00_1); }  else 
{ /* ./Reduce/walk.scm 45 */BFALSE; } 
{ /* ./Reduce/walk.scm 46 */
obj_t BgL_valuez00_691;
BgL_valuez00_691 = 
BGl_removezd2varzd2zzast_removez00(
CNST_TABLE_REF(((long)1)), BgL_globalsz00_1); 
{ /* ./Reduce/walk.scm 46 */
bool_t BgL_test2750z00_692;
{ /* ./Reduce/walk.scm 46 */
long BgL_n1z00_1087;
BgL_n1z00_1087 = 
(long)CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00); 
BgL_test2750z00_692 = 
(BgL_n1z00_1087>((long)0)); } 
if(BgL_test2750z00_692)
{ /* ./Reduce/walk.scm 46 */
{ /* ./Reduce/walk.scm 46 */
obj_t BgL_port2704z00_693;
BgL_port2704z00_693 = 
BGL_CURRENT_ERROR_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00, BgL_port2704z00_693); 
display_string(BGl_string3166z00zzreduce_walkz00, BgL_port2704z00_693); 
{ /* ./Reduce/walk.scm 46 */
obj_t BgL_arg2754z00_694;
{ /* ./Reduce/walk.scm 46 */
bool_t BgL_test2756z00_695;
{ /* ./Reduce/walk.scm 46 */
bool_t BgL_test2757z00_696;
{ /* ./Reduce/walk.scm 46 */
bool_t BgL_res3130z00_1095;
{ /* ./Reduce/walk.scm 46 */
obj_t BgL_objz00_1089;
BgL_objz00_1089 = BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00; 
{ /* ./Reduce/walk.scm 46 */
bool_t BgL_test1450z00_1090;
BgL_test1450z00_1090 = 
INTEGERP(BgL_objz00_1089); 
if(BgL_test1450z00_1090)
{ /* ./Reduce/walk.scm 46 */
BgL_res3130z00_1095 = ((bool_t)1); }  else 
{ /* ./Reduce/walk.scm 46 */
bool_t BgL_test1451z00_1091;
BgL_test1451z00_1091 = 
REALP(BgL_objz00_1089); 
if(BgL_test1451z00_1091)
{ /* ./Reduce/walk.scm 46 */
double BgL_arg1453z00_1092;
BgL_arg1453z00_1092 = 
BGl_roundflz00zz__r4_numbers_6_5_flonumz00(
REAL_TO_DOUBLE(BgL_objz00_1089)); 
BgL_res3130z00_1095 = 
(
REAL_TO_DOUBLE(BgL_objz00_1089)==BgL_arg1453z00_1092); }  else 
{ /* ./Reduce/walk.scm 46 */
BgL_res3130z00_1095 = ((bool_t)0); } } } } 
BgL_test2757z00_696 = BgL_res3130z00_1095; } 
if(BgL_test2757z00_696)
{ /* ./Reduce/walk.scm 46 */
BgL_test2756z00_695 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00, 
BINT(((long)1))); }  else 
{ /* ./Reduce/walk.scm 46 */
BgL_test2756z00_695 = ((bool_t)0); } } 
if(BgL_test2756z00_695)
{ /* ./Reduce/walk.scm 46 */
BgL_arg2754z00_694 = BGl_string3167z00zzreduce_walkz00; }  else 
{ /* ./Reduce/walk.scm 46 */
BgL_arg2754z00_694 = BGl_string3168z00zzreduce_walkz00; } } 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg2754z00_694, BgL_port2704z00_693); } 
display_string(BGl_string3169z00zzreduce_walkz00, BgL_port2704z00_693); 
WRITE_CHAR(((unsigned char)'\n'), BgL_port2704z00_693); } 
{ /* ./Reduce/walk.scm 46 */
obj_t BgL_list2764z00_697;
BgL_list2764z00_697 = 
MAKE_PAIR(
BINT(((long)-1)), BNIL); 
return 
BGl_exitz00zz__errorz00(BgL_list2764z00_697);} }  else 
{ 
obj_t BgL_hooksz00_698;obj_t BgL_hnamesz00_699;
{ /* ./Reduce/walk.scm 46 */
obj_t BgL_arg2767z00_701;
BgL_arg2767z00_701 = BNIL; 
BgL_hooksz00_698 = BgL_arg2767z00_701; 
BgL_hnamesz00_699 = BNIL; 
BgL_loopz00_700:
{ /* ./Reduce/walk.scm 46 */
bool_t BgL_test2772z00_704;
BgL_test2772z00_704 = 
NULLP(BgL_hooksz00_698); 
if(BgL_test2772z00_704)
{ /* ./Reduce/walk.scm 46 */
return BgL_valuez00_691;}  else 
{ /* ./Reduce/walk.scm 46 */
bool_t BgL_test2773z00_705;
{ /* ./Reduce/walk.scm 46 */
obj_t BgL_fun2787z00_710;
BgL_fun2787z00_710 = 
CAR(BgL_hooksz00_698); 
BgL_test2773z00_705 = 
CBOOL(
PROCEDURE_ENTRY(BgL_fun2787z00_710)(BgL_fun2787z00_710, BEOA)); } 
if(BgL_test2773z00_705)
{ /* ./Reduce/walk.scm 46 */
obj_t BgL_arg2775z00_706;obj_t BgL_arg2776z00_707;
BgL_arg2775z00_706 = 
CDR(BgL_hooksz00_698); 
BgL_arg2776z00_707 = 
CDR(BgL_hnamesz00_699); 
{ 
obj_t BgL_hnamesz00_1209;obj_t BgL_hooksz00_1208;
BgL_hooksz00_1208 = BgL_arg2775z00_706; 
BgL_hnamesz00_1209 = BgL_arg2776z00_707; 
BgL_hnamesz00_699 = BgL_hnamesz00_1209; 
BgL_hooksz00_698 = BgL_hooksz00_1208; 
goto BgL_loopz00_700;} }  else 
{ /* ./Reduce/walk.scm 46 */
obj_t BgL_arg2782z00_709;
BgL_arg2782z00_709 = 
CAR(BgL_hnamesz00_699); 
return 
BGl_internalzd2errorzd2zztools_errorz00(BGl_za2currentzd2passza2zd2zzengine_passz00, BGl_string3170z00zzreduce_walkz00, BgL_arg2782z00_709);} } } } } } } }  else 
{ /* ./Reduce/walk.scm 36 */
return BgL_globalsz00_1;} } 
}



/* _reduce-walk! */
obj_t BGl__reducezd2walkz12zc0zzreduce_walkz00(obj_t BgL_envz00_1104, obj_t BgL_globalsz00_1105)
{ AN_OBJECT;
{ /* ./Reduce/walk.scm 35 */
return 
BGl_reducezd2walkz12zc0zzreduce_walkz00(BgL_globalsz00_1105);} 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzreduce_walkz00()
{ AN_OBJECT;
{ /* ./Reduce/walk.scm 15 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzreduce_walkz00()
{ AN_OBJECT;
{ /* ./Reduce/walk.scm 15 */
BGl_modulezd2initializa7ationz75zztools_speekz00(((long)23537), 
BSTRING_TO_STRING(BGl_string3171z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zztools_errorz00(((long)25566), 
BSTRING_TO_STRING(BGl_string3171z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzengine_passz00(((long)10268), 
BSTRING_TO_STRING(BGl_string3171z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zztools_shapez00(((long)30833), 
BSTRING_TO_STRING(BGl_string3171z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)52606), 
BSTRING_TO_STRING(BGl_string3171z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19090), 
BSTRING_TO_STRING(BGl_string3171z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)44246), 
BSTRING_TO_STRING(BGl_string3171z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)50868), 
BSTRING_TO_STRING(BGl_string3171z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzreduce_copyz00(((long)31712), 
BSTRING_TO_STRING(BGl_string3171z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzreduce_csez00(((long)15139), 
BSTRING_TO_STRING(BGl_string3171z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzreduce_condz00(((long)24814), 
BSTRING_TO_STRING(BGl_string3171z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzreduce_typecz00(((long)31464), 
BSTRING_TO_STRING(BGl_string3171z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzreduce_1occz00(((long)64130), 
BSTRING_TO_STRING(BGl_string3171z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzreduce_betaz00(((long)32822), 
BSTRING_TO_STRING(BGl_string3171z00zzreduce_walkz00)); 
return 
BGl_modulezd2initializa7ationz75zzast_removez00(((long)12493), 
BSTRING_TO_STRING(BGl_string3171z00zzreduce_walkz00));} 
}

