;*=====================================================================*/
;*    serrano/prgm/project/bigloo/runtime/Eval/expdlet.scm             */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Mon Jan  4 17:10:13 1993                          */
;*    Last change :  Mon Apr 12 18:48:08 2004 (serrano)                */
;*    Copyright   :  2004 Manuel Serrano                               */
;*    -------------------------------------------------------------    */
;*    Let forms expansion                                              */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    Le module                                                        */
;*---------------------------------------------------------------------*/
(module __expander_let
   
   (import  __error
	    __bigloo
	    __tvector
	    __structure
	    __tvector
	    __bexit
	    
	    __r4_numbers_6_5
	    __r4_numbers_6_5_fixnum
	    __r4_numbers_6_5_flonum
	    __r4_characters_6_6
	    __r4_equivalence_6_2
	    __r4_booleans_6_1
	    __r4_symbols_6_4
	    __r4_strings_6_7
	    __r4_pairs_and_lists_6_3
	    __r4_input_6_10_2
	    __r4_control_features_6_9
	    __r4_vectors_6_8
	    __r4_ports_6_10_1
	    __r4_output_6_10_3
	    
	    __progn

	    __expander_define)
   
   (use     __type
	    __evenv)
   
   (export  (expand-eval-let    <expression> <expander>)
	    (expand-eval-let*   <expression> <expander>)
	    (expand-eval-letrec <expression> <expander>)
	    (expand-eval-labels <expression> <expander>)))

;*---------------------------------------------------------------------*/
;*    expand-eval-let ...                                              */
;*---------------------------------------------------------------------*/
(define (expand-eval-let x e)
   (let* ((e (internal-begin-expander e))
	  (res (match-case x
		  ((?- () . (and ?body (not ())))
		   (e (normalize-progn body) e))
		  ((?- (and (? symbol?) ?loop) ?bindings . (and ?body (not ())))
		   (if (not (or (null? bindings) (pair? bindings)))
		       (error 'let "Illegal form" x)
		       (e `(letrec ((,loop (lambda
						 ,(map
						   (lambda (b)
						      (if (pair? b)
							  (car b)
							  (error
							   'let
							   "Illegal `loop' form"
							   x)))
						   bindings)
					      ,(normalize-progn body))))
			      (,loop ,@(map (lambda (b)
					       (if (and (pair? b)
							(pair? (cdr b))
							(null? (cddr b)))
						   (cadr b)
						   (error 'let
							  "Illegal `loop' form"
							  x)))
					    bindings)))
			  e)))
		  ((?- (and (? pair?) ?bindings) . (and ?body (not ())))
		   (let loop ((bindings bindings)
			      (nbindings '()))
		      (cond
			 ((null? bindings)
			  `(let ,(reverse! nbindings)
			      ,(e (normalize-progn body) e)))
			 ((not (pair? (car bindings)))
			  (loop (cdr bindings)
				(cons (list (car bindings) #unspecified)
				      nbindings)))
			 ((not (pair? (cdr (car bindings))))
			  (error 'let "Illegal binding form" x))
			 (else
			  (loop (cdr bindings)
				(cons (list (caar bindings)
					    (e (normalize-progn (cdar bindings)) e))
				      nbindings))))))
		  (else
		   (error 'let "Illegal `let' form" x)))))
      (replace! x res)))
	   
;*---------------------------------------------------------------------*/
;*    expand-eval-let* ...                                             */
;*---------------------------------------------------------------------*/
(define (expand-eval-let* x e)
   (let* ((e (internal-begin-expander e))
	  (res (match-case x
		  ((?- () . (and ?body (not ())))
		   (e (normalize-progn body) e))
		  ((?- (and (? pair?) ?bindings) . (and ?body (not ())))
		   (let loop ((bindings bindings)
			      (nbindings '()))
		      (cond
			 ((null? bindings)
			  `(let* ,(reverse! nbindings)
			      ,(e (normalize-progn body) e)))
			 ((not (pair? (car bindings)))
			  (loop (cdr bindings)
				(cons (list (car bindings) #unspecified)
				      nbindings)))
			 ((not (pair? (cdar bindings)))
			  (error 'let* "Illegal bindings form" x))
			 (else
			  (loop (cdr bindings)
				(cons (list (caar bindings)
					    (e (normalize-progn (cdar bindings)) e))
				      nbindings))))))
		  (else
		   (error 'let* "Illegal form" x)))))
      (replace! x res)))
   
;*---------------------------------------------------------------------*/
;*    expand-eval-letrec ...                                           */
;*---------------------------------------------------------------------*/
(define (expand-eval-letrec x e)
   (let* ((e (internal-begin-expander e))
	  (res (match-case x
		  ((?- () . (and ?body (not ())))
		   (e (normalize-progn body) e))
		  ((?- (and (? pair?) ?bindings) . (and ?body (not ())))
		   (let loop ((bindings bindings)
			      (nbindings '()))
		      (cond
			 ((null? bindings)
			  (let* ((nbindings (reverse! nbindings))
				 (naux (map (lambda (x) (gensym)) nbindings))
				 (ebody (e (normalize-progn body) e)))
			     (if (every? (lambda (x)
					    (and (pair? x)
						 (pair? (cadr x))
						 (eq? (car (cadr x)) 'lambda)))
					 nbindings)
				 ;; all bindings bind lambda form, we
				 ;; can omit intermediate variables
				 `(letrec ,nbindings ,ebody)
				 `(let ,(map (lambda (b)
						(list (car b) #unspecified))
					     nbindings)
				     (let ,(map (lambda (n b)
						   (cons n (cdr b)))
						naux nbindings)
					(begin
					   ,@(map (lambda (n b)
						     `(set! ,(car b) ,n))
						  naux nbindings)
					   ,ebody))))))
			 ((not (pair? (car bindings)))
			  (loop (cdr bindings)
				(cons (list (car bindings) #unspecified)
				      nbindings)))
			 ((not (pair? (cdar bindings)))
			  (error 'letrec "Illegal binding form" x))
			 (else
			  (loop (cdr bindings)
				(cons (list (caar bindings)
					    (e (normalize-progn (cdar bindings)) e))
				      nbindings))))))
		  (else
		   (error 'letrec "Illegal form" x)))))
      (replace! x res)))

;*---------------------------------------------------------------------*/
;*    expand-eval-labels ...                                           */
;*---------------------------------------------------------------------*/
(define (expand-eval-labels x e)
   (let ((res (match-case x
		 ((?- () . (and ?body (not ())))
		  (e `((lambda () ,(normalize-progn body))) e))
		 ((?- ?bindings . (and ?body (not ())))
		  (let ((new (let loop ((bindings bindings))
				(cond
				   ((null? bindings)
				    '())
				   ((not (pair? bindings))
				    (error "expand-labels" "Illegal form" x))
				   (else
				    (match-case (car bindings)
				       ((?name ?args . ?lbody)
					(cons `(,name (lambda ,args ,@lbody))
					      (loop (cdr bindings))))
				       (else
					(error "expand-labels"
					       "Illegal form"
					       x))))))))
		     (e `(letrec ,new ,@body) e)))
		 (else
		  (error "expand-labels" "Illegal form" x)))))
      (replace! x res)))
