;*=====================================================================*/
;*    serrano/prgm/project/bigloo/runtime/Ieee/control5.scm            */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Fri Feb 27 14:11:26 1998                          */
;*    Last change :  Wed May  7 06:48:23 2003 (serrano)                */
;*    -------------------------------------------------------------    */
;*    An implementation of the R5RS multiple values.                   */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module __r5_control_features_6_4
    
   (import  __error)
   
   (use     __type
	    __bigloo
	    __tvector
	    __r4_equivalence_6_2
	    __r4_vectors_6_8
	    __r4_strings_6_7
	    __r4_numbers_6_5_fixnum
	    __r4_numbers_6_5_flonum
	    __r4_booleans_6_1
	    __r4_symbols_6_4
	    __r4_pairs_and_lists_6_3
	    __r4_control_features_6_9

	    __evenv)

   (extern  (macro %%get-mvalues-number::int ()
		   "BGL_MVALUES_NUMBER")
	    (macro %%set-mvalues-number!::int (::int)
		   "BGL_MVALUES_NUMBER_SET")
	    
	    (macro %%get-mvalues-val::obj (::int)
		   "BGL_MVALUES_VAL")
	    (macro %%set-mvalues-val!::obj (::int ::obj)
		   "BGL_MVALUES_VAL_SET"))
	    
   (java    (class foreign
	       (method static %%get-mvalues-number::int ()
		       "BGL_MVALUES_NUMBER")
	       (method static  %%set-mvalues-number!::int (::int)
		       "BGL_MVALUES_NUMBER_SET")
	       (method static %%get-mvalues-val::obj (::int)
		       "BGL_MVALUES_VAL")
	       (method static %%set-mvalues-val!::obj (::int ::obj)
		       "BGL_MVALUES_VAL_SET")))
	    
   (export  (values           . args)
	    (call-with-values ::procedure ::procedure)

	    (inline %get-mvalues-number::int)
	    (inline %set-mvalues-number!::int ::int)
	    
	    (inline %get-mvalues-val::obj ::int)
	    (inline %set-mvalues-val!::obj ::int ::obj)))

;*---------------------------------------------------------------------*/
;*    %get-mvalues-number ...                                          */
;*---------------------------------------------------------------------*/
(define-inline (%get-mvalues-number)
   (%%get-mvalues-number))

;*---------------------------------------------------------------------*/
;*    %set-mvalues-number ...                                          */
;*---------------------------------------------------------------------*/
(define-inline (%set-mvalues-number! n)
   (%%set-mvalues-number! n))

;*---------------------------------------------------------------------*/
;*    %get-mvalues-val ...                                             */
;*---------------------------------------------------------------------*/
(define-inline (%get-mvalues-val n)
   (%%get-mvalues-val n))

;*---------------------------------------------------------------------*/
;*    %set-mvalues-val ...                                             */
;*---------------------------------------------------------------------*/
(define-inline (%set-mvalues-val! n o)
   (%%set-mvalues-val! n o))

;*---------------------------------------------------------------------*/
;*    *values* ...                                                     */
;*---------------------------------------------------------------------*/
(define *res-number* 1)
(define *res1* #unspecified)
(define *res2* #unspecified)
(define *res3* #unspecified)

;*---------------------------------------------------------------------*/
;*    values ...                                                       */
;*    -------------------------------------------------------------    */
;*    Values with exactly one argument are not boxed.                  */
;*---------------------------------------------------------------------*/
(define (values . args)
   (let ((all-args args))
      (if (null? args)
	  (%set-mvalues-number! 0)
	  (if (null? (cdr args))
		  (begin
		     (%set-mvalues-number! 1)
		     (car args))
		  (let ((res0 (car args)))
		     (set! args (cdr args))
		     (%set-mvalues-val! 1 (car args))
		     (set! args (cdr args))
		     (if (pair? args)
			 (begin
			    (%set-mvalues-val! 2 (car args))
			    (set! args (cdr args))
			    (if (pair? args)
				(if (pair? (cdr args))
				    (begin
				       (%set-mvalues-number! -1)
				       all-args)
				    (begin
				       (%set-mvalues-val! 3 (car args))
				       (%set-mvalues-number! 4)
				       res0))
				(begin
				   (%set-mvalues-number! 3)
				   res0)))
			 (begin
			    (%set-mvalues-number! 2)
			    res0)))))))
	      
;*---------------------------------------------------------------------*/
;*    call-with-values ...                                             */
;*---------------------------------------------------------------------*/
(define (call-with-values producer consumer)
   (%set-mvalues-number! 1)
   (let ((res0 (producer)))
      (case (%get-mvalues-number)
	 ((-1)
	  (apply consumer res0))
	 ((0)
	  (consumer))
	 ((1)
	  (consumer res0))
	 ((2)
	  (consumer res0
		    (%get-mvalues-val 1)))
	 ((3)
	  (consumer res0
		    (%get-mvalues-val 1)
		    (%get-mvalues-val 2)))
	 ((4)
	  (consumer res0
		    (%get-mvalues-val 1)
		    (%get-mvalues-val 2)
		    (%get-mvalues-val 3)))
	 (else
	  (apply consumer res0)))))


