/*===========================================================================*/
/*   (Ast/shrinkify.scm)                                                     */
/*   Bigloo (2.6e)                                                           */
/*   Inria -- Sophia Antipolis (c)       Wed Jun 9 12:37:31 CEST 2004        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc-2.95 -lib-dir /users/serrano/prgm/project/bigloo/lib/2.6e -unsafev -no-hello -O2 -rm -unsafe -s -indent Ast/shrinkify.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_feffectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_readz00;
   obj_t BgL_writez00;
} *BgL_feffectz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_argszd2typezd2;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castzd2nullzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
} *BgL_castzd2nullzd2_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;


static obj_t BGl_methodzd2initzd2zzast_shrinkifyz00();
BGL_IMPORT obj_t open_input_string(obj_t);
BGL_IMPORT long BGl_classzd2numzd2zz__objectz00(obj_t);
extern obj_t BGl_letzd2funzd2zzast_nodez00;
static obj_t BGl_shrinkzd2nodez12zd2default2735z12zzast_shrinkifyz00(BgL_nodez00_bglt);
static obj_t BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(BgL_nodez00_bglt);
static obj_t BGl_shrinkzd2nodez12zd2select2762z12zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_shrinkzd2nodez12zd2letzd2fun2770zc0zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(BgL_variablez00_bglt);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t);
static obj_t BGl_shrinkzd2nodez12zd2sequence2744z12zzast_shrinkifyz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
extern obj_t BGl_letzd2varzd2zzast_nodez00;
extern obj_t BGl_kwotez00zzast_nodez00;
static obj_t BGl_shrinkzd2nodez12zd2letzd2var2772zc0zzast_shrinkifyz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
static obj_t BGl_shrinkzd2nodez12zd2var2740z12zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_shrinkzd2nodez12zd2setq2756z12zzast_shrinkifyz00(obj_t, obj_t);
extern obj_t BGl_castz00zzast_nodez00;
extern obj_t BGl_boxzd2refzd2zzast_nodez00;
extern obj_t BGl_varz00zzast_nodez00;
static obj_t BGl_cnstzd2initzd2zzast_shrinkifyz00();
extern obj_t BGl_atomz00zzast_nodez00;
extern obj_t BGl_failz00zzast_nodez00;
extern obj_t BGl_funcallz00zzast_nodez00;
static obj_t BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00();
BGL_EXPORTED_DECL obj_t BGl_shrinkifyz12z12zzast_shrinkifyz00(obj_t);
extern obj_t BGl_makezd2boxzd2zzast_nodez00;
static obj_t BGl__shrinkzd2nodez12zd2default2735z12zzast_shrinkifyz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
static obj_t BGl_shrinkzd2nodez12zd2atom2738z12zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_shrinkzd2nodez12zd2appzd2ly2748zc0zzast_shrinkifyz00(obj_t, obj_t);
extern obj_t BGl_selectz00zzast_nodez00;
static obj_t BGl_toplevelzd2initzd2zzast_shrinkifyz00();
extern obj_t BGl_appzd2lyzd2zzast_nodez00;
extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
static obj_t BGl_shrinkzd2nodez12zd2makezd2box2764zc0zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_shrinkzd2variablez12zd2default2733z12zzast_shrinkifyz00(BgL_variablez00_bglt);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_shrinkifyz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
static obj_t BGl_shrinkzd2nodez12zd2extern2752z12zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_shrinkzd2nodez12zd2jumpzd2exzd2it2776z12zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_shrinkzd2nodez12zd2boxzd2ref2766zc0zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl__shrinkzd2nodez123679zc0zzast_shrinkifyz00(obj_t, obj_t);
extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
static obj_t BGl__shrinkifyz12z12zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_shrinkzd2nodez12zd2fail2760z12zzast_shrinkifyz00(obj_t, obj_t);
extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t);
extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
static obj_t BGl_shrinkzd2nodez12zd2app2746z12zzast_shrinkifyz00(obj_t, obj_t);
extern obj_t BGl_externz00zzast_nodez00;
extern obj_t BGl_conditionalz00zzast_nodez00;
extern obj_t BGl_sequencez00zzast_nodez00;
static obj_t BGl__shrinkzd2variablez12zd2default2733z12zzast_shrinkifyz00(obj_t, obj_t);
extern obj_t BGl_appz00zzast_nodez00;
static obj_t BGl_shrinkzd2nodez12zd2conditional2758z12zzast_shrinkifyz00(obj_t, obj_t);
static bool_t BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(obj_t);
static obj_t BGl_shrinkzd2nodez12zd2funcall2750z12zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzast_shrinkifyz00 = BUNSPEC;
static obj_t BGl_shrinkzd2nodez12zd2kwote2742z12zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_shrinkzd2nodez12zd2setzd2exzd2it2774z12zzast_shrinkifyz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00();
static obj_t BGl__shrinkzd2variablez123677zc0zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_shrinkzd2nodez12zd2boxzd2setz122768zd2zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_shrinkzd2nodez12zd2cast2754z12zzast_shrinkifyz00(obj_t, obj_t);
extern obj_t BGl_setqz00zzast_nodez00;
static obj_t __cnst[ 1 ] ;


DEFINE_STATIC_PROCEDURE( BGl_shrinkzd2variablez12zd2default2733zd2envzc0zzast_shrinkifyz00, BgL_bgl__shrinkza7d2variableza712za7d2default2733za712za7za7ast_shrinkifyza7004280za7, BGl__shrinkzd2variablez12zd2default2733z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_GENERIC( BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_bgl__shrinkza7d2nodeza7123679za7c0za7za7ast_shrinkifyza7004281z00, BGl__shrinkzd2nodez123679zc0zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4230z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2var2740za712za7za7ast_shrinkifyza7004282za7, BGl_shrinkzd2nodez12zd2var2740z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4229z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2atom2738za712za7za7ast_shrinkifyza7004283za7, BGl_shrinkzd2nodez12zd2atom2738z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4231z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2kwote2742za712za7za7ast_shrinkifyza7004284za7, BGl_shrinkzd2nodez12zd2kwote2742z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4232z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2sequence2744za712za7za7ast_shrinkifyza7004285za7, BGl_shrinkzd2nodez12zd2sequence2744z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4233z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2app2746za712za7za7ast_shrinkifyza7004286za7, BGl_shrinkzd2nodez12zd2app2746z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4234z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2appza7d2ly2748za7c0za7za7ast_shrinkifyza7004287z00, BGl_shrinkzd2nodez12zd2appzd2ly2748zc0zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4235z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2funcall2750za712za7za7ast_shrinkifyza7004288za7, BGl_shrinkzd2nodez12zd2funcall2750z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4236z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2extern2752za712za7za7ast_shrinkifyza7004289za7, BGl_shrinkzd2nodez12zd2extern2752z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4237z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2cast2754za712za7za7ast_shrinkifyza7004290za7, BGl_shrinkzd2nodez12zd2cast2754z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4238z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2setq2756za712za7za7ast_shrinkifyza7004291za7, BGl_shrinkzd2nodez12zd2setq2756z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4240z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2fail2760za712za7za7ast_shrinkifyza7004292za7, BGl_shrinkzd2nodez12zd2fail2760z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4239z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2conditional2758za712za7za7ast_shrinkifyza7004293za7, BGl_shrinkzd2nodez12zd2conditional2758z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4241z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2select2762za712za7za7ast_shrinkifyza7004294za7, BGl_shrinkzd2nodez12zd2select2762z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4242z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2makeza7d2box2764za7c0za7za7ast_shrinkifyza7004295z00, BGl_shrinkzd2nodez12zd2makezd2box2764zc0zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4243z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2boxza7d2ref2766za7c0za7za7ast_shrinkifyza7004296z00, BGl_shrinkzd2nodez12zd2boxzd2ref2766zc0zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4244z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2boxza7d2setza7122768za7d2za7za7ast_shrinkifyza7004297za7, BGl_shrinkzd2nodez12zd2boxzd2setz122768zd2zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4245z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2letza7d2fun2770za7c0za7za7ast_shrinkifyza7004298z00, BGl_shrinkzd2nodez12zd2letzd2fun2770zc0zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4246z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2letza7d2var2772za7c0za7za7ast_shrinkifyza7004299z00, BGl_shrinkzd2nodez12zd2letzd2var2772zc0zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4247z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2setza7d2exza7d2it2774za712za7za7ast_shrinkifyza7004300za7, BGl_shrinkzd2nodez12zd2setzd2exzd2it2774z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4248z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2jumpza7d2exza7d2it2776za712za7za7ast_shrinkifyza7004301za7, BGl_shrinkzd2nodez12zd2jumpzd2exzd2it2776z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_shrinkifyz12zd2envzc0zzast_shrinkifyz00, BgL_bgl__shrinkifyza712za712za7za7ast_shrinkifyza7004302za7, BGl__shrinkifyz12z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STRING( BGl_string4251z00zzast_shrinkifyz00, BgL_bgl_string4251za700za7za7ast_shrinkifyza7004303z00, "shrink-node!-default2735 ", 25 );
DEFINE_STRING( BGl_string4250z00zzast_shrinkifyz00, BgL_bgl_string4250za700za7za7ast_shrinkifyza7004304z00, "ast_shrinkify", 13 );
DEFINE_STRING( BGl_string4249z00zzast_shrinkifyz00, BgL_bgl_string4249za700za7za7ast_shrinkifyza7004305z00, "No method for this object", 25 );
DEFINE_STATIC_PROCEDURE( BGl_shrinkzd2nodez12zd2default2735zd2envzc0zzast_shrinkifyz00, BgL_bgl__shrinkza7d2nodeza712za7d2default2735za712za7za7ast_shrinkifyza7004306za7, BGl__shrinkzd2nodez12zd2default2735z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_GENERIC( BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, BgL_bgl__shrinkza7d2variableza7123677za7c0za7za7ast_shrinkifyza7004307z00, BGl__shrinkzd2variablez123677zc0zzast_shrinkifyz00, 0L, 1 );



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_shrinkifyz00(long BgL_checksumz00_2497, char * BgL_fromz00_2498)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzast_shrinkifyz00))
{ 
BGl_requirezd2initializa7ationz75zzast_shrinkifyz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00(); 
BGl_cnstzd2initzd2zzast_shrinkifyz00(); 
BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00(); 
BGl_methodzd2initzd2zzast_shrinkifyz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00()
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "ast_shrinkify"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "ast_shrinkify"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzast_shrinkifyz00()
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
{ /* ./Ast/shrinkify.scm 15 */
obj_t BgL_cportz00_2484;
BgL_cportz00_2484 = 
open_input_string(BGl_string4251z00zzast_shrinkifyz00); 
{ 
long BgL_iz00_2485;
BgL_iz00_2485 = ((long)0); 
BgL_loopz00_2486:
{ /* ./Ast/shrinkify.scm 15 */
bool_t BgL_test4253z00_2487;
BgL_test4253z00_2487 = 
(BgL_iz00_2485==((long)-1)); 
if(BgL_test4253z00_2487)
{ /* ./Ast/shrinkify.scm 15 */
return BUNSPEC;}  else 
{ /* ./Ast/shrinkify.scm 15 */
{ /* ./Ast/shrinkify.scm 15 */
obj_t BgL_arg4255z00_2488;
{ /* ./Ast/shrinkify.scm 15 */
obj_t BgL_list4258z00_2489;
BgL_list4258z00_2489 = 
MAKE_PAIR(BgL_cportz00_2484, BNIL); 
BgL_arg4255z00_2488 = 
BGl_readz00zz__readerz00(BgL_list4258z00_2489); } 
{ /* ./Ast/shrinkify.scm 15 */
int BgL_auxz00_2513;
BgL_auxz00_2513 = 
(int)(BgL_iz00_2485); 
CNST_TABLE_SET(BgL_auxz00_2513, BgL_arg4255z00_2488); } } 
{ /* ./Ast/shrinkify.scm 15 */
int BgL_auxz00_2490;
BgL_auxz00_2490 = 
(int)(
(BgL_iz00_2485-((long)1))); 
{ 
long BgL_iz00_2518;
BgL_iz00_2518 = 
(long)(BgL_auxz00_2490); 
BgL_iz00_2485 = BgL_iz00_2518; 
goto BgL_loopz00_2486;} } } } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzast_shrinkifyz00()
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
return BUNSPEC;} 
}



/* shrinkify! */
BGL_EXPORTED_DEF obj_t BGl_shrinkifyz12z12zzast_shrinkifyz00(obj_t BgL_globalsz00_1)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 25 */
BGl_forzd2eachzd2globalz12z12zzast_envz00(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00); 
{ 
obj_t BgL_l2704z00_696;
BgL_l2704z00_696 = BgL_globalsz00_1; 
BgL_forzd2each2705zd2_697:
{ /* ./Ast/shrinkify.scm 27 */
bool_t BgL_test2779z00_698;
BgL_test2779z00_698 = 
PAIRP(BgL_l2704z00_696); 
if(BgL_test2779z00_698)
{ /* ./Ast/shrinkify.scm 27 */
{ /* ./Ast/shrinkify.scm 28 */
obj_t BgL_globalz00_699;
BgL_globalz00_699 = 
CAR(BgL_l2704z00_696); 
{ /* ./Ast/shrinkify.scm 28 */
BgL_valuez00_bglt BgL_sfunz00_700;
{ /* ./Ast/shrinkify.scm 28 */
BgL_variablez00_bglt BgL_obj1100z00_1291;
BgL_obj1100z00_1291 = 
(BgL_variablez00_bglt)(BgL_globalz00_699); 
BgL_sfunz00_700 = 
(((BgL_variablez00_bglt)CREF(BgL_obj1100z00_1291))->BgL_valuez00); } 
{ 
obj_t BgL_l2706z00_701;
{ /* ./Ast/shrinkify.scm 29 */
obj_t BgL_arg2781z00_703;
{ /* ./Ast/shrinkify.scm 29 */
BgL_sfunz00_bglt BgL_obj1367z00_1292;
BgL_obj1367z00_1292 = 
(BgL_sfunz00_bglt)(BgL_sfunz00_700); 
BgL_arg2781z00_703 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1367z00_1292))->BgL_argsz00); } 
BgL_l2706z00_701 = BgL_arg2781z00_703; 
BgL_forzd2each2707zd2_702:
{ /* ./Ast/shrinkify.scm 29 */
bool_t BgL_test2784z00_704;
BgL_test2784z00_704 = 
PAIRP(BgL_l2706z00_701); 
if(BgL_test2784z00_704)
{ /* ./Ast/shrinkify.scm 29 */
{ /* ./Ast/shrinkify.scm 29 */
obj_t BgL_arg2786z00_705;
BgL_arg2786z00_705 = 
CAR(BgL_l2706z00_701); 
{ /* ./Ast/shrinkify.scm 29 */
BgL_variablez00_bglt BgL_variablez00_1295;
BgL_variablez00_1295 = 
(BgL_variablez00_bglt)(BgL_arg2786z00_705); 
{ /* ./Ast/shrinkify.scm 29 */
obj_t BgL_method2734z00_1296;
{ /* ./Ast/shrinkify.scm 29 */
BgL_objectz00_bglt BgL_objz00_1297;
BgL_objz00_1297 = 
(BgL_objectz00_bglt)(BgL_variablez00_1295); 
{ /* ./Ast/shrinkify.scm 29 */
long BgL_objzd2classzd2numz00_1298;
BgL_objzd2classzd2numz00_1298 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1297); 
{ /* ./Ast/shrinkify.scm 29 */
obj_t BgL_arg2096z00_1299;
BgL_arg2096z00_1299 = 
PROCEDURE_REF(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 29 */
int BgL_offsetz00_1302;
BgL_offsetz00_1302 = 
(int)(BgL_objzd2classzd2numz00_1298); 
{ /* ./Ast/shrinkify.scm 29 */
long BgL_offsetz00_1303;
BgL_offsetz00_1303 = 
(
(long)(BgL_offsetz00_1302)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 29 */
long BgL_modz00_1304;
{ /* ./Ast/shrinkify.scm 29 */
int BgL_arg2107z00_1305;
BgL_arg2107z00_1305 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 29 */
long BgL_n2z00_1313;
BgL_n2z00_1313 = 
(long)(BgL_arg2107z00_1305); 
BgL_modz00_1304 = 
(BgL_offsetz00_1303/BgL_n2z00_1313); } } 
{ /* ./Ast/shrinkify.scm 29 */
long BgL_restz00_1306;
{ /* ./Ast/shrinkify.scm 29 */
int BgL_arg2103z00_1307;
BgL_arg2103z00_1307 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 29 */
long BgL_n2z00_1316;
BgL_n2z00_1316 = 
(long)(BgL_arg2103z00_1307); 
BgL_restz00_1306 = 
(BgL_offsetz00_1303%BgL_n2z00_1316); } } 
{ /* ./Ast/shrinkify.scm 29 */

{ /* ./Ast/shrinkify.scm 29 */
obj_t BgL_bucketz00_1308;
{ /* ./Ast/shrinkify.scm 29 */
int BgL_kz00_1318;
BgL_kz00_1318 = 
(int)(BgL_modz00_1304); 
BgL_bucketz00_1308 = 
VECTOR_REF(BgL_arg2096z00_1299,BgL_kz00_1318); } 
{ /* ./Ast/shrinkify.scm 29 */
int BgL_kz00_1320;
BgL_kz00_1320 = 
(int)(BgL_restz00_1306); 
BgL_method2734z00_1296 = 
VECTOR_REF(BgL_bucketz00_1308,BgL_kz00_1320); } } } } } } } } } } 
PROCEDURE_ENTRY(BgL_method2734z00_1296)(BgL_method2734z00_1296, 
(obj_t)(BgL_variablez00_1295), BEOA); } } } 
{ /* ./Ast/shrinkify.scm 29 */
obj_t BgL_arg2790z00_706;
BgL_arg2790z00_706 = 
CDR(BgL_l2706z00_701); 
{ 
obj_t BgL_l2706z00_2553;
BgL_l2706z00_2553 = BgL_arg2790z00_706; 
BgL_l2706z00_701 = BgL_l2706z00_2553; 
goto BgL_forzd2each2707zd2_702;} } }  else 
{ /* ./Ast/shrinkify.scm 29 */((bool_t)1); } } } } 
{ /* ./Ast/shrinkify.scm 30 */
obj_t BgL_arg2795z00_707;
{ /* ./Ast/shrinkify.scm 30 */
BgL_sfunz00_bglt BgL_obj1370z00_1323;
{ /* ./Ast/shrinkify.scm 30 */
BgL_valuez00_bglt BgL_auxz00_2554;
{ /* ./Ast/shrinkify.scm 30 */
BgL_variablez00_bglt BgL_obj1100z00_1322;
BgL_obj1100z00_1322 = 
(BgL_variablez00_bglt)(BgL_globalz00_699); 
BgL_auxz00_2554 = 
(((BgL_variablez00_bglt)CREF(BgL_obj1100z00_1322))->BgL_valuez00); } 
BgL_obj1370z00_1323 = 
(BgL_sfunz00_bglt)(BgL_auxz00_2554); } 
BgL_arg2795z00_707 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1370z00_1323))->BgL_bodyz00); } 
{ /* ./Ast/shrinkify.scm 30 */
obj_t BgL_res3575z00_1350;
{ /* ./Ast/shrinkify.scm 30 */
BgL_nodez00_bglt BgL_nodez00_1324;
BgL_nodez00_1324 = 
(BgL_nodez00_bglt)(BgL_arg2795z00_707); 
{ /* ./Ast/shrinkify.scm 30 */
obj_t BgL_method2736z00_1325;
{ /* ./Ast/shrinkify.scm 30 */
BgL_objectz00_bglt BgL_objz00_1326;
BgL_objz00_1326 = 
(BgL_objectz00_bglt)(BgL_nodez00_1324); 
{ /* ./Ast/shrinkify.scm 30 */
long BgL_objzd2classzd2numz00_1327;
BgL_objzd2classzd2numz00_1327 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1326); 
{ /* ./Ast/shrinkify.scm 30 */
obj_t BgL_arg2096z00_1328;
BgL_arg2096z00_1328 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 30 */
int BgL_offsetz00_1331;
BgL_offsetz00_1331 = 
(int)(BgL_objzd2classzd2numz00_1327); 
{ /* ./Ast/shrinkify.scm 30 */
long BgL_offsetz00_1332;
BgL_offsetz00_1332 = 
(
(long)(BgL_offsetz00_1331)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 30 */
long BgL_modz00_1333;
{ /* ./Ast/shrinkify.scm 30 */
int BgL_arg2107z00_1334;
BgL_arg2107z00_1334 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 30 */
long BgL_n2z00_1342;
BgL_n2z00_1342 = 
(long)(BgL_arg2107z00_1334); 
BgL_modz00_1333 = 
(BgL_offsetz00_1332/BgL_n2z00_1342); } } 
{ /* ./Ast/shrinkify.scm 30 */
long BgL_restz00_1335;
{ /* ./Ast/shrinkify.scm 30 */
int BgL_arg2103z00_1336;
BgL_arg2103z00_1336 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 30 */
long BgL_n2z00_1345;
BgL_n2z00_1345 = 
(long)(BgL_arg2103z00_1336); 
BgL_restz00_1335 = 
(BgL_offsetz00_1332%BgL_n2z00_1345); } } 
{ /* ./Ast/shrinkify.scm 30 */

{ /* ./Ast/shrinkify.scm 30 */
obj_t BgL_bucketz00_1337;
{ /* ./Ast/shrinkify.scm 30 */
int BgL_kz00_1347;
BgL_kz00_1347 = 
(int)(BgL_modz00_1333); 
BgL_bucketz00_1337 = 
VECTOR_REF(BgL_arg2096z00_1328,BgL_kz00_1347); } 
{ /* ./Ast/shrinkify.scm 30 */
int BgL_kz00_1349;
BgL_kz00_1349 = 
(int)(BgL_restz00_1335); 
BgL_method2736z00_1325 = 
VECTOR_REF(BgL_bucketz00_1337,BgL_kz00_1349); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 30 */
obj_t BgL_xz00_2455;
BgL_xz00_2455 = 
PROCEDURE_ENTRY(BgL_method2736z00_1325)(BgL_method2736z00_1325, 
(obj_t)(BgL_nodez00_1324), BEOA); 
BgL_res3575z00_1350 = BUNSPEC; } } } BgL_res3575z00_1350; } } } } 
{ /* ./Ast/shrinkify.scm 27 */
obj_t BgL_arg2804z00_709;
BgL_arg2804z00_709 = 
CDR(BgL_l2704z00_696); 
{ 
obj_t BgL_l2704z00_2581;
BgL_l2704z00_2581 = BgL_arg2804z00_709; 
BgL_l2704z00_696 = BgL_l2704z00_2581; 
goto BgL_forzd2each2705zd2_697;} } }  else 
{ /* ./Ast/shrinkify.scm 27 */((bool_t)1); } } } 
return BgL_globalsz00_1;} 
}



/* _shrinkify! */
obj_t BGl__shrinkifyz12z12zzast_shrinkifyz00(obj_t BgL_envz00_2385, obj_t BgL_globalsz00_2386)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 25 */
return 
BGl_shrinkifyz12z12zzast_shrinkifyz00(BgL_globalsz00_2386);} 
}



/* shrink-node*! */
bool_t BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(obj_t BgL_nodeza2za2_26)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 221 */
{ 
obj_t BgL_l2731z00_710;
BgL_l2731z00_710 = BgL_nodeza2za2_26; 
BgL_forzd2each2732zd2_711:
{ /* ./Ast/shrinkify.scm 222 */
bool_t BgL_test2809z00_712;
BgL_test2809z00_712 = 
PAIRP(BgL_l2731z00_710); 
if(BgL_test2809z00_712)
{ /* ./Ast/shrinkify.scm 222 */
{ /* ./Ast/shrinkify.scm 222 */
obj_t BgL_arg2811z00_713;
BgL_arg2811z00_713 = 
CAR(BgL_l2731z00_710); 
{ /* ./Ast/shrinkify.scm 222 */
obj_t BgL_res3578z00_1380;
{ /* ./Ast/shrinkify.scm 222 */
BgL_nodez00_bglt BgL_nodez00_1354;
BgL_nodez00_1354 = 
(BgL_nodez00_bglt)(BgL_arg2811z00_713); 
{ /* ./Ast/shrinkify.scm 222 */
obj_t BgL_method2736z00_1355;
{ /* ./Ast/shrinkify.scm 222 */
BgL_objectz00_bglt BgL_objz00_1356;
BgL_objz00_1356 = 
(BgL_objectz00_bglt)(BgL_nodez00_1354); 
{ /* ./Ast/shrinkify.scm 222 */
long BgL_objzd2classzd2numz00_1357;
BgL_objzd2classzd2numz00_1357 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1356); 
{ /* ./Ast/shrinkify.scm 222 */
obj_t BgL_arg2096z00_1358;
BgL_arg2096z00_1358 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 222 */
int BgL_offsetz00_1361;
BgL_offsetz00_1361 = 
(int)(BgL_objzd2classzd2numz00_1357); 
{ /* ./Ast/shrinkify.scm 222 */
long BgL_offsetz00_1362;
BgL_offsetz00_1362 = 
(
(long)(BgL_offsetz00_1361)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 222 */
long BgL_modz00_1363;
{ /* ./Ast/shrinkify.scm 222 */
int BgL_arg2107z00_1364;
BgL_arg2107z00_1364 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 222 */
long BgL_n2z00_1372;
BgL_n2z00_1372 = 
(long)(BgL_arg2107z00_1364); 
BgL_modz00_1363 = 
(BgL_offsetz00_1362/BgL_n2z00_1372); } } 
{ /* ./Ast/shrinkify.scm 222 */
long BgL_restz00_1365;
{ /* ./Ast/shrinkify.scm 222 */
int BgL_arg2103z00_1366;
BgL_arg2103z00_1366 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 222 */
long BgL_n2z00_1375;
BgL_n2z00_1375 = 
(long)(BgL_arg2103z00_1366); 
BgL_restz00_1365 = 
(BgL_offsetz00_1362%BgL_n2z00_1375); } } 
{ /* ./Ast/shrinkify.scm 222 */

{ /* ./Ast/shrinkify.scm 222 */
obj_t BgL_bucketz00_1367;
{ /* ./Ast/shrinkify.scm 222 */
int BgL_kz00_1377;
BgL_kz00_1377 = 
(int)(BgL_modz00_1363); 
BgL_bucketz00_1367 = 
VECTOR_REF(BgL_arg2096z00_1358,BgL_kz00_1377); } 
{ /* ./Ast/shrinkify.scm 222 */
int BgL_kz00_1379;
BgL_kz00_1379 = 
(int)(BgL_restz00_1365); 
BgL_method2736z00_1355 = 
VECTOR_REF(BgL_bucketz00_1367,BgL_kz00_1379); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 222 */
obj_t BgL_xz00_2456;
BgL_xz00_2456 = 
PROCEDURE_ENTRY(BgL_method2736z00_1355)(BgL_method2736z00_1355, 
(obj_t)(BgL_nodez00_1354), BEOA); 
BgL_res3578z00_1380 = BUNSPEC; } } } BgL_res3578z00_1380; } } 
{ /* ./Ast/shrinkify.scm 222 */
obj_t BgL_arg2815z00_714;
BgL_arg2815z00_714 = 
CDR(BgL_l2731z00_710); 
{ 
obj_t BgL_l2731z00_2608;
BgL_l2731z00_2608 = BgL_arg2815z00_714; 
BgL_l2731z00_710 = BgL_l2731z00_2608; 
goto BgL_forzd2each2732zd2_711;} } }  else 
{ /* ./Ast/shrinkify.scm 222 */
return ((bool_t)1);} } } } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzast_shrinkifyz00()
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
BGl_addzd2genericz12zc0zz__objectz00(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, BGl_shrinkzd2variablez12zd2default2733zd2envzc0zzast_shrinkifyz00); 
BGl_addzd2genericz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_shrinkzd2nodez12zd2default2735zd2envzc0zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_atomz00zzast_nodez00, BGl_proc4229z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_varz00zzast_nodez00, BGl_proc4230z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_kwotez00zzast_nodez00, BGl_proc4231z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_sequencez00zzast_nodez00, BGl_proc4232z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_appz00zzast_nodez00, BGl_proc4233z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_appzd2lyzd2zzast_nodez00, BGl_proc4234z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_funcallz00zzast_nodez00, BGl_proc4235z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_externz00zzast_nodez00, BGl_proc4236z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_castz00zzast_nodez00, BGl_proc4237z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_setqz00zzast_nodez00, BGl_proc4238z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_conditionalz00zzast_nodez00, BGl_proc4239z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_failz00zzast_nodez00, BGl_proc4240z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_selectz00zzast_nodez00, BGl_proc4241z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_makezd2boxzd2zzast_nodez00, BGl_proc4242z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_boxzd2refzd2zzast_nodez00, BGl_proc4243z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc4244z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_letzd2funzd2zzast_nodez00, BGl_proc4245z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_letzd2varzd2zzast_nodez00, BGl_proc4246z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc4247z00zzast_shrinkifyz00); 
return 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc4248z00zzast_shrinkifyz00);} 
}



/* shrink-node!-jump-ex-it2776 */
obj_t BGl_shrinkzd2nodez12zd2jumpzd2exzd2it2776z12zzast_shrinkifyz00(obj_t BgL_envz00_2411, obj_t BgL_nodez00_2412)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 213 */
{ 
BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1269;
BgL_nodez00_1269 = 
(BgL_jumpzd2exzd2itz00_bglt)(BgL_nodez00_2412); 
{ /* ./Ast/shrinkify.scm 214 */
BgL_nodez00_bglt BgL_arg3519z00_1272;
BgL_arg3519z00_1272 = 
(((BgL_jumpzd2exzd2itz00_bglt)CREF(BgL_nodez00_1269))->BgL_exitz00); 
{ /* ./Ast/shrinkify.scm 214 */
obj_t BgL_res3666z00_2275;
{ /* ./Ast/shrinkify.scm 214 */
obj_t BgL_method2736z00_2250;
{ /* ./Ast/shrinkify.scm 214 */
BgL_objectz00_bglt BgL_objz00_2251;
BgL_objz00_2251 = 
(BgL_objectz00_bglt)(BgL_arg3519z00_1272); 
{ /* ./Ast/shrinkify.scm 214 */
long BgL_objzd2classzd2numz00_2252;
BgL_objzd2classzd2numz00_2252 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2251); 
{ /* ./Ast/shrinkify.scm 214 */
obj_t BgL_arg2096z00_2253;
BgL_arg2096z00_2253 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 214 */
int BgL_offsetz00_2256;
BgL_offsetz00_2256 = 
(int)(BgL_objzd2classzd2numz00_2252); 
{ /* ./Ast/shrinkify.scm 214 */
long BgL_offsetz00_2257;
BgL_offsetz00_2257 = 
(
(long)(BgL_offsetz00_2256)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 214 */
long BgL_modz00_2258;
{ /* ./Ast/shrinkify.scm 214 */
int BgL_arg2107z00_2259;
BgL_arg2107z00_2259 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 214 */
long BgL_n2z00_2267;
BgL_n2z00_2267 = 
(long)(BgL_arg2107z00_2259); 
BgL_modz00_2258 = 
(BgL_offsetz00_2257/BgL_n2z00_2267); } } 
{ /* ./Ast/shrinkify.scm 214 */
long BgL_restz00_2260;
{ /* ./Ast/shrinkify.scm 214 */
int BgL_arg2103z00_2261;
BgL_arg2103z00_2261 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 214 */
long BgL_n2z00_2270;
BgL_n2z00_2270 = 
(long)(BgL_arg2103z00_2261); 
BgL_restz00_2260 = 
(BgL_offsetz00_2257%BgL_n2z00_2270); } } 
{ /* ./Ast/shrinkify.scm 214 */

{ /* ./Ast/shrinkify.scm 214 */
obj_t BgL_bucketz00_2262;
{ /* ./Ast/shrinkify.scm 214 */
int BgL_kz00_2272;
BgL_kz00_2272 = 
(int)(BgL_modz00_2258); 
BgL_bucketz00_2262 = 
VECTOR_REF(BgL_arg2096z00_2253,BgL_kz00_2272); } 
{ /* ./Ast/shrinkify.scm 214 */
int BgL_kz00_2274;
BgL_kz00_2274 = 
(int)(BgL_restz00_2260); 
BgL_method2736z00_2250 = 
VECTOR_REF(BgL_bucketz00_2262,BgL_kz00_2274); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 214 */
obj_t BgL_xz00_2457;
BgL_xz00_2457 = 
PROCEDURE_ENTRY(BgL_method2736z00_2250)(BgL_method2736z00_2250, 
(obj_t)(BgL_arg3519z00_1272), BEOA); 
BgL_res3666z00_2275 = BUNSPEC; } } BgL_res3666z00_2275; } } 
{ /* ./Ast/shrinkify.scm 215 */
BgL_nodez00_bglt BgL_arg3524z00_1273;
BgL_arg3524z00_1273 = 
(((BgL_jumpzd2exzd2itz00_bglt)CREF(BgL_nodez00_1269))->BgL_valuez00); 
{ /* ./Ast/shrinkify.scm 215 */
obj_t BgL_res3669z00_2303;
{ /* ./Ast/shrinkify.scm 215 */
obj_t BgL_method2736z00_2278;
{ /* ./Ast/shrinkify.scm 215 */
BgL_objectz00_bglt BgL_objz00_2279;
BgL_objz00_2279 = 
(BgL_objectz00_bglt)(BgL_arg3524z00_1273); 
{ /* ./Ast/shrinkify.scm 215 */
long BgL_objzd2classzd2numz00_2280;
BgL_objzd2classzd2numz00_2280 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2279); 
{ /* ./Ast/shrinkify.scm 215 */
obj_t BgL_arg2096z00_2281;
BgL_arg2096z00_2281 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 215 */
int BgL_offsetz00_2284;
BgL_offsetz00_2284 = 
(int)(BgL_objzd2classzd2numz00_2280); 
{ /* ./Ast/shrinkify.scm 215 */
long BgL_offsetz00_2285;
BgL_offsetz00_2285 = 
(
(long)(BgL_offsetz00_2284)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 215 */
long BgL_modz00_2286;
{ /* ./Ast/shrinkify.scm 215 */
int BgL_arg2107z00_2287;
BgL_arg2107z00_2287 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 215 */
long BgL_n2z00_2295;
BgL_n2z00_2295 = 
(long)(BgL_arg2107z00_2287); 
BgL_modz00_2286 = 
(BgL_offsetz00_2285/BgL_n2z00_2295); } } 
{ /* ./Ast/shrinkify.scm 215 */
long BgL_restz00_2288;
{ /* ./Ast/shrinkify.scm 215 */
int BgL_arg2103z00_2289;
BgL_arg2103z00_2289 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 215 */
long BgL_n2z00_2298;
BgL_n2z00_2298 = 
(long)(BgL_arg2103z00_2289); 
BgL_restz00_2288 = 
(BgL_offsetz00_2285%BgL_n2z00_2298); } } 
{ /* ./Ast/shrinkify.scm 215 */

{ /* ./Ast/shrinkify.scm 215 */
obj_t BgL_bucketz00_2290;
{ /* ./Ast/shrinkify.scm 215 */
int BgL_kz00_2300;
BgL_kz00_2300 = 
(int)(BgL_modz00_2286); 
BgL_bucketz00_2290 = 
VECTOR_REF(BgL_arg2096z00_2281,BgL_kz00_2300); } 
{ /* ./Ast/shrinkify.scm 215 */
int BgL_kz00_2302;
BgL_kz00_2302 = 
(int)(BgL_restz00_2288); 
BgL_method2736z00_2278 = 
VECTOR_REF(BgL_bucketz00_2290,BgL_kz00_2302); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 215 */
obj_t BgL_xz00_2458;
BgL_xz00_2458 = 
PROCEDURE_ENTRY(BgL_method2736z00_2278)(BgL_method2736z00_2278, 
(obj_t)(BgL_arg3524z00_1273), BEOA); 
BgL_res3669z00_2303 = BUNSPEC; } } BgL_res3669z00_2303; } } 
return BUNSPEC;} } 
}



/* shrink-node!-set-ex-it2774 */
obj_t BGl_shrinkzd2nodez12zd2setzd2exzd2it2774z12zzast_shrinkifyz00(obj_t BgL_envz00_2413, obj_t BgL_nodez00_2414)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 204 */
{ 
BgL_setzd2exzd2itz00_bglt BgL_nodez00_1261;
BgL_nodez00_1261 = 
(BgL_setzd2exzd2itz00_bglt)(BgL_nodez00_2414); 
{ /* ./Ast/shrinkify.scm 206 */
BgL_varz00_bglt BgL_arg3505z00_1265;
BgL_arg3505z00_1265 = 
(((BgL_setzd2exzd2itz00_bglt)CREF(BgL_nodez00_1261))->BgL_varz00); 
{ /* ./Ast/shrinkify.scm 206 */
obj_t BgL_res3660z00_2219;
{ /* ./Ast/shrinkify.scm 206 */
BgL_nodez00_bglt BgL_nodez00_2193;
BgL_nodez00_2193 = 
(BgL_nodez00_bglt)(BgL_arg3505z00_1265); 
{ /* ./Ast/shrinkify.scm 206 */
obj_t BgL_method2736z00_2194;
{ /* ./Ast/shrinkify.scm 206 */
BgL_objectz00_bglt BgL_objz00_2195;
BgL_objz00_2195 = 
(BgL_objectz00_bglt)(BgL_nodez00_2193); 
{ /* ./Ast/shrinkify.scm 206 */
long BgL_objzd2classzd2numz00_2196;
BgL_objzd2classzd2numz00_2196 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2195); 
{ /* ./Ast/shrinkify.scm 206 */
obj_t BgL_arg2096z00_2197;
BgL_arg2096z00_2197 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 206 */
int BgL_offsetz00_2200;
BgL_offsetz00_2200 = 
(int)(BgL_objzd2classzd2numz00_2196); 
{ /* ./Ast/shrinkify.scm 206 */
long BgL_offsetz00_2201;
BgL_offsetz00_2201 = 
(
(long)(BgL_offsetz00_2200)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 206 */
long BgL_modz00_2202;
{ /* ./Ast/shrinkify.scm 206 */
int BgL_arg2107z00_2203;
BgL_arg2107z00_2203 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 206 */
long BgL_n2z00_2211;
BgL_n2z00_2211 = 
(long)(BgL_arg2107z00_2203); 
BgL_modz00_2202 = 
(BgL_offsetz00_2201/BgL_n2z00_2211); } } 
{ /* ./Ast/shrinkify.scm 206 */
long BgL_restz00_2204;
{ /* ./Ast/shrinkify.scm 206 */
int BgL_arg2103z00_2205;
BgL_arg2103z00_2205 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 206 */
long BgL_n2z00_2214;
BgL_n2z00_2214 = 
(long)(BgL_arg2103z00_2205); 
BgL_restz00_2204 = 
(BgL_offsetz00_2201%BgL_n2z00_2214); } } 
{ /* ./Ast/shrinkify.scm 206 */

{ /* ./Ast/shrinkify.scm 206 */
obj_t BgL_bucketz00_2206;
{ /* ./Ast/shrinkify.scm 206 */
int BgL_kz00_2216;
BgL_kz00_2216 = 
(int)(BgL_modz00_2202); 
BgL_bucketz00_2206 = 
VECTOR_REF(BgL_arg2096z00_2197,BgL_kz00_2216); } 
{ /* ./Ast/shrinkify.scm 206 */
int BgL_kz00_2218;
BgL_kz00_2218 = 
(int)(BgL_restz00_2204); 
BgL_method2736z00_2194 = 
VECTOR_REF(BgL_bucketz00_2206,BgL_kz00_2218); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 206 */
obj_t BgL_xz00_2459;
BgL_xz00_2459 = 
PROCEDURE_ENTRY(BgL_method2736z00_2194)(BgL_method2736z00_2194, 
(obj_t)(BgL_nodez00_2193), BEOA); 
BgL_res3660z00_2219 = BUNSPEC; } } } BgL_res3660z00_2219; } } 
{ /* ./Ast/shrinkify.scm 207 */
BgL_nodez00_bglt BgL_arg3509z00_1266;
BgL_arg3509z00_1266 = 
(((BgL_setzd2exzd2itz00_bglt)CREF(BgL_nodez00_1261))->BgL_bodyz00); 
{ /* ./Ast/shrinkify.scm 207 */
obj_t BgL_res3663z00_2247;
{ /* ./Ast/shrinkify.scm 207 */
obj_t BgL_method2736z00_2222;
{ /* ./Ast/shrinkify.scm 207 */
BgL_objectz00_bglt BgL_objz00_2223;
BgL_objz00_2223 = 
(BgL_objectz00_bglt)(BgL_arg3509z00_1266); 
{ /* ./Ast/shrinkify.scm 207 */
long BgL_objzd2classzd2numz00_2224;
BgL_objzd2classzd2numz00_2224 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2223); 
{ /* ./Ast/shrinkify.scm 207 */
obj_t BgL_arg2096z00_2225;
BgL_arg2096z00_2225 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 207 */
int BgL_offsetz00_2228;
BgL_offsetz00_2228 = 
(int)(BgL_objzd2classzd2numz00_2224); 
{ /* ./Ast/shrinkify.scm 207 */
long BgL_offsetz00_2229;
BgL_offsetz00_2229 = 
(
(long)(BgL_offsetz00_2228)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 207 */
long BgL_modz00_2230;
{ /* ./Ast/shrinkify.scm 207 */
int BgL_arg2107z00_2231;
BgL_arg2107z00_2231 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 207 */
long BgL_n2z00_2239;
BgL_n2z00_2239 = 
(long)(BgL_arg2107z00_2231); 
BgL_modz00_2230 = 
(BgL_offsetz00_2229/BgL_n2z00_2239); } } 
{ /* ./Ast/shrinkify.scm 207 */
long BgL_restz00_2232;
{ /* ./Ast/shrinkify.scm 207 */
int BgL_arg2103z00_2233;
BgL_arg2103z00_2233 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 207 */
long BgL_n2z00_2242;
BgL_n2z00_2242 = 
(long)(BgL_arg2103z00_2233); 
BgL_restz00_2232 = 
(BgL_offsetz00_2229%BgL_n2z00_2242); } } 
{ /* ./Ast/shrinkify.scm 207 */

{ /* ./Ast/shrinkify.scm 207 */
obj_t BgL_bucketz00_2234;
{ /* ./Ast/shrinkify.scm 207 */
int BgL_kz00_2244;
BgL_kz00_2244 = 
(int)(BgL_modz00_2230); 
BgL_bucketz00_2234 = 
VECTOR_REF(BgL_arg2096z00_2225,BgL_kz00_2244); } 
{ /* ./Ast/shrinkify.scm 207 */
int BgL_kz00_2246;
BgL_kz00_2246 = 
(int)(BgL_restz00_2232); 
BgL_method2736z00_2222 = 
VECTOR_REF(BgL_bucketz00_2234,BgL_kz00_2246); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 207 */
obj_t BgL_xz00_2460;
BgL_xz00_2460 = 
PROCEDURE_ENTRY(BgL_method2736z00_2222)(BgL_method2736z00_2222, 
(obj_t)(BgL_arg3509z00_1266), BEOA); 
BgL_res3663z00_2247 = BUNSPEC; } } BgL_res3663z00_2247; } } 
return BUNSPEC;} } 
}



/* shrink-node!-let-var2772 */
obj_t BGl_shrinkzd2nodez12zd2letzd2var2772zc0zzast_shrinkifyz00(obj_t BgL_envz00_2415, obj_t BgL_nodez00_2416)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 192 */
{ 
BgL_letzd2varzd2_bglt BgL_nodez00_1246;
BgL_nodez00_1246 = 
(BgL_letzd2varzd2_bglt)(BgL_nodez00_2416); 
{ /* ./Ast/shrinkify.scm 194 */
BgL_nodez00_bglt BgL_arg3476z00_1250;
BgL_arg3476z00_1250 = 
(((BgL_letzd2varzd2_bglt)CREF(BgL_nodez00_1246))->BgL_bodyz00); 
{ /* ./Ast/shrinkify.scm 194 */
obj_t BgL_res3652z00_2132;
{ /* ./Ast/shrinkify.scm 194 */
obj_t BgL_method2736z00_2107;
{ /* ./Ast/shrinkify.scm 194 */
BgL_objectz00_bglt BgL_objz00_2108;
BgL_objz00_2108 = 
(BgL_objectz00_bglt)(BgL_arg3476z00_1250); 
{ /* ./Ast/shrinkify.scm 194 */
long BgL_objzd2classzd2numz00_2109;
BgL_objzd2classzd2numz00_2109 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2108); 
{ /* ./Ast/shrinkify.scm 194 */
obj_t BgL_arg2096z00_2110;
BgL_arg2096z00_2110 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 194 */
int BgL_offsetz00_2113;
BgL_offsetz00_2113 = 
(int)(BgL_objzd2classzd2numz00_2109); 
{ /* ./Ast/shrinkify.scm 194 */
long BgL_offsetz00_2114;
BgL_offsetz00_2114 = 
(
(long)(BgL_offsetz00_2113)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 194 */
long BgL_modz00_2115;
{ /* ./Ast/shrinkify.scm 194 */
int BgL_arg2107z00_2116;
BgL_arg2107z00_2116 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 194 */
long BgL_n2z00_2124;
BgL_n2z00_2124 = 
(long)(BgL_arg2107z00_2116); 
BgL_modz00_2115 = 
(BgL_offsetz00_2114/BgL_n2z00_2124); } } 
{ /* ./Ast/shrinkify.scm 194 */
long BgL_restz00_2117;
{ /* ./Ast/shrinkify.scm 194 */
int BgL_arg2103z00_2118;
BgL_arg2103z00_2118 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 194 */
long BgL_n2z00_2127;
BgL_n2z00_2127 = 
(long)(BgL_arg2103z00_2118); 
BgL_restz00_2117 = 
(BgL_offsetz00_2114%BgL_n2z00_2127); } } 
{ /* ./Ast/shrinkify.scm 194 */

{ /* ./Ast/shrinkify.scm 194 */
obj_t BgL_bucketz00_2119;
{ /* ./Ast/shrinkify.scm 194 */
int BgL_kz00_2129;
BgL_kz00_2129 = 
(int)(BgL_modz00_2115); 
BgL_bucketz00_2119 = 
VECTOR_REF(BgL_arg2096z00_2110,BgL_kz00_2129); } 
{ /* ./Ast/shrinkify.scm 194 */
int BgL_kz00_2131;
BgL_kz00_2131 = 
(int)(BgL_restz00_2117); 
BgL_method2736z00_2107 = 
VECTOR_REF(BgL_bucketz00_2119,BgL_kz00_2131); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 194 */
obj_t BgL_xz00_2461;
BgL_xz00_2461 = 
PROCEDURE_ENTRY(BgL_method2736z00_2107)(BgL_method2736z00_2107, 
(obj_t)(BgL_arg3476z00_1250), BEOA); 
BgL_res3652z00_2132 = BUNSPEC; } } BgL_res3652z00_2132; } } 
{ 
obj_t BgL_l2727z00_1251;
{ /* ./Ast/shrinkify.scm 195 */
obj_t BgL_arg3480z00_1253;
BgL_arg3480z00_1253 = 
(((BgL_letzd2varzd2_bglt)CREF(BgL_nodez00_1246))->BgL_bindingsz00); 
BgL_l2727z00_1251 = BgL_arg3480z00_1253; 
BgL_forzd2each2728zd2_1252:
{ /* ./Ast/shrinkify.scm 195 */
bool_t BgL_test3483z00_1254;
BgL_test3483z00_1254 = 
PAIRP(BgL_l2727z00_1251); 
if(BgL_test3483z00_1254)
{ /* ./Ast/shrinkify.scm 195 */
{ /* ./Ast/shrinkify.scm 196 */
obj_t BgL_bindingz00_1255;
BgL_bindingz00_1255 = 
CAR(BgL_l2727z00_1251); 
{ /* ./Ast/shrinkify.scm 196 */
obj_t BgL_arg3485z00_1256;
BgL_arg3485z00_1256 = 
CAR(BgL_bindingz00_1255); 
{ /* ./Ast/shrinkify.scm 196 */
BgL_variablez00_bglt BgL_variablez00_2137;
BgL_variablez00_2137 = 
(BgL_variablez00_bglt)(BgL_arg3485z00_1256); 
{ /* ./Ast/shrinkify.scm 196 */
obj_t BgL_method2734z00_2138;
{ /* ./Ast/shrinkify.scm 196 */
BgL_objectz00_bglt BgL_objz00_2139;
BgL_objz00_2139 = 
(BgL_objectz00_bglt)(BgL_variablez00_2137); 
{ /* ./Ast/shrinkify.scm 196 */
long BgL_objzd2classzd2numz00_2140;
BgL_objzd2classzd2numz00_2140 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2139); 
{ /* ./Ast/shrinkify.scm 196 */
obj_t BgL_arg2096z00_2141;
BgL_arg2096z00_2141 = 
PROCEDURE_REF(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 196 */
int BgL_offsetz00_2144;
BgL_offsetz00_2144 = 
(int)(BgL_objzd2classzd2numz00_2140); 
{ /* ./Ast/shrinkify.scm 196 */
long BgL_offsetz00_2145;
BgL_offsetz00_2145 = 
(
(long)(BgL_offsetz00_2144)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 196 */
long BgL_modz00_2146;
{ /* ./Ast/shrinkify.scm 196 */
int BgL_arg2107z00_2147;
BgL_arg2107z00_2147 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 196 */
long BgL_n2z00_2155;
BgL_n2z00_2155 = 
(long)(BgL_arg2107z00_2147); 
BgL_modz00_2146 = 
(BgL_offsetz00_2145/BgL_n2z00_2155); } } 
{ /* ./Ast/shrinkify.scm 196 */
long BgL_restz00_2148;
{ /* ./Ast/shrinkify.scm 196 */
int BgL_arg2103z00_2149;
BgL_arg2103z00_2149 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 196 */
long BgL_n2z00_2158;
BgL_n2z00_2158 = 
(long)(BgL_arg2103z00_2149); 
BgL_restz00_2148 = 
(BgL_offsetz00_2145%BgL_n2z00_2158); } } 
{ /* ./Ast/shrinkify.scm 196 */

{ /* ./Ast/shrinkify.scm 196 */
obj_t BgL_bucketz00_2150;
{ /* ./Ast/shrinkify.scm 196 */
int BgL_kz00_2160;
BgL_kz00_2160 = 
(int)(BgL_modz00_2146); 
BgL_bucketz00_2150 = 
VECTOR_REF(BgL_arg2096z00_2141,BgL_kz00_2160); } 
{ /* ./Ast/shrinkify.scm 196 */
int BgL_kz00_2162;
BgL_kz00_2162 = 
(int)(BgL_restz00_2148); 
BgL_method2734z00_2138 = 
VECTOR_REF(BgL_bucketz00_2150,BgL_kz00_2162); } } } } } } } } } } 
PROCEDURE_ENTRY(BgL_method2734z00_2138)(BgL_method2734z00_2138, 
(obj_t)(BgL_variablez00_2137), BEOA); } } } 
{ /* ./Ast/shrinkify.scm 197 */
obj_t BgL_arg3489z00_1257;
BgL_arg3489z00_1257 = 
CDR(BgL_bindingz00_1255); 
{ /* ./Ast/shrinkify.scm 197 */
obj_t BgL_res3657z00_2190;
{ /* ./Ast/shrinkify.scm 197 */
BgL_nodez00_bglt BgL_nodez00_2164;
BgL_nodez00_2164 = 
(BgL_nodez00_bglt)(BgL_arg3489z00_1257); 
{ /* ./Ast/shrinkify.scm 197 */
obj_t BgL_method2736z00_2165;
{ /* ./Ast/shrinkify.scm 197 */
BgL_objectz00_bglt BgL_objz00_2166;
BgL_objz00_2166 = 
(BgL_objectz00_bglt)(BgL_nodez00_2164); 
{ /* ./Ast/shrinkify.scm 197 */
long BgL_objzd2classzd2numz00_2167;
BgL_objzd2classzd2numz00_2167 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2166); 
{ /* ./Ast/shrinkify.scm 197 */
obj_t BgL_arg2096z00_2168;
BgL_arg2096z00_2168 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 197 */
int BgL_offsetz00_2171;
BgL_offsetz00_2171 = 
(int)(BgL_objzd2classzd2numz00_2167); 
{ /* ./Ast/shrinkify.scm 197 */
long BgL_offsetz00_2172;
BgL_offsetz00_2172 = 
(
(long)(BgL_offsetz00_2171)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 197 */
long BgL_modz00_2173;
{ /* ./Ast/shrinkify.scm 197 */
int BgL_arg2107z00_2174;
BgL_arg2107z00_2174 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 197 */
long BgL_n2z00_2182;
BgL_n2z00_2182 = 
(long)(BgL_arg2107z00_2174); 
BgL_modz00_2173 = 
(BgL_offsetz00_2172/BgL_n2z00_2182); } } 
{ /* ./Ast/shrinkify.scm 197 */
long BgL_restz00_2175;
{ /* ./Ast/shrinkify.scm 197 */
int BgL_arg2103z00_2176;
BgL_arg2103z00_2176 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 197 */
long BgL_n2z00_2185;
BgL_n2z00_2185 = 
(long)(BgL_arg2103z00_2176); 
BgL_restz00_2175 = 
(BgL_offsetz00_2172%BgL_n2z00_2185); } } 
{ /* ./Ast/shrinkify.scm 197 */

{ /* ./Ast/shrinkify.scm 197 */
obj_t BgL_bucketz00_2177;
{ /* ./Ast/shrinkify.scm 197 */
int BgL_kz00_2187;
BgL_kz00_2187 = 
(int)(BgL_modz00_2173); 
BgL_bucketz00_2177 = 
VECTOR_REF(BgL_arg2096z00_2168,BgL_kz00_2187); } 
{ /* ./Ast/shrinkify.scm 197 */
int BgL_kz00_2189;
BgL_kz00_2189 = 
(int)(BgL_restz00_2175); 
BgL_method2736z00_2165 = 
VECTOR_REF(BgL_bucketz00_2177,BgL_kz00_2189); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 197 */
obj_t BgL_xz00_2462;
BgL_xz00_2462 = 
PROCEDURE_ENTRY(BgL_method2736z00_2165)(BgL_method2736z00_2165, 
(obj_t)(BgL_nodez00_2164), BEOA); 
BgL_res3657z00_2190 = BUNSPEC; } } } BgL_res3657z00_2190; } } } 
{ /* ./Ast/shrinkify.scm 195 */
obj_t BgL_arg3494z00_1258;
BgL_arg3494z00_1258 = 
CDR(BgL_l2727z00_1251); 
{ 
obj_t BgL_l2727z00_2788;
BgL_l2727z00_2788 = BgL_arg3494z00_1258; 
BgL_l2727z00_1251 = BgL_l2727z00_2788; 
goto BgL_forzd2each2728zd2_1252;} } }  else 
{ /* ./Ast/shrinkify.scm 195 */((bool_t)1); } } } } 
return BUNSPEC;} } 
}



/* shrink-node!-let-fun2770 */
obj_t BGl_shrinkzd2nodez12zd2letzd2fun2770zc0zzast_shrinkifyz00(obj_t BgL_envz00_2417, obj_t BgL_nodez00_2418)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 178 */
{ 
BgL_letzd2funzd2_bglt BgL_nodez00_1225;
BgL_nodez00_1225 = 
(BgL_letzd2funzd2_bglt)(BgL_nodez00_2418); 
{ /* ./Ast/shrinkify.scm 180 */
BgL_nodez00_bglt BgL_arg3434z00_1229;
BgL_arg3434z00_1229 = 
(((BgL_letzd2funzd2_bglt)CREF(BgL_nodez00_1225))->BgL_bodyz00); 
{ /* ./Ast/shrinkify.scm 180 */
obj_t BgL_res3642z00_2015;
{ /* ./Ast/shrinkify.scm 180 */
obj_t BgL_method2736z00_1990;
{ /* ./Ast/shrinkify.scm 180 */
BgL_objectz00_bglt BgL_objz00_1991;
BgL_objz00_1991 = 
(BgL_objectz00_bglt)(BgL_arg3434z00_1229); 
{ /* ./Ast/shrinkify.scm 180 */
long BgL_objzd2classzd2numz00_1992;
BgL_objzd2classzd2numz00_1992 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1991); 
{ /* ./Ast/shrinkify.scm 180 */
obj_t BgL_arg2096z00_1993;
BgL_arg2096z00_1993 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 180 */
int BgL_offsetz00_1996;
BgL_offsetz00_1996 = 
(int)(BgL_objzd2classzd2numz00_1992); 
{ /* ./Ast/shrinkify.scm 180 */
long BgL_offsetz00_1997;
BgL_offsetz00_1997 = 
(
(long)(BgL_offsetz00_1996)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 180 */
long BgL_modz00_1998;
{ /* ./Ast/shrinkify.scm 180 */
int BgL_arg2107z00_1999;
BgL_arg2107z00_1999 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 180 */
long BgL_n2z00_2007;
BgL_n2z00_2007 = 
(long)(BgL_arg2107z00_1999); 
BgL_modz00_1998 = 
(BgL_offsetz00_1997/BgL_n2z00_2007); } } 
{ /* ./Ast/shrinkify.scm 180 */
long BgL_restz00_2000;
{ /* ./Ast/shrinkify.scm 180 */
int BgL_arg2103z00_2001;
BgL_arg2103z00_2001 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 180 */
long BgL_n2z00_2010;
BgL_n2z00_2010 = 
(long)(BgL_arg2103z00_2001); 
BgL_restz00_2000 = 
(BgL_offsetz00_1997%BgL_n2z00_2010); } } 
{ /* ./Ast/shrinkify.scm 180 */

{ /* ./Ast/shrinkify.scm 180 */
obj_t BgL_bucketz00_2002;
{ /* ./Ast/shrinkify.scm 180 */
int BgL_kz00_2012;
BgL_kz00_2012 = 
(int)(BgL_modz00_1998); 
BgL_bucketz00_2002 = 
VECTOR_REF(BgL_arg2096z00_1993,BgL_kz00_2012); } 
{ /* ./Ast/shrinkify.scm 180 */
int BgL_kz00_2014;
BgL_kz00_2014 = 
(int)(BgL_restz00_2000); 
BgL_method2736z00_1990 = 
VECTOR_REF(BgL_bucketz00_2002,BgL_kz00_2014); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 180 */
obj_t BgL_xz00_2463;
BgL_xz00_2463 = 
PROCEDURE_ENTRY(BgL_method2736z00_1990)(BgL_method2736z00_1990, 
(obj_t)(BgL_arg3434z00_1229), BEOA); 
BgL_res3642z00_2015 = BUNSPEC; } } BgL_res3642z00_2015; } } 
{ 
obj_t BgL_l2721z00_1230;
{ /* ./Ast/shrinkify.scm 181 */
obj_t BgL_arg3438z00_1232;
BgL_arg3438z00_1232 = 
(((BgL_letzd2funzd2_bglt)CREF(BgL_nodez00_1225))->BgL_localsz00); 
BgL_l2721z00_1230 = BgL_arg3438z00_1232; 
BgL_forzd2each2722zd2_1231:
{ /* ./Ast/shrinkify.scm 181 */
bool_t BgL_test3441z00_1233;
BgL_test3441z00_1233 = 
PAIRP(BgL_l2721z00_1230); 
if(BgL_test3441z00_1233)
{ /* ./Ast/shrinkify.scm 181 */
{ /* ./Ast/shrinkify.scm 182 */
obj_t BgL_localz00_1234;
BgL_localz00_1234 = 
CAR(BgL_l2721z00_1230); 
{ /* ./Ast/shrinkify.scm 182 */
BgL_valuez00_bglt BgL_sfunz00_1235;
{ /* ./Ast/shrinkify.scm 182 */
BgL_variablez00_bglt BgL_obj1100z00_2019;
BgL_obj1100z00_2019 = 
(BgL_variablez00_bglt)(BgL_localz00_1234); 
BgL_sfunz00_1235 = 
(((BgL_variablez00_bglt)CREF(BgL_obj1100z00_2019))->BgL_valuez00); } 
{ /* ./Ast/shrinkify.scm 183 */
BgL_variablez00_bglt BgL_variablez00_2020;
BgL_variablez00_2020 = 
(BgL_variablez00_bglt)(BgL_localz00_1234); 
{ /* ./Ast/shrinkify.scm 183 */
obj_t BgL_method2734z00_2021;
{ /* ./Ast/shrinkify.scm 183 */
BgL_objectz00_bglt BgL_objz00_2022;
BgL_objz00_2022 = 
(BgL_objectz00_bglt)(BgL_variablez00_2020); 
{ /* ./Ast/shrinkify.scm 183 */
long BgL_objzd2classzd2numz00_2023;
BgL_objzd2classzd2numz00_2023 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2022); 
{ /* ./Ast/shrinkify.scm 183 */
obj_t BgL_arg2096z00_2024;
BgL_arg2096z00_2024 = 
PROCEDURE_REF(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 183 */
int BgL_offsetz00_2027;
BgL_offsetz00_2027 = 
(int)(BgL_objzd2classzd2numz00_2023); 
{ /* ./Ast/shrinkify.scm 183 */
long BgL_offsetz00_2028;
BgL_offsetz00_2028 = 
(
(long)(BgL_offsetz00_2027)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 183 */
long BgL_modz00_2029;
{ /* ./Ast/shrinkify.scm 183 */
int BgL_arg2107z00_2030;
BgL_arg2107z00_2030 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 183 */
long BgL_n2z00_2038;
BgL_n2z00_2038 = 
(long)(BgL_arg2107z00_2030); 
BgL_modz00_2029 = 
(BgL_offsetz00_2028/BgL_n2z00_2038); } } 
{ /* ./Ast/shrinkify.scm 183 */
long BgL_restz00_2031;
{ /* ./Ast/shrinkify.scm 183 */
int BgL_arg2103z00_2032;
BgL_arg2103z00_2032 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 183 */
long BgL_n2z00_2041;
BgL_n2z00_2041 = 
(long)(BgL_arg2103z00_2032); 
BgL_restz00_2031 = 
(BgL_offsetz00_2028%BgL_n2z00_2041); } } 
{ /* ./Ast/shrinkify.scm 183 */

{ /* ./Ast/shrinkify.scm 183 */
obj_t BgL_bucketz00_2033;
{ /* ./Ast/shrinkify.scm 183 */
int BgL_kz00_2043;
BgL_kz00_2043 = 
(int)(BgL_modz00_2029); 
BgL_bucketz00_2033 = 
VECTOR_REF(BgL_arg2096z00_2024,BgL_kz00_2043); } 
{ /* ./Ast/shrinkify.scm 183 */
int BgL_kz00_2045;
BgL_kz00_2045 = 
(int)(BgL_restz00_2031); 
BgL_method2734z00_2021 = 
VECTOR_REF(BgL_bucketz00_2033,BgL_kz00_2045); } } } } } } } } } } 
PROCEDURE_ENTRY(BgL_method2734z00_2021)(BgL_method2734z00_2021, 
(obj_t)(BgL_variablez00_2020), BEOA); } } 
{ 
obj_t BgL_l2723z00_1236;
{ /* ./Ast/shrinkify.scm 184 */
obj_t BgL_arg3444z00_1238;
{ /* ./Ast/shrinkify.scm 184 */
BgL_sfunz00_bglt BgL_obj1367z00_2046;
BgL_obj1367z00_2046 = 
(BgL_sfunz00_bglt)(BgL_sfunz00_1235); 
BgL_arg3444z00_1238 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1367z00_2046))->BgL_argsz00); } 
BgL_l2723z00_1236 = BgL_arg3444z00_1238; 
BgL_forzd2each2724zd2_1237:
{ /* ./Ast/shrinkify.scm 184 */
bool_t BgL_test3447z00_1239;
BgL_test3447z00_1239 = 
PAIRP(BgL_l2723z00_1236); 
if(BgL_test3447z00_1239)
{ /* ./Ast/shrinkify.scm 184 */
{ /* ./Ast/shrinkify.scm 184 */
obj_t BgL_arg3449z00_1240;
BgL_arg3449z00_1240 = 
CAR(BgL_l2723z00_1236); 
{ /* ./Ast/shrinkify.scm 184 */
BgL_variablez00_bglt BgL_variablez00_2049;
BgL_variablez00_2049 = 
(BgL_variablez00_bglt)(BgL_arg3449z00_1240); 
{ /* ./Ast/shrinkify.scm 184 */
obj_t BgL_method2734z00_2050;
{ /* ./Ast/shrinkify.scm 184 */
BgL_objectz00_bglt BgL_objz00_2051;
BgL_objz00_2051 = 
(BgL_objectz00_bglt)(BgL_variablez00_2049); 
{ /* ./Ast/shrinkify.scm 184 */
long BgL_objzd2classzd2numz00_2052;
BgL_objzd2classzd2numz00_2052 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2051); 
{ /* ./Ast/shrinkify.scm 184 */
obj_t BgL_arg2096z00_2053;
BgL_arg2096z00_2053 = 
PROCEDURE_REF(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 184 */
int BgL_offsetz00_2056;
BgL_offsetz00_2056 = 
(int)(BgL_objzd2classzd2numz00_2052); 
{ /* ./Ast/shrinkify.scm 184 */
long BgL_offsetz00_2057;
BgL_offsetz00_2057 = 
(
(long)(BgL_offsetz00_2056)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 184 */
long BgL_modz00_2058;
{ /* ./Ast/shrinkify.scm 184 */
int BgL_arg2107z00_2059;
BgL_arg2107z00_2059 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 184 */
long BgL_n2z00_2067;
BgL_n2z00_2067 = 
(long)(BgL_arg2107z00_2059); 
BgL_modz00_2058 = 
(BgL_offsetz00_2057/BgL_n2z00_2067); } } 
{ /* ./Ast/shrinkify.scm 184 */
long BgL_restz00_2060;
{ /* ./Ast/shrinkify.scm 184 */
int BgL_arg2103z00_2061;
BgL_arg2103z00_2061 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 184 */
long BgL_n2z00_2070;
BgL_n2z00_2070 = 
(long)(BgL_arg2103z00_2061); 
BgL_restz00_2060 = 
(BgL_offsetz00_2057%BgL_n2z00_2070); } } 
{ /* ./Ast/shrinkify.scm 184 */

{ /* ./Ast/shrinkify.scm 184 */
obj_t BgL_bucketz00_2062;
{ /* ./Ast/shrinkify.scm 184 */
int BgL_kz00_2072;
BgL_kz00_2072 = 
(int)(BgL_modz00_2058); 
BgL_bucketz00_2062 = 
VECTOR_REF(BgL_arg2096z00_2053,BgL_kz00_2072); } 
{ /* ./Ast/shrinkify.scm 184 */
int BgL_kz00_2074;
BgL_kz00_2074 = 
(int)(BgL_restz00_2060); 
BgL_method2734z00_2050 = 
VECTOR_REF(BgL_bucketz00_2062,BgL_kz00_2074); } } } } } } } } } } 
PROCEDURE_ENTRY(BgL_method2734z00_2050)(BgL_method2734z00_2050, 
(obj_t)(BgL_variablez00_2049), BEOA); } } } 
{ /* ./Ast/shrinkify.scm 184 */
obj_t BgL_arg3454z00_1241;
BgL_arg3454z00_1241 = 
CDR(BgL_l2723z00_1236); 
{ 
obj_t BgL_l2723z00_2865;
BgL_l2723z00_2865 = BgL_arg3454z00_1241; 
BgL_l2723z00_1236 = BgL_l2723z00_2865; 
goto BgL_forzd2each2724zd2_1237;} } }  else 
{ /* ./Ast/shrinkify.scm 184 */((bool_t)1); } } } } 
{ /* ./Ast/shrinkify.scm 185 */
obj_t BgL_arg3459z00_1242;
{ /* ./Ast/shrinkify.scm 185 */
BgL_sfunz00_bglt BgL_obj1370z00_2076;
BgL_obj1370z00_2076 = 
(BgL_sfunz00_bglt)(BgL_sfunz00_1235); 
BgL_arg3459z00_1242 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1370z00_2076))->BgL_bodyz00); } 
{ /* ./Ast/shrinkify.scm 185 */
obj_t BgL_res3649z00_2103;
{ /* ./Ast/shrinkify.scm 185 */
BgL_nodez00_bglt BgL_nodez00_2077;
BgL_nodez00_2077 = 
(BgL_nodez00_bglt)(BgL_arg3459z00_1242); 
{ /* ./Ast/shrinkify.scm 185 */
obj_t BgL_method2736z00_2078;
{ /* ./Ast/shrinkify.scm 185 */
BgL_objectz00_bglt BgL_objz00_2079;
BgL_objz00_2079 = 
(BgL_objectz00_bglt)(BgL_nodez00_2077); 
{ /* ./Ast/shrinkify.scm 185 */
long BgL_objzd2classzd2numz00_2080;
BgL_objzd2classzd2numz00_2080 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2079); 
{ /* ./Ast/shrinkify.scm 185 */
obj_t BgL_arg2096z00_2081;
BgL_arg2096z00_2081 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 185 */
int BgL_offsetz00_2084;
BgL_offsetz00_2084 = 
(int)(BgL_objzd2classzd2numz00_2080); 
{ /* ./Ast/shrinkify.scm 185 */
long BgL_offsetz00_2085;
BgL_offsetz00_2085 = 
(
(long)(BgL_offsetz00_2084)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 185 */
long BgL_modz00_2086;
{ /* ./Ast/shrinkify.scm 185 */
int BgL_arg2107z00_2087;
BgL_arg2107z00_2087 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 185 */
long BgL_n2z00_2095;
BgL_n2z00_2095 = 
(long)(BgL_arg2107z00_2087); 
BgL_modz00_2086 = 
(BgL_offsetz00_2085/BgL_n2z00_2095); } } 
{ /* ./Ast/shrinkify.scm 185 */
long BgL_restz00_2088;
{ /* ./Ast/shrinkify.scm 185 */
int BgL_arg2103z00_2089;
BgL_arg2103z00_2089 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 185 */
long BgL_n2z00_2098;
BgL_n2z00_2098 = 
(long)(BgL_arg2103z00_2089); 
BgL_restz00_2088 = 
(BgL_offsetz00_2085%BgL_n2z00_2098); } } 
{ /* ./Ast/shrinkify.scm 185 */

{ /* ./Ast/shrinkify.scm 185 */
obj_t BgL_bucketz00_2090;
{ /* ./Ast/shrinkify.scm 185 */
int BgL_kz00_2100;
BgL_kz00_2100 = 
(int)(BgL_modz00_2086); 
BgL_bucketz00_2090 = 
VECTOR_REF(BgL_arg2096z00_2081,BgL_kz00_2100); } 
{ /* ./Ast/shrinkify.scm 185 */
int BgL_kz00_2102;
BgL_kz00_2102 = 
(int)(BgL_restz00_2088); 
BgL_method2736z00_2078 = 
VECTOR_REF(BgL_bucketz00_2090,BgL_kz00_2102); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 185 */
obj_t BgL_xz00_2464;
BgL_xz00_2464 = 
PROCEDURE_ENTRY(BgL_method2736z00_2078)(BgL_method2736z00_2078, 
(obj_t)(BgL_nodez00_2077), BEOA); 
BgL_res3649z00_2103 = BUNSPEC; } } } BgL_res3649z00_2103; } } } } 
{ /* ./Ast/shrinkify.scm 181 */
obj_t BgL_arg3465z00_1243;
BgL_arg3465z00_1243 = 
CDR(BgL_l2721z00_1230); 
{ 
obj_t BgL_l2721z00_2890;
BgL_l2721z00_2890 = BgL_arg3465z00_1243; 
BgL_l2721z00_1230 = BgL_l2721z00_2890; 
goto BgL_forzd2each2722zd2_1231;} } }  else 
{ /* ./Ast/shrinkify.scm 181 */((bool_t)1); } } } } 
return BUNSPEC;} } 
}



/* shrink-node!-box-set!2768 */
obj_t BGl_shrinkzd2nodez12zd2boxzd2setz122768zd2zzast_shrinkifyz00(obj_t BgL_envz00_2419, obj_t BgL_nodez00_2420)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 169 */
{ 
BgL_boxzd2setz12zc0_bglt BgL_nodez00_1213;
BgL_nodez00_1213 = 
(BgL_boxzd2setz12zc0_bglt)(BgL_nodez00_2420); 
{ /* ./Ast/shrinkify.scm 170 */
bool_t BgL_test3405z00_1216;
{ /* ./Ast/shrinkify.scm 170 */
bool_t BgL_testz00_2892;
{ /* ./Ast/shrinkify.scm 170 */
obj_t BgL_auxz00_2893;
{ /* ./Ast/shrinkify.scm 170 */
BgL_objectz00_bglt BgL_auxz00_2894;
BgL_auxz00_2894 = 
(BgL_objectz00_bglt)(BgL_nodez00_1213); 
BgL_auxz00_2893 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2894); } 
BgL_testz00_2892 = 
CBOOL(BgL_auxz00_2893); } 
if(BgL_testz00_2892)
{ /* ./Ast/shrinkify.scm 170 */
BgL_test3405z00_1216 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 170 */
BgL_test3405z00_1216 = ((bool_t)0); } } 
if(BgL_test3405z00_1216)
{ /* ./Ast/shrinkify.scm 170 */
{ /* ./Ast/shrinkify.scm 170 */
long BgL_arg3407z00_1218;
{ /* ./Ast/shrinkify.scm 170 */
obj_t BgL_arg3410z00_1219;
{ /* ./Ast/shrinkify.scm 170 */
obj_t BgL_arg3413z00_1220;
{ /* ./Ast/shrinkify.scm 170 */
BgL_objectz00_bglt BgL_objectz00_1922;
BgL_objectz00_1922 = 
(BgL_objectz00_bglt)(BgL_nodez00_1213); 
{ /* ./Ast/shrinkify.scm 170 */
long BgL_arg2114z00_1923;
{ /* ./Ast/shrinkify.scm 170 */
long BgL_arg2117z00_1924;
BgL_arg2117z00_1924 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_1922); 
BgL_arg2114z00_1923 = 
(BgL_arg2117z00_1924-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 170 */
obj_t BgL_vectorz00_1928;int BgL_kz00_1929;
BgL_vectorz00_1928 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_1929 = 
(int)(BgL_arg2114z00_1923); 
BgL_arg3413z00_1220 = 
VECTOR_REF(BgL_vectorz00_1928,BgL_kz00_1929); } } } 
BgL_arg3410z00_1219 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3413z00_1220); } 
BgL_arg3407z00_1218 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3410z00_1219); } 
{ /* ./Ast/shrinkify.scm 170 */
BgL_objectz00_bglt BgL_objz00_1930;
BgL_objz00_1930 = 
(BgL_objectz00_bglt)(BgL_nodez00_1213); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_1930, BgL_arg3407z00_1218); } } 
{ /* ./Ast/shrinkify.scm 170 */
BgL_objectz00_bglt BgL_auxz00_2908;
BgL_auxz00_2908 = 
(BgL_objectz00_bglt)(BgL_nodez00_1213); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_2908, BFALSE); } 
(obj_t)(BgL_nodez00_1213); }  else 
{ /* ./Ast/shrinkify.scm 170 */BFALSE; } } 
{ /* ./Ast/shrinkify.scm 171 */
BgL_varz00_bglt BgL_arg3420z00_1221;
BgL_arg3420z00_1221 = 
(((BgL_boxzd2setz12zc0_bglt)CREF(BgL_nodez00_1213))->BgL_varz00); 
{ /* ./Ast/shrinkify.scm 171 */
obj_t BgL_res3636z00_1959;
{ /* ./Ast/shrinkify.scm 171 */
BgL_nodez00_bglt BgL_nodez00_1933;
BgL_nodez00_1933 = 
(BgL_nodez00_bglt)(BgL_arg3420z00_1221); 
{ /* ./Ast/shrinkify.scm 171 */
obj_t BgL_method2736z00_1934;
{ /* ./Ast/shrinkify.scm 171 */
BgL_objectz00_bglt BgL_objz00_1935;
BgL_objz00_1935 = 
(BgL_objectz00_bglt)(BgL_nodez00_1933); 
{ /* ./Ast/shrinkify.scm 171 */
long BgL_objzd2classzd2numz00_1936;
BgL_objzd2classzd2numz00_1936 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1935); 
{ /* ./Ast/shrinkify.scm 171 */
obj_t BgL_arg2096z00_1937;
BgL_arg2096z00_1937 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 171 */
int BgL_offsetz00_1940;
BgL_offsetz00_1940 = 
(int)(BgL_objzd2classzd2numz00_1936); 
{ /* ./Ast/shrinkify.scm 171 */
long BgL_offsetz00_1941;
BgL_offsetz00_1941 = 
(
(long)(BgL_offsetz00_1940)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 171 */
long BgL_modz00_1942;
{ /* ./Ast/shrinkify.scm 171 */
int BgL_arg2107z00_1943;
BgL_arg2107z00_1943 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 171 */
long BgL_n2z00_1951;
BgL_n2z00_1951 = 
(long)(BgL_arg2107z00_1943); 
BgL_modz00_1942 = 
(BgL_offsetz00_1941/BgL_n2z00_1951); } } 
{ /* ./Ast/shrinkify.scm 171 */
long BgL_restz00_1944;
{ /* ./Ast/shrinkify.scm 171 */
int BgL_arg2103z00_1945;
BgL_arg2103z00_1945 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 171 */
long BgL_n2z00_1954;
BgL_n2z00_1954 = 
(long)(BgL_arg2103z00_1945); 
BgL_restz00_1944 = 
(BgL_offsetz00_1941%BgL_n2z00_1954); } } 
{ /* ./Ast/shrinkify.scm 171 */

{ /* ./Ast/shrinkify.scm 171 */
obj_t BgL_bucketz00_1946;
{ /* ./Ast/shrinkify.scm 171 */
int BgL_kz00_1956;
BgL_kz00_1956 = 
(int)(BgL_modz00_1942); 
BgL_bucketz00_1946 = 
VECTOR_REF(BgL_arg2096z00_1937,BgL_kz00_1956); } 
{ /* ./Ast/shrinkify.scm 171 */
int BgL_kz00_1958;
BgL_kz00_1958 = 
(int)(BgL_restz00_1944); 
BgL_method2736z00_1934 = 
VECTOR_REF(BgL_bucketz00_1946,BgL_kz00_1958); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 171 */
obj_t BgL_xz00_2465;
BgL_xz00_2465 = 
PROCEDURE_ENTRY(BgL_method2736z00_1934)(BgL_method2736z00_1934, 
(obj_t)(BgL_nodez00_1933), BEOA); 
BgL_res3636z00_1959 = BUNSPEC; } } } BgL_res3636z00_1959; } } 
{ /* ./Ast/shrinkify.scm 172 */
BgL_nodez00_bglt BgL_arg3424z00_1222;
BgL_arg3424z00_1222 = 
(((BgL_boxzd2setz12zc0_bglt)CREF(BgL_nodez00_1213))->BgL_valuez00); 
{ /* ./Ast/shrinkify.scm 172 */
obj_t BgL_res3639z00_1987;
{ /* ./Ast/shrinkify.scm 172 */
obj_t BgL_method2736z00_1962;
{ /* ./Ast/shrinkify.scm 172 */
BgL_objectz00_bglt BgL_objz00_1963;
BgL_objz00_1963 = 
(BgL_objectz00_bglt)(BgL_arg3424z00_1222); 
{ /* ./Ast/shrinkify.scm 172 */
long BgL_objzd2classzd2numz00_1964;
BgL_objzd2classzd2numz00_1964 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1963); 
{ /* ./Ast/shrinkify.scm 172 */
obj_t BgL_arg2096z00_1965;
BgL_arg2096z00_1965 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 172 */
int BgL_offsetz00_1968;
BgL_offsetz00_1968 = 
(int)(BgL_objzd2classzd2numz00_1964); 
{ /* ./Ast/shrinkify.scm 172 */
long BgL_offsetz00_1969;
BgL_offsetz00_1969 = 
(
(long)(BgL_offsetz00_1968)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 172 */
long BgL_modz00_1970;
{ /* ./Ast/shrinkify.scm 172 */
int BgL_arg2107z00_1971;
BgL_arg2107z00_1971 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 172 */
long BgL_n2z00_1979;
BgL_n2z00_1979 = 
(long)(BgL_arg2107z00_1971); 
BgL_modz00_1970 = 
(BgL_offsetz00_1969/BgL_n2z00_1979); } } 
{ /* ./Ast/shrinkify.scm 172 */
long BgL_restz00_1972;
{ /* ./Ast/shrinkify.scm 172 */
int BgL_arg2103z00_1973;
BgL_arg2103z00_1973 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 172 */
long BgL_n2z00_1982;
BgL_n2z00_1982 = 
(long)(BgL_arg2103z00_1973); 
BgL_restz00_1972 = 
(BgL_offsetz00_1969%BgL_n2z00_1982); } } 
{ /* ./Ast/shrinkify.scm 172 */

{ /* ./Ast/shrinkify.scm 172 */
obj_t BgL_bucketz00_1974;
{ /* ./Ast/shrinkify.scm 172 */
int BgL_kz00_1984;
BgL_kz00_1984 = 
(int)(BgL_modz00_1970); 
BgL_bucketz00_1974 = 
VECTOR_REF(BgL_arg2096z00_1965,BgL_kz00_1984); } 
{ /* ./Ast/shrinkify.scm 172 */
int BgL_kz00_1986;
BgL_kz00_1986 = 
(int)(BgL_restz00_1972); 
BgL_method2736z00_1962 = 
VECTOR_REF(BgL_bucketz00_1974,BgL_kz00_1986); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 172 */
obj_t BgL_xz00_2466;
BgL_xz00_2466 = 
PROCEDURE_ENTRY(BgL_method2736z00_1962)(BgL_method2736z00_1962, 
(obj_t)(BgL_arg3424z00_1222), BEOA); 
BgL_res3639z00_1987 = BUNSPEC; } } BgL_res3639z00_1987; } } 
return BUNSPEC;} } 
}



/* shrink-node!-box-ref2766 */
obj_t BGl_shrinkzd2nodez12zd2boxzd2ref2766zc0zzast_shrinkifyz00(obj_t BgL_envz00_2421, obj_t BgL_nodez00_2422)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 161 */
{ 
BgL_boxzd2refzd2_bglt BgL_nodez00_1202;
BgL_nodez00_1202 = 
(BgL_boxzd2refzd2_bglt)(BgL_nodez00_2422); 
{ /* ./Ast/shrinkify.scm 162 */
bool_t BgL_test3382z00_1205;
{ /* ./Ast/shrinkify.scm 162 */
bool_t BgL_testz00_2956;
{ /* ./Ast/shrinkify.scm 162 */
obj_t BgL_auxz00_2957;
{ /* ./Ast/shrinkify.scm 162 */
BgL_objectz00_bglt BgL_auxz00_2958;
BgL_auxz00_2958 = 
(BgL_objectz00_bglt)(BgL_nodez00_1202); 
BgL_auxz00_2957 = 
BGL_OBJECT_WIDENING(BgL_auxz00_2958); } 
BgL_testz00_2956 = 
CBOOL(BgL_auxz00_2957); } 
if(BgL_testz00_2956)
{ /* ./Ast/shrinkify.scm 162 */
BgL_test3382z00_1205 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 162 */
BgL_test3382z00_1205 = ((bool_t)0); } } 
if(BgL_test3382z00_1205)
{ /* ./Ast/shrinkify.scm 162 */
{ /* ./Ast/shrinkify.scm 162 */
long BgL_arg3384z00_1207;
{ /* ./Ast/shrinkify.scm 162 */
obj_t BgL_arg3387z00_1208;
{ /* ./Ast/shrinkify.scm 162 */
obj_t BgL_arg3390z00_1209;
{ /* ./Ast/shrinkify.scm 162 */
BgL_objectz00_bglt BgL_objectz00_1881;
BgL_objectz00_1881 = 
(BgL_objectz00_bglt)(BgL_nodez00_1202); 
{ /* ./Ast/shrinkify.scm 162 */
long BgL_arg2114z00_1882;
{ /* ./Ast/shrinkify.scm 162 */
long BgL_arg2117z00_1883;
BgL_arg2117z00_1883 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_1881); 
BgL_arg2114z00_1882 = 
(BgL_arg2117z00_1883-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 162 */
obj_t BgL_vectorz00_1887;int BgL_kz00_1888;
BgL_vectorz00_1887 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_1888 = 
(int)(BgL_arg2114z00_1882); 
BgL_arg3390z00_1209 = 
VECTOR_REF(BgL_vectorz00_1887,BgL_kz00_1888); } } } 
BgL_arg3387z00_1208 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3390z00_1209); } 
BgL_arg3384z00_1207 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3387z00_1208); } 
{ /* ./Ast/shrinkify.scm 162 */
BgL_objectz00_bglt BgL_objz00_1889;
BgL_objz00_1889 = 
(BgL_objectz00_bglt)(BgL_nodez00_1202); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_1889, BgL_arg3384z00_1207); } } 
{ /* ./Ast/shrinkify.scm 162 */
BgL_objectz00_bglt BgL_auxz00_2972;
BgL_auxz00_2972 = 
(BgL_objectz00_bglt)(BgL_nodez00_1202); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_2972, BFALSE); } 
(obj_t)(BgL_nodez00_1202); }  else 
{ /* ./Ast/shrinkify.scm 162 */BFALSE; } } 
{ /* ./Ast/shrinkify.scm 163 */
BgL_varz00_bglt BgL_arg3396z00_1210;
BgL_arg3396z00_1210 = 
(((BgL_boxzd2refzd2_bglt)CREF(BgL_nodez00_1202))->BgL_varz00); 
{ /* ./Ast/shrinkify.scm 163 */
obj_t BgL_res3632z00_1918;
{ /* ./Ast/shrinkify.scm 163 */
BgL_nodez00_bglt BgL_nodez00_1892;
BgL_nodez00_1892 = 
(BgL_nodez00_bglt)(BgL_arg3396z00_1210); 
{ /* ./Ast/shrinkify.scm 163 */
obj_t BgL_method2736z00_1893;
{ /* ./Ast/shrinkify.scm 163 */
BgL_objectz00_bglt BgL_objz00_1894;
BgL_objz00_1894 = 
(BgL_objectz00_bglt)(BgL_nodez00_1892); 
{ /* ./Ast/shrinkify.scm 163 */
long BgL_objzd2classzd2numz00_1895;
BgL_objzd2classzd2numz00_1895 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1894); 
{ /* ./Ast/shrinkify.scm 163 */
obj_t BgL_arg2096z00_1896;
BgL_arg2096z00_1896 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 163 */
int BgL_offsetz00_1899;
BgL_offsetz00_1899 = 
(int)(BgL_objzd2classzd2numz00_1895); 
{ /* ./Ast/shrinkify.scm 163 */
long BgL_offsetz00_1900;
BgL_offsetz00_1900 = 
(
(long)(BgL_offsetz00_1899)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 163 */
long BgL_modz00_1901;
{ /* ./Ast/shrinkify.scm 163 */
int BgL_arg2107z00_1902;
BgL_arg2107z00_1902 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 163 */
long BgL_n2z00_1910;
BgL_n2z00_1910 = 
(long)(BgL_arg2107z00_1902); 
BgL_modz00_1901 = 
(BgL_offsetz00_1900/BgL_n2z00_1910); } } 
{ /* ./Ast/shrinkify.scm 163 */
long BgL_restz00_1903;
{ /* ./Ast/shrinkify.scm 163 */
int BgL_arg2103z00_1904;
BgL_arg2103z00_1904 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 163 */
long BgL_n2z00_1913;
BgL_n2z00_1913 = 
(long)(BgL_arg2103z00_1904); 
BgL_restz00_1903 = 
(BgL_offsetz00_1900%BgL_n2z00_1913); } } 
{ /* ./Ast/shrinkify.scm 163 */

{ /* ./Ast/shrinkify.scm 163 */
obj_t BgL_bucketz00_1905;
{ /* ./Ast/shrinkify.scm 163 */
int BgL_kz00_1915;
BgL_kz00_1915 = 
(int)(BgL_modz00_1901); 
BgL_bucketz00_1905 = 
VECTOR_REF(BgL_arg2096z00_1896,BgL_kz00_1915); } 
{ /* ./Ast/shrinkify.scm 163 */
int BgL_kz00_1917;
BgL_kz00_1917 = 
(int)(BgL_restz00_1903); 
BgL_method2736z00_1893 = 
VECTOR_REF(BgL_bucketz00_1905,BgL_kz00_1917); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 163 */
obj_t BgL_xz00_2467;
BgL_xz00_2467 = 
PROCEDURE_ENTRY(BgL_method2736z00_1893)(BgL_method2736z00_1893, 
(obj_t)(BgL_nodez00_1892), BEOA); 
BgL_res3632z00_1918 = BUNSPEC; } } } BgL_res3632z00_1918; } } 
return BUNSPEC;} } 
}



/* shrink-node!-make-box2764 */
obj_t BGl_shrinkzd2nodez12zd2makezd2box2764zc0zzast_shrinkifyz00(obj_t BgL_envz00_2423, obj_t BgL_nodez00_2424)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 153 */
{ 
BgL_makezd2boxzd2_bglt BgL_nodez00_1191;
BgL_nodez00_1191 = 
(BgL_makezd2boxzd2_bglt)(BgL_nodez00_2424); 
{ /* ./Ast/shrinkify.scm 154 */
bool_t BgL_test3359z00_1194;
{ /* ./Ast/shrinkify.scm 154 */
bool_t BgL_testz00_2999;
{ /* ./Ast/shrinkify.scm 154 */
obj_t BgL_auxz00_3000;
{ /* ./Ast/shrinkify.scm 154 */
BgL_objectz00_bglt BgL_auxz00_3001;
BgL_auxz00_3001 = 
(BgL_objectz00_bglt)(BgL_nodez00_1191); 
BgL_auxz00_3000 = 
BGL_OBJECT_WIDENING(BgL_auxz00_3001); } 
BgL_testz00_2999 = 
CBOOL(BgL_auxz00_3000); } 
if(BgL_testz00_2999)
{ /* ./Ast/shrinkify.scm 154 */
BgL_test3359z00_1194 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 154 */
BgL_test3359z00_1194 = ((bool_t)0); } } 
if(BgL_test3359z00_1194)
{ /* ./Ast/shrinkify.scm 154 */
{ /* ./Ast/shrinkify.scm 154 */
long BgL_arg3361z00_1196;
{ /* ./Ast/shrinkify.scm 154 */
obj_t BgL_arg3364z00_1197;
{ /* ./Ast/shrinkify.scm 154 */
obj_t BgL_arg3367z00_1198;
{ /* ./Ast/shrinkify.scm 154 */
BgL_objectz00_bglt BgL_objectz00_1840;
BgL_objectz00_1840 = 
(BgL_objectz00_bglt)(BgL_nodez00_1191); 
{ /* ./Ast/shrinkify.scm 154 */
long BgL_arg2114z00_1841;
{ /* ./Ast/shrinkify.scm 154 */
long BgL_arg2117z00_1842;
BgL_arg2117z00_1842 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_1840); 
BgL_arg2114z00_1841 = 
(BgL_arg2117z00_1842-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 154 */
obj_t BgL_vectorz00_1846;int BgL_kz00_1847;
BgL_vectorz00_1846 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_1847 = 
(int)(BgL_arg2114z00_1841); 
BgL_arg3367z00_1198 = 
VECTOR_REF(BgL_vectorz00_1846,BgL_kz00_1847); } } } 
BgL_arg3364z00_1197 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3367z00_1198); } 
BgL_arg3361z00_1196 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3364z00_1197); } 
{ /* ./Ast/shrinkify.scm 154 */
BgL_objectz00_bglt BgL_objz00_1848;
BgL_objz00_1848 = 
(BgL_objectz00_bglt)(BgL_nodez00_1191); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_1848, BgL_arg3361z00_1196); } } 
{ /* ./Ast/shrinkify.scm 154 */
BgL_objectz00_bglt BgL_auxz00_3015;
BgL_auxz00_3015 = 
(BgL_objectz00_bglt)(BgL_nodez00_1191); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_3015, BFALSE); } 
(obj_t)(BgL_nodez00_1191); }  else 
{ /* ./Ast/shrinkify.scm 154 */BFALSE; } } 
{ /* ./Ast/shrinkify.scm 155 */
BgL_nodez00_bglt BgL_arg3373z00_1199;
BgL_arg3373z00_1199 = 
(((BgL_makezd2boxzd2_bglt)CREF(BgL_nodez00_1191))->BgL_valuez00); 
{ /* ./Ast/shrinkify.scm 155 */
obj_t BgL_res3628z00_1877;
{ /* ./Ast/shrinkify.scm 155 */
obj_t BgL_method2736z00_1852;
{ /* ./Ast/shrinkify.scm 155 */
BgL_objectz00_bglt BgL_objz00_1853;
BgL_objz00_1853 = 
(BgL_objectz00_bglt)(BgL_arg3373z00_1199); 
{ /* ./Ast/shrinkify.scm 155 */
long BgL_objzd2classzd2numz00_1854;
BgL_objzd2classzd2numz00_1854 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1853); 
{ /* ./Ast/shrinkify.scm 155 */
obj_t BgL_arg2096z00_1855;
BgL_arg2096z00_1855 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 155 */
int BgL_offsetz00_1858;
BgL_offsetz00_1858 = 
(int)(BgL_objzd2classzd2numz00_1854); 
{ /* ./Ast/shrinkify.scm 155 */
long BgL_offsetz00_1859;
BgL_offsetz00_1859 = 
(
(long)(BgL_offsetz00_1858)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 155 */
long BgL_modz00_1860;
{ /* ./Ast/shrinkify.scm 155 */
int BgL_arg2107z00_1861;
BgL_arg2107z00_1861 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 155 */
long BgL_n2z00_1869;
BgL_n2z00_1869 = 
(long)(BgL_arg2107z00_1861); 
BgL_modz00_1860 = 
(BgL_offsetz00_1859/BgL_n2z00_1869); } } 
{ /* ./Ast/shrinkify.scm 155 */
long BgL_restz00_1862;
{ /* ./Ast/shrinkify.scm 155 */
int BgL_arg2103z00_1863;
BgL_arg2103z00_1863 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 155 */
long BgL_n2z00_1872;
BgL_n2z00_1872 = 
(long)(BgL_arg2103z00_1863); 
BgL_restz00_1862 = 
(BgL_offsetz00_1859%BgL_n2z00_1872); } } 
{ /* ./Ast/shrinkify.scm 155 */

{ /* ./Ast/shrinkify.scm 155 */
obj_t BgL_bucketz00_1864;
{ /* ./Ast/shrinkify.scm 155 */
int BgL_kz00_1874;
BgL_kz00_1874 = 
(int)(BgL_modz00_1860); 
BgL_bucketz00_1864 = 
VECTOR_REF(BgL_arg2096z00_1855,BgL_kz00_1874); } 
{ /* ./Ast/shrinkify.scm 155 */
int BgL_kz00_1876;
BgL_kz00_1876 = 
(int)(BgL_restz00_1862); 
BgL_method2736z00_1852 = 
VECTOR_REF(BgL_bucketz00_1864,BgL_kz00_1876); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 155 */
obj_t BgL_xz00_2468;
BgL_xz00_2468 = 
PROCEDURE_ENTRY(BgL_method2736z00_1852)(BgL_method2736z00_1852, 
(obj_t)(BgL_arg3373z00_1199), BEOA); 
BgL_res3628z00_1877 = BUNSPEC; } } BgL_res3628z00_1877; } } 
return BUNSPEC;} } 
}



/* shrink-node!-select2762 */
obj_t BGl_shrinkzd2nodez12zd2select2762z12zzast_shrinkifyz00(obj_t BgL_envz00_2425, obj_t BgL_nodez00_2426)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 143 */
{ 
BgL_selectz00_bglt BgL_nodez00_1178;
BgL_nodez00_1178 = 
(BgL_selectz00_bglt)(BgL_nodez00_2426); 
{ /* ./Ast/shrinkify.scm 144 */
BgL_nodez00_bglt BgL_arg3335z00_1181;
BgL_arg3335z00_1181 = 
(((BgL_selectz00_bglt)CREF(BgL_nodez00_1178))->BgL_testz00); 
{ /* ./Ast/shrinkify.scm 144 */
obj_t BgL_res3621z00_1804;
{ /* ./Ast/shrinkify.scm 144 */
obj_t BgL_method2736z00_1779;
{ /* ./Ast/shrinkify.scm 144 */
BgL_objectz00_bglt BgL_objz00_1780;
BgL_objz00_1780 = 
(BgL_objectz00_bglt)(BgL_arg3335z00_1181); 
{ /* ./Ast/shrinkify.scm 144 */
long BgL_objzd2classzd2numz00_1781;
BgL_objzd2classzd2numz00_1781 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1780); 
{ /* ./Ast/shrinkify.scm 144 */
obj_t BgL_arg2096z00_1782;
BgL_arg2096z00_1782 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 144 */
int BgL_offsetz00_1785;
BgL_offsetz00_1785 = 
(int)(BgL_objzd2classzd2numz00_1781); 
{ /* ./Ast/shrinkify.scm 144 */
long BgL_offsetz00_1786;
BgL_offsetz00_1786 = 
(
(long)(BgL_offsetz00_1785)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 144 */
long BgL_modz00_1787;
{ /* ./Ast/shrinkify.scm 144 */
int BgL_arg2107z00_1788;
BgL_arg2107z00_1788 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 144 */
long BgL_n2z00_1796;
BgL_n2z00_1796 = 
(long)(BgL_arg2107z00_1788); 
BgL_modz00_1787 = 
(BgL_offsetz00_1786/BgL_n2z00_1796); } } 
{ /* ./Ast/shrinkify.scm 144 */
long BgL_restz00_1789;
{ /* ./Ast/shrinkify.scm 144 */
int BgL_arg2103z00_1790;
BgL_arg2103z00_1790 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 144 */
long BgL_n2z00_1799;
BgL_n2z00_1799 = 
(long)(BgL_arg2103z00_1790); 
BgL_restz00_1789 = 
(BgL_offsetz00_1786%BgL_n2z00_1799); } } 
{ /* ./Ast/shrinkify.scm 144 */

{ /* ./Ast/shrinkify.scm 144 */
obj_t BgL_bucketz00_1791;
{ /* ./Ast/shrinkify.scm 144 */
int BgL_kz00_1801;
BgL_kz00_1801 = 
(int)(BgL_modz00_1787); 
BgL_bucketz00_1791 = 
VECTOR_REF(BgL_arg2096z00_1782,BgL_kz00_1801); } 
{ /* ./Ast/shrinkify.scm 144 */
int BgL_kz00_1803;
BgL_kz00_1803 = 
(int)(BgL_restz00_1789); 
BgL_method2736z00_1779 = 
VECTOR_REF(BgL_bucketz00_1791,BgL_kz00_1803); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 144 */
obj_t BgL_xz00_2469;
BgL_xz00_2469 = 
PROCEDURE_ENTRY(BgL_method2736z00_1779)(BgL_method2736z00_1779, 
(obj_t)(BgL_arg3335z00_1181), BEOA); 
BgL_res3621z00_1804 = BUNSPEC; } } BgL_res3621z00_1804; } } 
{ 
obj_t BgL_l2714z00_1182;
{ /* ./Ast/shrinkify.scm 147 */
obj_t BgL_arg3339z00_1184;
BgL_arg3339z00_1184 = 
(((BgL_selectz00_bglt)CREF(BgL_nodez00_1178))->BgL_clausesz00); 
BgL_l2714z00_1182 = BgL_arg3339z00_1184; 
BgL_forzd2each2715zd2_1183:
{ /* ./Ast/shrinkify.scm 145 */
bool_t BgL_test3342z00_1185;
BgL_test3342z00_1185 = 
PAIRP(BgL_l2714z00_1182); 
if(BgL_test3342z00_1185)
{ /* ./Ast/shrinkify.scm 145 */
{ /* ./Ast/shrinkify.scm 146 */
obj_t BgL_clausez00_1186;
BgL_clausez00_1186 = 
CAR(BgL_l2714z00_1182); 
{ /* ./Ast/shrinkify.scm 146 */
obj_t BgL_arg3344z00_1187;
BgL_arg3344z00_1187 = 
CDR(BgL_clausez00_1186); 
{ /* ./Ast/shrinkify.scm 146 */
obj_t BgL_res3624z00_1835;
{ /* ./Ast/shrinkify.scm 146 */
BgL_nodez00_bglt BgL_nodez00_1809;
BgL_nodez00_1809 = 
(BgL_nodez00_bglt)(BgL_arg3344z00_1187); 
{ /* ./Ast/shrinkify.scm 146 */
obj_t BgL_method2736z00_1810;
{ /* ./Ast/shrinkify.scm 146 */
BgL_objectz00_bglt BgL_objz00_1811;
BgL_objz00_1811 = 
(BgL_objectz00_bglt)(BgL_nodez00_1809); 
{ /* ./Ast/shrinkify.scm 146 */
long BgL_objzd2classzd2numz00_1812;
BgL_objzd2classzd2numz00_1812 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1811); 
{ /* ./Ast/shrinkify.scm 146 */
obj_t BgL_arg2096z00_1813;
BgL_arg2096z00_1813 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 146 */
int BgL_offsetz00_1816;
BgL_offsetz00_1816 = 
(int)(BgL_objzd2classzd2numz00_1812); 
{ /* ./Ast/shrinkify.scm 146 */
long BgL_offsetz00_1817;
BgL_offsetz00_1817 = 
(
(long)(BgL_offsetz00_1816)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 146 */
long BgL_modz00_1818;
{ /* ./Ast/shrinkify.scm 146 */
int BgL_arg2107z00_1819;
BgL_arg2107z00_1819 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 146 */
long BgL_n2z00_1827;
BgL_n2z00_1827 = 
(long)(BgL_arg2107z00_1819); 
BgL_modz00_1818 = 
(BgL_offsetz00_1817/BgL_n2z00_1827); } } 
{ /* ./Ast/shrinkify.scm 146 */
long BgL_restz00_1820;
{ /* ./Ast/shrinkify.scm 146 */
int BgL_arg2103z00_1821;
BgL_arg2103z00_1821 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 146 */
long BgL_n2z00_1830;
BgL_n2z00_1830 = 
(long)(BgL_arg2103z00_1821); 
BgL_restz00_1820 = 
(BgL_offsetz00_1817%BgL_n2z00_1830); } } 
{ /* ./Ast/shrinkify.scm 146 */

{ /* ./Ast/shrinkify.scm 146 */
obj_t BgL_bucketz00_1822;
{ /* ./Ast/shrinkify.scm 146 */
int BgL_kz00_1832;
BgL_kz00_1832 = 
(int)(BgL_modz00_1818); 
BgL_bucketz00_1822 = 
VECTOR_REF(BgL_arg2096z00_1813,BgL_kz00_1832); } 
{ /* ./Ast/shrinkify.scm 146 */
int BgL_kz00_1834;
BgL_kz00_1834 = 
(int)(BgL_restz00_1820); 
BgL_method2736z00_1810 = 
VECTOR_REF(BgL_bucketz00_1822,BgL_kz00_1834); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 146 */
obj_t BgL_xz00_2470;
BgL_xz00_2470 = 
PROCEDURE_ENTRY(BgL_method2736z00_1810)(BgL_method2736z00_1810, 
(obj_t)(BgL_nodez00_1809), BEOA); 
BgL_res3624z00_1835 = BUNSPEC; } } } BgL_res3624z00_1835; } } } 
{ /* ./Ast/shrinkify.scm 145 */
obj_t BgL_arg3349z00_1188;
BgL_arg3349z00_1188 = 
CDR(BgL_l2714z00_1182); 
{ 
obj_t BgL_l2714z00_3089;
BgL_l2714z00_3089 = BgL_arg3349z00_1188; 
BgL_l2714z00_1182 = BgL_l2714z00_3089; 
goto BgL_forzd2each2715zd2_1183;} } }  else 
{ /* ./Ast/shrinkify.scm 145 */((bool_t)1); } } } } 
return BUNSPEC;} } 
}



/* shrink-node!-fail2760 */
obj_t BGl_shrinkzd2nodez12zd2fail2760z12zzast_shrinkifyz00(obj_t BgL_envz00_2427, obj_t BgL_nodez00_2428)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 134 */
{ 
BgL_failz00_bglt BgL_nodez00_1170;
BgL_nodez00_1170 = 
(BgL_failz00_bglt)(BgL_nodez00_2428); 
{ /* ./Ast/shrinkify.scm 135 */
BgL_nodez00_bglt BgL_arg3317z00_1173;
BgL_arg3317z00_1173 = 
(((BgL_failz00_bglt)CREF(BgL_nodez00_1170))->BgL_procz00); 
{ /* ./Ast/shrinkify.scm 135 */
obj_t BgL_res3612z00_1720;
{ /* ./Ast/shrinkify.scm 135 */
obj_t BgL_method2736z00_1695;
{ /* ./Ast/shrinkify.scm 135 */
BgL_objectz00_bglt BgL_objz00_1696;
BgL_objz00_1696 = 
(BgL_objectz00_bglt)(BgL_arg3317z00_1173); 
{ /* ./Ast/shrinkify.scm 135 */
long BgL_objzd2classzd2numz00_1697;
BgL_objzd2classzd2numz00_1697 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1696); 
{ /* ./Ast/shrinkify.scm 135 */
obj_t BgL_arg2096z00_1698;
BgL_arg2096z00_1698 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 135 */
int BgL_offsetz00_1701;
BgL_offsetz00_1701 = 
(int)(BgL_objzd2classzd2numz00_1697); 
{ /* ./Ast/shrinkify.scm 135 */
long BgL_offsetz00_1702;
BgL_offsetz00_1702 = 
(
(long)(BgL_offsetz00_1701)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 135 */
long BgL_modz00_1703;
{ /* ./Ast/shrinkify.scm 135 */
int BgL_arg2107z00_1704;
BgL_arg2107z00_1704 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 135 */
long BgL_n2z00_1712;
BgL_n2z00_1712 = 
(long)(BgL_arg2107z00_1704); 
BgL_modz00_1703 = 
(BgL_offsetz00_1702/BgL_n2z00_1712); } } 
{ /* ./Ast/shrinkify.scm 135 */
long BgL_restz00_1705;
{ /* ./Ast/shrinkify.scm 135 */
int BgL_arg2103z00_1706;
BgL_arg2103z00_1706 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 135 */
long BgL_n2z00_1715;
BgL_n2z00_1715 = 
(long)(BgL_arg2103z00_1706); 
BgL_restz00_1705 = 
(BgL_offsetz00_1702%BgL_n2z00_1715); } } 
{ /* ./Ast/shrinkify.scm 135 */

{ /* ./Ast/shrinkify.scm 135 */
obj_t BgL_bucketz00_1707;
{ /* ./Ast/shrinkify.scm 135 */
int BgL_kz00_1717;
BgL_kz00_1717 = 
(int)(BgL_modz00_1703); 
BgL_bucketz00_1707 = 
VECTOR_REF(BgL_arg2096z00_1698,BgL_kz00_1717); } 
{ /* ./Ast/shrinkify.scm 135 */
int BgL_kz00_1719;
BgL_kz00_1719 = 
(int)(BgL_restz00_1705); 
BgL_method2736z00_1695 = 
VECTOR_REF(BgL_bucketz00_1707,BgL_kz00_1719); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 135 */
obj_t BgL_xz00_2471;
BgL_xz00_2471 = 
PROCEDURE_ENTRY(BgL_method2736z00_1695)(BgL_method2736z00_1695, 
(obj_t)(BgL_arg3317z00_1173), BEOA); 
BgL_res3612z00_1720 = BUNSPEC; } } BgL_res3612z00_1720; } } 
{ /* ./Ast/shrinkify.scm 136 */
BgL_nodez00_bglt BgL_arg3321z00_1174;
BgL_arg3321z00_1174 = 
(((BgL_failz00_bglt)CREF(BgL_nodez00_1170))->BgL_msgz00); 
{ /* ./Ast/shrinkify.scm 136 */
obj_t BgL_res3615z00_1748;
{ /* ./Ast/shrinkify.scm 136 */
obj_t BgL_method2736z00_1723;
{ /* ./Ast/shrinkify.scm 136 */
BgL_objectz00_bglt BgL_objz00_1724;
BgL_objz00_1724 = 
(BgL_objectz00_bglt)(BgL_arg3321z00_1174); 
{ /* ./Ast/shrinkify.scm 136 */
long BgL_objzd2classzd2numz00_1725;
BgL_objzd2classzd2numz00_1725 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1724); 
{ /* ./Ast/shrinkify.scm 136 */
obj_t BgL_arg2096z00_1726;
BgL_arg2096z00_1726 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 136 */
int BgL_offsetz00_1729;
BgL_offsetz00_1729 = 
(int)(BgL_objzd2classzd2numz00_1725); 
{ /* ./Ast/shrinkify.scm 136 */
long BgL_offsetz00_1730;
BgL_offsetz00_1730 = 
(
(long)(BgL_offsetz00_1729)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 136 */
long BgL_modz00_1731;
{ /* ./Ast/shrinkify.scm 136 */
int BgL_arg2107z00_1732;
BgL_arg2107z00_1732 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 136 */
long BgL_n2z00_1740;
BgL_n2z00_1740 = 
(long)(BgL_arg2107z00_1732); 
BgL_modz00_1731 = 
(BgL_offsetz00_1730/BgL_n2z00_1740); } } 
{ /* ./Ast/shrinkify.scm 136 */
long BgL_restz00_1733;
{ /* ./Ast/shrinkify.scm 136 */
int BgL_arg2103z00_1734;
BgL_arg2103z00_1734 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 136 */
long BgL_n2z00_1743;
BgL_n2z00_1743 = 
(long)(BgL_arg2103z00_1734); 
BgL_restz00_1733 = 
(BgL_offsetz00_1730%BgL_n2z00_1743); } } 
{ /* ./Ast/shrinkify.scm 136 */

{ /* ./Ast/shrinkify.scm 136 */
obj_t BgL_bucketz00_1735;
{ /* ./Ast/shrinkify.scm 136 */
int BgL_kz00_1745;
BgL_kz00_1745 = 
(int)(BgL_modz00_1731); 
BgL_bucketz00_1735 = 
VECTOR_REF(BgL_arg2096z00_1726,BgL_kz00_1745); } 
{ /* ./Ast/shrinkify.scm 136 */
int BgL_kz00_1747;
BgL_kz00_1747 = 
(int)(BgL_restz00_1733); 
BgL_method2736z00_1723 = 
VECTOR_REF(BgL_bucketz00_1735,BgL_kz00_1747); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 136 */
obj_t BgL_xz00_2472;
BgL_xz00_2472 = 
PROCEDURE_ENTRY(BgL_method2736z00_1723)(BgL_method2736z00_1723, 
(obj_t)(BgL_arg3321z00_1174), BEOA); 
BgL_res3615z00_1748 = BUNSPEC; } } BgL_res3615z00_1748; } } 
{ /* ./Ast/shrinkify.scm 137 */
BgL_nodez00_bglt BgL_arg3325z00_1175;
BgL_arg3325z00_1175 = 
(((BgL_failz00_bglt)CREF(BgL_nodez00_1170))->BgL_objz00); 
{ /* ./Ast/shrinkify.scm 137 */
obj_t BgL_res3618z00_1776;
{ /* ./Ast/shrinkify.scm 137 */
obj_t BgL_method2736z00_1751;
{ /* ./Ast/shrinkify.scm 137 */
BgL_objectz00_bglt BgL_objz00_1752;
BgL_objz00_1752 = 
(BgL_objectz00_bglt)(BgL_arg3325z00_1175); 
{ /* ./Ast/shrinkify.scm 137 */
long BgL_objzd2classzd2numz00_1753;
BgL_objzd2classzd2numz00_1753 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1752); 
{ /* ./Ast/shrinkify.scm 137 */
obj_t BgL_arg2096z00_1754;
BgL_arg2096z00_1754 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 137 */
int BgL_offsetz00_1757;
BgL_offsetz00_1757 = 
(int)(BgL_objzd2classzd2numz00_1753); 
{ /* ./Ast/shrinkify.scm 137 */
long BgL_offsetz00_1758;
BgL_offsetz00_1758 = 
(
(long)(BgL_offsetz00_1757)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 137 */
long BgL_modz00_1759;
{ /* ./Ast/shrinkify.scm 137 */
int BgL_arg2107z00_1760;
BgL_arg2107z00_1760 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 137 */
long BgL_n2z00_1768;
BgL_n2z00_1768 = 
(long)(BgL_arg2107z00_1760); 
BgL_modz00_1759 = 
(BgL_offsetz00_1758/BgL_n2z00_1768); } } 
{ /* ./Ast/shrinkify.scm 137 */
long BgL_restz00_1761;
{ /* ./Ast/shrinkify.scm 137 */
int BgL_arg2103z00_1762;
BgL_arg2103z00_1762 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 137 */
long BgL_n2z00_1771;
BgL_n2z00_1771 = 
(long)(BgL_arg2103z00_1762); 
BgL_restz00_1761 = 
(BgL_offsetz00_1758%BgL_n2z00_1771); } } 
{ /* ./Ast/shrinkify.scm 137 */

{ /* ./Ast/shrinkify.scm 137 */
obj_t BgL_bucketz00_1763;
{ /* ./Ast/shrinkify.scm 137 */
int BgL_kz00_1773;
BgL_kz00_1773 = 
(int)(BgL_modz00_1759); 
BgL_bucketz00_1763 = 
VECTOR_REF(BgL_arg2096z00_1754,BgL_kz00_1773); } 
{ /* ./Ast/shrinkify.scm 137 */
int BgL_kz00_1775;
BgL_kz00_1775 = 
(int)(BgL_restz00_1761); 
BgL_method2736z00_1751 = 
VECTOR_REF(BgL_bucketz00_1763,BgL_kz00_1775); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 137 */
obj_t BgL_xz00_2473;
BgL_xz00_2473 = 
PROCEDURE_ENTRY(BgL_method2736z00_1751)(BgL_method2736z00_1751, 
(obj_t)(BgL_arg3325z00_1175), BEOA); 
BgL_res3618z00_1776 = BUNSPEC; } } BgL_res3618z00_1776; } } 
return BUNSPEC;} } 
}



/* shrink-node!-conditional2758 */
obj_t BGl_shrinkzd2nodez12zd2conditional2758z12zzast_shrinkifyz00(obj_t BgL_envz00_2429, obj_t BgL_nodez00_2430)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 125 */
{ 
BgL_conditionalz00_bglt BgL_nodez00_1162;
BgL_nodez00_1162 = 
(BgL_conditionalz00_bglt)(BgL_nodez00_2430); 
{ /* ./Ast/shrinkify.scm 126 */
BgL_nodez00_bglt BgL_arg3299z00_1165;
BgL_arg3299z00_1165 = 
(((BgL_conditionalz00_bglt)CREF(BgL_nodez00_1162))->BgL_testz00); 
{ /* ./Ast/shrinkify.scm 126 */
obj_t BgL_res3603z00_1636;
{ /* ./Ast/shrinkify.scm 126 */
obj_t BgL_method2736z00_1611;
{ /* ./Ast/shrinkify.scm 126 */
BgL_objectz00_bglt BgL_objz00_1612;
BgL_objz00_1612 = 
(BgL_objectz00_bglt)(BgL_arg3299z00_1165); 
{ /* ./Ast/shrinkify.scm 126 */
long BgL_objzd2classzd2numz00_1613;
BgL_objzd2classzd2numz00_1613 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1612); 
{ /* ./Ast/shrinkify.scm 126 */
obj_t BgL_arg2096z00_1614;
BgL_arg2096z00_1614 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 126 */
int BgL_offsetz00_1617;
BgL_offsetz00_1617 = 
(int)(BgL_objzd2classzd2numz00_1613); 
{ /* ./Ast/shrinkify.scm 126 */
long BgL_offsetz00_1618;
BgL_offsetz00_1618 = 
(
(long)(BgL_offsetz00_1617)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 126 */
long BgL_modz00_1619;
{ /* ./Ast/shrinkify.scm 126 */
int BgL_arg2107z00_1620;
BgL_arg2107z00_1620 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 126 */
long BgL_n2z00_1628;
BgL_n2z00_1628 = 
(long)(BgL_arg2107z00_1620); 
BgL_modz00_1619 = 
(BgL_offsetz00_1618/BgL_n2z00_1628); } } 
{ /* ./Ast/shrinkify.scm 126 */
long BgL_restz00_1621;
{ /* ./Ast/shrinkify.scm 126 */
int BgL_arg2103z00_1622;
BgL_arg2103z00_1622 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 126 */
long BgL_n2z00_1631;
BgL_n2z00_1631 = 
(long)(BgL_arg2103z00_1622); 
BgL_restz00_1621 = 
(BgL_offsetz00_1618%BgL_n2z00_1631); } } 
{ /* ./Ast/shrinkify.scm 126 */

{ /* ./Ast/shrinkify.scm 126 */
obj_t BgL_bucketz00_1623;
{ /* ./Ast/shrinkify.scm 126 */
int BgL_kz00_1633;
BgL_kz00_1633 = 
(int)(BgL_modz00_1619); 
BgL_bucketz00_1623 = 
VECTOR_REF(BgL_arg2096z00_1614,BgL_kz00_1633); } 
{ /* ./Ast/shrinkify.scm 126 */
int BgL_kz00_1635;
BgL_kz00_1635 = 
(int)(BgL_restz00_1621); 
BgL_method2736z00_1611 = 
VECTOR_REF(BgL_bucketz00_1623,BgL_kz00_1635); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 126 */
obj_t BgL_xz00_2474;
BgL_xz00_2474 = 
PROCEDURE_ENTRY(BgL_method2736z00_1611)(BgL_method2736z00_1611, 
(obj_t)(BgL_arg3299z00_1165), BEOA); 
BgL_res3603z00_1636 = BUNSPEC; } } BgL_res3603z00_1636; } } 
{ /* ./Ast/shrinkify.scm 127 */
BgL_nodez00_bglt BgL_arg3303z00_1166;
BgL_arg3303z00_1166 = 
(((BgL_conditionalz00_bglt)CREF(BgL_nodez00_1162))->BgL_truez00); 
{ /* ./Ast/shrinkify.scm 127 */
obj_t BgL_res3606z00_1664;
{ /* ./Ast/shrinkify.scm 127 */
obj_t BgL_method2736z00_1639;
{ /* ./Ast/shrinkify.scm 127 */
BgL_objectz00_bglt BgL_objz00_1640;
BgL_objz00_1640 = 
(BgL_objectz00_bglt)(BgL_arg3303z00_1166); 
{ /* ./Ast/shrinkify.scm 127 */
long BgL_objzd2classzd2numz00_1641;
BgL_objzd2classzd2numz00_1641 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1640); 
{ /* ./Ast/shrinkify.scm 127 */
obj_t BgL_arg2096z00_1642;
BgL_arg2096z00_1642 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 127 */
int BgL_offsetz00_1645;
BgL_offsetz00_1645 = 
(int)(BgL_objzd2classzd2numz00_1641); 
{ /* ./Ast/shrinkify.scm 127 */
long BgL_offsetz00_1646;
BgL_offsetz00_1646 = 
(
(long)(BgL_offsetz00_1645)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 127 */
long BgL_modz00_1647;
{ /* ./Ast/shrinkify.scm 127 */
int BgL_arg2107z00_1648;
BgL_arg2107z00_1648 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 127 */
long BgL_n2z00_1656;
BgL_n2z00_1656 = 
(long)(BgL_arg2107z00_1648); 
BgL_modz00_1647 = 
(BgL_offsetz00_1646/BgL_n2z00_1656); } } 
{ /* ./Ast/shrinkify.scm 127 */
long BgL_restz00_1649;
{ /* ./Ast/shrinkify.scm 127 */
int BgL_arg2103z00_1650;
BgL_arg2103z00_1650 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 127 */
long BgL_n2z00_1659;
BgL_n2z00_1659 = 
(long)(BgL_arg2103z00_1650); 
BgL_restz00_1649 = 
(BgL_offsetz00_1646%BgL_n2z00_1659); } } 
{ /* ./Ast/shrinkify.scm 127 */

{ /* ./Ast/shrinkify.scm 127 */
obj_t BgL_bucketz00_1651;
{ /* ./Ast/shrinkify.scm 127 */
int BgL_kz00_1661;
BgL_kz00_1661 = 
(int)(BgL_modz00_1647); 
BgL_bucketz00_1651 = 
VECTOR_REF(BgL_arg2096z00_1642,BgL_kz00_1661); } 
{ /* ./Ast/shrinkify.scm 127 */
int BgL_kz00_1663;
BgL_kz00_1663 = 
(int)(BgL_restz00_1649); 
BgL_method2736z00_1639 = 
VECTOR_REF(BgL_bucketz00_1651,BgL_kz00_1663); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 127 */
obj_t BgL_xz00_2475;
BgL_xz00_2475 = 
PROCEDURE_ENTRY(BgL_method2736z00_1639)(BgL_method2736z00_1639, 
(obj_t)(BgL_arg3303z00_1166), BEOA); 
BgL_res3606z00_1664 = BUNSPEC; } } BgL_res3606z00_1664; } } 
{ /* ./Ast/shrinkify.scm 128 */
BgL_nodez00_bglt BgL_arg3307z00_1167;
BgL_arg3307z00_1167 = 
(((BgL_conditionalz00_bglt)CREF(BgL_nodez00_1162))->BgL_falsez00); 
{ /* ./Ast/shrinkify.scm 128 */
obj_t BgL_res3609z00_1692;
{ /* ./Ast/shrinkify.scm 128 */
obj_t BgL_method2736z00_1667;
{ /* ./Ast/shrinkify.scm 128 */
BgL_objectz00_bglt BgL_objz00_1668;
BgL_objz00_1668 = 
(BgL_objectz00_bglt)(BgL_arg3307z00_1167); 
{ /* ./Ast/shrinkify.scm 128 */
long BgL_objzd2classzd2numz00_1669;
BgL_objzd2classzd2numz00_1669 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1668); 
{ /* ./Ast/shrinkify.scm 128 */
obj_t BgL_arg2096z00_1670;
BgL_arg2096z00_1670 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 128 */
int BgL_offsetz00_1673;
BgL_offsetz00_1673 = 
(int)(BgL_objzd2classzd2numz00_1669); 
{ /* ./Ast/shrinkify.scm 128 */
long BgL_offsetz00_1674;
BgL_offsetz00_1674 = 
(
(long)(BgL_offsetz00_1673)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 128 */
long BgL_modz00_1675;
{ /* ./Ast/shrinkify.scm 128 */
int BgL_arg2107z00_1676;
BgL_arg2107z00_1676 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 128 */
long BgL_n2z00_1684;
BgL_n2z00_1684 = 
(long)(BgL_arg2107z00_1676); 
BgL_modz00_1675 = 
(BgL_offsetz00_1674/BgL_n2z00_1684); } } 
{ /* ./Ast/shrinkify.scm 128 */
long BgL_restz00_1677;
{ /* ./Ast/shrinkify.scm 128 */
int BgL_arg2103z00_1678;
BgL_arg2103z00_1678 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 128 */
long BgL_n2z00_1687;
BgL_n2z00_1687 = 
(long)(BgL_arg2103z00_1678); 
BgL_restz00_1677 = 
(BgL_offsetz00_1674%BgL_n2z00_1687); } } 
{ /* ./Ast/shrinkify.scm 128 */

{ /* ./Ast/shrinkify.scm 128 */
obj_t BgL_bucketz00_1679;
{ /* ./Ast/shrinkify.scm 128 */
int BgL_kz00_1689;
BgL_kz00_1689 = 
(int)(BgL_modz00_1675); 
BgL_bucketz00_1679 = 
VECTOR_REF(BgL_arg2096z00_1670,BgL_kz00_1689); } 
{ /* ./Ast/shrinkify.scm 128 */
int BgL_kz00_1691;
BgL_kz00_1691 = 
(int)(BgL_restz00_1677); 
BgL_method2736z00_1667 = 
VECTOR_REF(BgL_bucketz00_1679,BgL_kz00_1691); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 128 */
obj_t BgL_xz00_2476;
BgL_xz00_2476 = 
PROCEDURE_ENTRY(BgL_method2736z00_1667)(BgL_method2736z00_1667, 
(obj_t)(BgL_arg3307z00_1167), BEOA); 
BgL_res3609z00_1692 = BUNSPEC; } } BgL_res3609z00_1692; } } 
return BUNSPEC;} } 
}



/* shrink-node!-setq2756 */
obj_t BGl_shrinkzd2nodez12zd2setq2756z12zzast_shrinkifyz00(obj_t BgL_envz00_2431, obj_t BgL_nodez00_2432)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 118 */
{ 
BgL_setqz00_bglt BgL_nodez00_1156;
BgL_nodez00_1156 = 
(BgL_setqz00_bglt)(BgL_nodez00_2432); 
{ /* ./Ast/shrinkify.scm 119 */
BgL_nodez00_bglt BgL_arg3289z00_1580;
BgL_arg3289z00_1580 = 
(((BgL_setqz00_bglt)CREF(BgL_nodez00_1156))->BgL_valuez00); 
{ /* ./Ast/shrinkify.scm 119 */
obj_t BgL_res3600z00_1608;
{ /* ./Ast/shrinkify.scm 119 */
obj_t BgL_method2736z00_1583;
{ /* ./Ast/shrinkify.scm 119 */
BgL_objectz00_bglt BgL_objz00_1584;
BgL_objz00_1584 = 
(BgL_objectz00_bglt)(BgL_arg3289z00_1580); 
{ /* ./Ast/shrinkify.scm 119 */
long BgL_objzd2classzd2numz00_1585;
BgL_objzd2classzd2numz00_1585 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1584); 
{ /* ./Ast/shrinkify.scm 119 */
obj_t BgL_arg2096z00_1586;
BgL_arg2096z00_1586 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 119 */
int BgL_offsetz00_1589;
BgL_offsetz00_1589 = 
(int)(BgL_objzd2classzd2numz00_1585); 
{ /* ./Ast/shrinkify.scm 119 */
long BgL_offsetz00_1590;
BgL_offsetz00_1590 = 
(
(long)(BgL_offsetz00_1589)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 119 */
long BgL_modz00_1591;
{ /* ./Ast/shrinkify.scm 119 */
int BgL_arg2107z00_1592;
BgL_arg2107z00_1592 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 119 */
long BgL_n2z00_1600;
BgL_n2z00_1600 = 
(long)(BgL_arg2107z00_1592); 
BgL_modz00_1591 = 
(BgL_offsetz00_1590/BgL_n2z00_1600); } } 
{ /* ./Ast/shrinkify.scm 119 */
long BgL_restz00_1593;
{ /* ./Ast/shrinkify.scm 119 */
int BgL_arg2103z00_1594;
BgL_arg2103z00_1594 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 119 */
long BgL_n2z00_1603;
BgL_n2z00_1603 = 
(long)(BgL_arg2103z00_1594); 
BgL_restz00_1593 = 
(BgL_offsetz00_1590%BgL_n2z00_1603); } } 
{ /* ./Ast/shrinkify.scm 119 */

{ /* ./Ast/shrinkify.scm 119 */
obj_t BgL_bucketz00_1595;
{ /* ./Ast/shrinkify.scm 119 */
int BgL_kz00_1605;
BgL_kz00_1605 = 
(int)(BgL_modz00_1591); 
BgL_bucketz00_1595 = 
VECTOR_REF(BgL_arg2096z00_1586,BgL_kz00_1605); } 
{ /* ./Ast/shrinkify.scm 119 */
int BgL_kz00_1607;
BgL_kz00_1607 = 
(int)(BgL_restz00_1593); 
BgL_method2736z00_1583 = 
VECTOR_REF(BgL_bucketz00_1595,BgL_kz00_1607); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 119 */
obj_t BgL_xz00_2477;
BgL_xz00_2477 = 
PROCEDURE_ENTRY(BgL_method2736z00_1583)(BgL_method2736z00_1583, 
(obj_t)(BgL_arg3289z00_1580), BEOA); 
BgL_res3600z00_1608 = BUNSPEC; } } BgL_res3600z00_1608; } } 
return BUNSPEC;} } 
}



/* shrink-node!-cast2754 */
obj_t BGl_shrinkzd2nodez12zd2cast2754z12zzast_shrinkifyz00(obj_t BgL_envz00_2433, obj_t BgL_nodez00_2434)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 111 */
{ 
BgL_castz00_bglt BgL_nodez00_1150;
{ /* ./Ast/shrinkify.scm 112 */
BgL_castz00_bglt BgL_auxz00_3241;
BgL_nodez00_1150 = 
(BgL_castz00_bglt)(BgL_nodez00_2434); 
{ /* ./Ast/shrinkify.scm 112 */
BgL_nodez00_bglt BgL_arg3279z00_1551;
BgL_arg3279z00_1551 = 
(((BgL_castz00_bglt)CREF(BgL_nodez00_1150))->BgL_argz00); 
{ /* ./Ast/shrinkify.scm 112 */
obj_t BgL_res3597z00_1579;
{ /* ./Ast/shrinkify.scm 112 */
obj_t BgL_method2736z00_1554;
{ /* ./Ast/shrinkify.scm 112 */
BgL_objectz00_bglt BgL_objz00_1555;
BgL_objz00_1555 = 
(BgL_objectz00_bglt)(BgL_arg3279z00_1551); 
{ /* ./Ast/shrinkify.scm 112 */
long BgL_objzd2classzd2numz00_1556;
BgL_objzd2classzd2numz00_1556 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1555); 
{ /* ./Ast/shrinkify.scm 112 */
obj_t BgL_arg2096z00_1557;
BgL_arg2096z00_1557 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 112 */
int BgL_offsetz00_1560;
BgL_offsetz00_1560 = 
(int)(BgL_objzd2classzd2numz00_1556); 
{ /* ./Ast/shrinkify.scm 112 */
long BgL_offsetz00_1561;
BgL_offsetz00_1561 = 
(
(long)(BgL_offsetz00_1560)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 112 */
long BgL_modz00_1562;
{ /* ./Ast/shrinkify.scm 112 */
int BgL_arg2107z00_1563;
BgL_arg2107z00_1563 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 112 */
long BgL_n2z00_1571;
BgL_n2z00_1571 = 
(long)(BgL_arg2107z00_1563); 
BgL_modz00_1562 = 
(BgL_offsetz00_1561/BgL_n2z00_1571); } } 
{ /* ./Ast/shrinkify.scm 112 */
long BgL_restz00_1564;
{ /* ./Ast/shrinkify.scm 112 */
int BgL_arg2103z00_1565;
BgL_arg2103z00_1565 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 112 */
long BgL_n2z00_1574;
BgL_n2z00_1574 = 
(long)(BgL_arg2103z00_1565); 
BgL_restz00_1564 = 
(BgL_offsetz00_1561%BgL_n2z00_1574); } } 
{ /* ./Ast/shrinkify.scm 112 */

{ /* ./Ast/shrinkify.scm 112 */
obj_t BgL_bucketz00_1566;
{ /* ./Ast/shrinkify.scm 112 */
int BgL_kz00_1576;
BgL_kz00_1576 = 
(int)(BgL_modz00_1562); 
BgL_bucketz00_1566 = 
VECTOR_REF(BgL_arg2096z00_1557,BgL_kz00_1576); } 
{ /* ./Ast/shrinkify.scm 112 */
int BgL_kz00_1578;
BgL_kz00_1578 = 
(int)(BgL_restz00_1564); 
BgL_method2736z00_1554 = 
VECTOR_REF(BgL_bucketz00_1566,BgL_kz00_1578); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 112 */
obj_t BgL_xz00_2478;
BgL_xz00_2478 = 
PROCEDURE_ENTRY(BgL_method2736z00_1554)(BgL_method2736z00_1554, 
(obj_t)(BgL_arg3279z00_1551), BEOA); 
BgL_res3597z00_1579 = BUNSPEC; } } BgL_res3597z00_1579; } } 
BgL_auxz00_3241 = BgL_nodez00_1150; 
return 
(obj_t)(BgL_auxz00_3241);} } } 
}



/* shrink-node!-extern2752 */
obj_t BGl_shrinkzd2nodez12zd2extern2752z12zzast_shrinkifyz00(obj_t BgL_envz00_2435, obj_t BgL_nodez00_2436)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 103 */
{ 
BgL_externz00_bglt BgL_nodez00_1139;
{ /* ./Ast/shrinkify.scm 104 */
BgL_externz00_bglt BgL_auxz00_3265;
BgL_nodez00_1139 = 
(BgL_externz00_bglt)(BgL_nodez00_2436); 
{ /* ./Ast/shrinkify.scm 104 */
bool_t BgL_test3254z00_1142;
{ /* ./Ast/shrinkify.scm 104 */
bool_t BgL_testz00_3266;
{ /* ./Ast/shrinkify.scm 104 */
obj_t BgL_auxz00_3267;
{ /* ./Ast/shrinkify.scm 104 */
BgL_objectz00_bglt BgL_auxz00_3268;
BgL_auxz00_3268 = 
(BgL_objectz00_bglt)(BgL_nodez00_1139); 
BgL_auxz00_3267 = 
BGL_OBJECT_WIDENING(BgL_auxz00_3268); } 
BgL_testz00_3266 = 
CBOOL(BgL_auxz00_3267); } 
if(BgL_testz00_3266)
{ /* ./Ast/shrinkify.scm 104 */
BgL_test3254z00_1142 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 104 */
BgL_test3254z00_1142 = ((bool_t)0); } } 
if(BgL_test3254z00_1142)
{ /* ./Ast/shrinkify.scm 104 */
{ /* ./Ast/shrinkify.scm 104 */
long BgL_arg3256z00_1144;
{ /* ./Ast/shrinkify.scm 104 */
obj_t BgL_arg3259z00_1145;
{ /* ./Ast/shrinkify.scm 104 */
obj_t BgL_arg3262z00_1146;
{ /* ./Ast/shrinkify.scm 104 */
BgL_objectz00_bglt BgL_objectz00_1540;
BgL_objectz00_1540 = 
(BgL_objectz00_bglt)(BgL_nodez00_1139); 
{ /* ./Ast/shrinkify.scm 104 */
long BgL_arg2114z00_1541;
{ /* ./Ast/shrinkify.scm 104 */
long BgL_arg2117z00_1542;
BgL_arg2117z00_1542 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_1540); 
BgL_arg2114z00_1541 = 
(BgL_arg2117z00_1542-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 104 */
obj_t BgL_vectorz00_1546;int BgL_kz00_1547;
BgL_vectorz00_1546 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_1547 = 
(int)(BgL_arg2114z00_1541); 
BgL_arg3262z00_1146 = 
VECTOR_REF(BgL_vectorz00_1546,BgL_kz00_1547); } } } 
BgL_arg3259z00_1145 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3262z00_1146); } 
BgL_arg3256z00_1144 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3259z00_1145); } 
{ /* ./Ast/shrinkify.scm 104 */
BgL_objectz00_bglt BgL_objz00_1548;
BgL_objz00_1548 = 
(BgL_objectz00_bglt)(BgL_nodez00_1139); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_1548, BgL_arg3256z00_1144); } } 
{ /* ./Ast/shrinkify.scm 104 */
BgL_objectz00_bglt BgL_auxz00_3282;
BgL_auxz00_3282 = 
(BgL_objectz00_bglt)(BgL_nodez00_1139); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_3282, BFALSE); } 
(obj_t)(BgL_nodez00_1139); }  else 
{ /* ./Ast/shrinkify.scm 104 */BFALSE; } } 
{ /* ./Ast/shrinkify.scm 105 */
obj_t BgL_arg3269z00_1147;
BgL_arg3269z00_1147 = 
(((BgL_externz00_bglt)CREF(BgL_nodez00_1139))->BgL_exprza2za2); 
BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3269z00_1147); } 
BgL_auxz00_3265 = BgL_nodez00_1139; 
return 
(obj_t)(BgL_auxz00_3265);} } } 
}



/* shrink-node!-funcall2750 */
obj_t BGl_shrinkzd2nodez12zd2funcall2750z12zzast_shrinkifyz00(obj_t BgL_envz00_2437, obj_t BgL_nodez00_2438)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 94 */
{ 
BgL_funcallz00_bglt BgL_nodez00_1127;
BgL_nodez00_1127 = 
(BgL_funcallz00_bglt)(BgL_nodez00_2438); 
{ /* ./Ast/shrinkify.scm 95 */
bool_t BgL_test3227z00_1130;
{ /* ./Ast/shrinkify.scm 95 */
bool_t BgL_testz00_3290;
{ /* ./Ast/shrinkify.scm 95 */
obj_t BgL_auxz00_3291;
{ /* ./Ast/shrinkify.scm 95 */
BgL_objectz00_bglt BgL_auxz00_3292;
BgL_auxz00_3292 = 
(BgL_objectz00_bglt)(BgL_nodez00_1127); 
BgL_auxz00_3291 = 
BGL_OBJECT_WIDENING(BgL_auxz00_3292); } 
BgL_testz00_3290 = 
CBOOL(BgL_auxz00_3291); } 
if(BgL_testz00_3290)
{ /* ./Ast/shrinkify.scm 95 */
BgL_test3227z00_1130 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 95 */
BgL_test3227z00_1130 = ((bool_t)0); } } 
if(BgL_test3227z00_1130)
{ /* ./Ast/shrinkify.scm 95 */
{ /* ./Ast/shrinkify.scm 95 */
long BgL_arg3229z00_1132;
{ /* ./Ast/shrinkify.scm 95 */
obj_t BgL_arg3232z00_1133;
{ /* ./Ast/shrinkify.scm 95 */
obj_t BgL_arg3235z00_1134;
{ /* ./Ast/shrinkify.scm 95 */
BgL_objectz00_bglt BgL_objectz00_1498;
BgL_objectz00_1498 = 
(BgL_objectz00_bglt)(BgL_nodez00_1127); 
{ /* ./Ast/shrinkify.scm 95 */
long BgL_arg2114z00_1499;
{ /* ./Ast/shrinkify.scm 95 */
long BgL_arg2117z00_1500;
BgL_arg2117z00_1500 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_1498); 
BgL_arg2114z00_1499 = 
(BgL_arg2117z00_1500-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 95 */
obj_t BgL_vectorz00_1504;int BgL_kz00_1505;
BgL_vectorz00_1504 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_1505 = 
(int)(BgL_arg2114z00_1499); 
BgL_arg3235z00_1134 = 
VECTOR_REF(BgL_vectorz00_1504,BgL_kz00_1505); } } } 
BgL_arg3232z00_1133 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3235z00_1134); } 
BgL_arg3229z00_1132 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3232z00_1133); } 
{ /* ./Ast/shrinkify.scm 95 */
BgL_objectz00_bglt BgL_objz00_1506;
BgL_objz00_1506 = 
(BgL_objectz00_bglt)(BgL_nodez00_1127); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_1506, BgL_arg3229z00_1132); } } 
{ /* ./Ast/shrinkify.scm 95 */
BgL_objectz00_bglt BgL_auxz00_3306;
BgL_auxz00_3306 = 
(BgL_objectz00_bglt)(BgL_nodez00_1127); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_3306, BFALSE); } 
(obj_t)(BgL_nodez00_1127); }  else 
{ /* ./Ast/shrinkify.scm 95 */BFALSE; } } 
{ /* ./Ast/shrinkify.scm 96 */
BgL_nodez00_bglt BgL_arg3241z00_1135;
BgL_arg3241z00_1135 = 
(((BgL_funcallz00_bglt)CREF(BgL_nodez00_1127))->BgL_funz00); 
{ /* ./Ast/shrinkify.scm 96 */
obj_t BgL_res3593z00_1535;
{ /* ./Ast/shrinkify.scm 96 */
obj_t BgL_method2736z00_1510;
{ /* ./Ast/shrinkify.scm 96 */
BgL_objectz00_bglt BgL_objz00_1511;
BgL_objz00_1511 = 
(BgL_objectz00_bglt)(BgL_arg3241z00_1135); 
{ /* ./Ast/shrinkify.scm 96 */
long BgL_objzd2classzd2numz00_1512;
BgL_objzd2classzd2numz00_1512 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1511); 
{ /* ./Ast/shrinkify.scm 96 */
obj_t BgL_arg2096z00_1513;
BgL_arg2096z00_1513 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 96 */
int BgL_offsetz00_1516;
BgL_offsetz00_1516 = 
(int)(BgL_objzd2classzd2numz00_1512); 
{ /* ./Ast/shrinkify.scm 96 */
long BgL_offsetz00_1517;
BgL_offsetz00_1517 = 
(
(long)(BgL_offsetz00_1516)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 96 */
long BgL_modz00_1518;
{ /* ./Ast/shrinkify.scm 96 */
int BgL_arg2107z00_1519;
BgL_arg2107z00_1519 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 96 */
long BgL_n2z00_1527;
BgL_n2z00_1527 = 
(long)(BgL_arg2107z00_1519); 
BgL_modz00_1518 = 
(BgL_offsetz00_1517/BgL_n2z00_1527); } } 
{ /* ./Ast/shrinkify.scm 96 */
long BgL_restz00_1520;
{ /* ./Ast/shrinkify.scm 96 */
int BgL_arg2103z00_1521;
BgL_arg2103z00_1521 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 96 */
long BgL_n2z00_1530;
BgL_n2z00_1530 = 
(long)(BgL_arg2103z00_1521); 
BgL_restz00_1520 = 
(BgL_offsetz00_1517%BgL_n2z00_1530); } } 
{ /* ./Ast/shrinkify.scm 96 */

{ /* ./Ast/shrinkify.scm 96 */
obj_t BgL_bucketz00_1522;
{ /* ./Ast/shrinkify.scm 96 */
int BgL_kz00_1532;
BgL_kz00_1532 = 
(int)(BgL_modz00_1518); 
BgL_bucketz00_1522 = 
VECTOR_REF(BgL_arg2096z00_1513,BgL_kz00_1532); } 
{ /* ./Ast/shrinkify.scm 96 */
int BgL_kz00_1534;
BgL_kz00_1534 = 
(int)(BgL_restz00_1520); 
BgL_method2736z00_1510 = 
VECTOR_REF(BgL_bucketz00_1522,BgL_kz00_1534); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 96 */
obj_t BgL_xz00_2479;
BgL_xz00_2479 = 
PROCEDURE_ENTRY(BgL_method2736z00_1510)(BgL_method2736z00_1510, 
(obj_t)(BgL_arg3241z00_1135), BEOA); 
BgL_res3593z00_1535 = BUNSPEC; } } BgL_res3593z00_1535; } } 
{ /* ./Ast/shrinkify.scm 97 */
obj_t BgL_arg3245z00_1136;
BgL_arg3245z00_1136 = 
(((BgL_funcallz00_bglt)CREF(BgL_nodez00_1127))->BgL_argsz00); 
BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3245z00_1136); } 
return BUNSPEC;} } 
}



/* shrink-node!-app-ly2748 */
obj_t BGl_shrinkzd2nodez12zd2appzd2ly2748zc0zzast_shrinkifyz00(obj_t BgL_envz00_2439, obj_t BgL_nodez00_2440)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 85 */
{ 
BgL_appzd2lyzd2_bglt BgL_nodez00_1115;
BgL_nodez00_1115 = 
(BgL_appzd2lyzd2_bglt)(BgL_nodez00_2440); 
{ /* ./Ast/shrinkify.scm 86 */
bool_t BgL_test3200z00_1118;
{ /* ./Ast/shrinkify.scm 86 */
bool_t BgL_testz00_3334;
{ /* ./Ast/shrinkify.scm 86 */
obj_t BgL_auxz00_3335;
{ /* ./Ast/shrinkify.scm 86 */
BgL_objectz00_bglt BgL_auxz00_3336;
BgL_auxz00_3336 = 
(BgL_objectz00_bglt)(BgL_nodez00_1115); 
BgL_auxz00_3335 = 
BGL_OBJECT_WIDENING(BgL_auxz00_3336); } 
BgL_testz00_3334 = 
CBOOL(BgL_auxz00_3335); } 
if(BgL_testz00_3334)
{ /* ./Ast/shrinkify.scm 86 */
BgL_test3200z00_1118 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 86 */
BgL_test3200z00_1118 = ((bool_t)0); } } 
if(BgL_test3200z00_1118)
{ /* ./Ast/shrinkify.scm 86 */
{ /* ./Ast/shrinkify.scm 86 */
long BgL_arg3202z00_1120;
{ /* ./Ast/shrinkify.scm 86 */
obj_t BgL_arg3205z00_1121;
{ /* ./Ast/shrinkify.scm 86 */
obj_t BgL_arg3208z00_1122;
{ /* ./Ast/shrinkify.scm 86 */
BgL_objectz00_bglt BgL_objectz00_1429;
BgL_objectz00_1429 = 
(BgL_objectz00_bglt)(BgL_nodez00_1115); 
{ /* ./Ast/shrinkify.scm 86 */
long BgL_arg2114z00_1430;
{ /* ./Ast/shrinkify.scm 86 */
long BgL_arg2117z00_1431;
BgL_arg2117z00_1431 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_1429); 
BgL_arg2114z00_1430 = 
(BgL_arg2117z00_1431-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 86 */
obj_t BgL_vectorz00_1435;int BgL_kz00_1436;
BgL_vectorz00_1435 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_1436 = 
(int)(BgL_arg2114z00_1430); 
BgL_arg3208z00_1122 = 
VECTOR_REF(BgL_vectorz00_1435,BgL_kz00_1436); } } } 
BgL_arg3205z00_1121 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3208z00_1122); } 
BgL_arg3202z00_1120 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3205z00_1121); } 
{ /* ./Ast/shrinkify.scm 86 */
BgL_objectz00_bglt BgL_objz00_1437;
BgL_objz00_1437 = 
(BgL_objectz00_bglt)(BgL_nodez00_1115); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_1437, BgL_arg3202z00_1120); } } 
{ /* ./Ast/shrinkify.scm 86 */
BgL_objectz00_bglt BgL_auxz00_3350;
BgL_auxz00_3350 = 
(BgL_objectz00_bglt)(BgL_nodez00_1115); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_3350, BFALSE); } 
(obj_t)(BgL_nodez00_1115); }  else 
{ /* ./Ast/shrinkify.scm 86 */BFALSE; } } 
{ /* ./Ast/shrinkify.scm 87 */
BgL_nodez00_bglt BgL_arg3214z00_1123;
BgL_arg3214z00_1123 = 
(((BgL_appzd2lyzd2_bglt)CREF(BgL_nodez00_1115))->BgL_funz00); 
{ /* ./Ast/shrinkify.scm 87 */
obj_t BgL_res3586z00_1466;
{ /* ./Ast/shrinkify.scm 87 */
obj_t BgL_method2736z00_1441;
{ /* ./Ast/shrinkify.scm 87 */
BgL_objectz00_bglt BgL_objz00_1442;
BgL_objz00_1442 = 
(BgL_objectz00_bglt)(BgL_arg3214z00_1123); 
{ /* ./Ast/shrinkify.scm 87 */
long BgL_objzd2classzd2numz00_1443;
BgL_objzd2classzd2numz00_1443 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1442); 
{ /* ./Ast/shrinkify.scm 87 */
obj_t BgL_arg2096z00_1444;
BgL_arg2096z00_1444 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 87 */
int BgL_offsetz00_1447;
BgL_offsetz00_1447 = 
(int)(BgL_objzd2classzd2numz00_1443); 
{ /* ./Ast/shrinkify.scm 87 */
long BgL_offsetz00_1448;
BgL_offsetz00_1448 = 
(
(long)(BgL_offsetz00_1447)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 87 */
long BgL_modz00_1449;
{ /* ./Ast/shrinkify.scm 87 */
int BgL_arg2107z00_1450;
BgL_arg2107z00_1450 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 87 */
long BgL_n2z00_1458;
BgL_n2z00_1458 = 
(long)(BgL_arg2107z00_1450); 
BgL_modz00_1449 = 
(BgL_offsetz00_1448/BgL_n2z00_1458); } } 
{ /* ./Ast/shrinkify.scm 87 */
long BgL_restz00_1451;
{ /* ./Ast/shrinkify.scm 87 */
int BgL_arg2103z00_1452;
BgL_arg2103z00_1452 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 87 */
long BgL_n2z00_1461;
BgL_n2z00_1461 = 
(long)(BgL_arg2103z00_1452); 
BgL_restz00_1451 = 
(BgL_offsetz00_1448%BgL_n2z00_1461); } } 
{ /* ./Ast/shrinkify.scm 87 */

{ /* ./Ast/shrinkify.scm 87 */
obj_t BgL_bucketz00_1453;
{ /* ./Ast/shrinkify.scm 87 */
int BgL_kz00_1463;
BgL_kz00_1463 = 
(int)(BgL_modz00_1449); 
BgL_bucketz00_1453 = 
VECTOR_REF(BgL_arg2096z00_1444,BgL_kz00_1463); } 
{ /* ./Ast/shrinkify.scm 87 */
int BgL_kz00_1465;
BgL_kz00_1465 = 
(int)(BgL_restz00_1451); 
BgL_method2736z00_1441 = 
VECTOR_REF(BgL_bucketz00_1453,BgL_kz00_1465); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 87 */
obj_t BgL_xz00_2480;
BgL_xz00_2480 = 
PROCEDURE_ENTRY(BgL_method2736z00_1441)(BgL_method2736z00_1441, 
(obj_t)(BgL_arg3214z00_1123), BEOA); 
BgL_res3586z00_1466 = BUNSPEC; } } BgL_res3586z00_1466; } } 
{ /* ./Ast/shrinkify.scm 88 */
BgL_nodez00_bglt BgL_arg3218z00_1124;
BgL_arg3218z00_1124 = 
(((BgL_appzd2lyzd2_bglt)CREF(BgL_nodez00_1115))->BgL_argz00); 
{ /* ./Ast/shrinkify.scm 88 */
obj_t BgL_res3589z00_1494;
{ /* ./Ast/shrinkify.scm 88 */
obj_t BgL_method2736z00_1469;
{ /* ./Ast/shrinkify.scm 88 */
BgL_objectz00_bglt BgL_objz00_1470;
BgL_objz00_1470 = 
(BgL_objectz00_bglt)(BgL_arg3218z00_1124); 
{ /* ./Ast/shrinkify.scm 88 */
long BgL_objzd2classzd2numz00_1471;
BgL_objzd2classzd2numz00_1471 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1470); 
{ /* ./Ast/shrinkify.scm 88 */
obj_t BgL_arg2096z00_1472;
BgL_arg2096z00_1472 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 88 */
int BgL_offsetz00_1475;
BgL_offsetz00_1475 = 
(int)(BgL_objzd2classzd2numz00_1471); 
{ /* ./Ast/shrinkify.scm 88 */
long BgL_offsetz00_1476;
BgL_offsetz00_1476 = 
(
(long)(BgL_offsetz00_1475)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 88 */
long BgL_modz00_1477;
{ /* ./Ast/shrinkify.scm 88 */
int BgL_arg2107z00_1478;
BgL_arg2107z00_1478 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 88 */
long BgL_n2z00_1486;
BgL_n2z00_1486 = 
(long)(BgL_arg2107z00_1478); 
BgL_modz00_1477 = 
(BgL_offsetz00_1476/BgL_n2z00_1486); } } 
{ /* ./Ast/shrinkify.scm 88 */
long BgL_restz00_1479;
{ /* ./Ast/shrinkify.scm 88 */
int BgL_arg2103z00_1480;
BgL_arg2103z00_1480 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 88 */
long BgL_n2z00_1489;
BgL_n2z00_1489 = 
(long)(BgL_arg2103z00_1480); 
BgL_restz00_1479 = 
(BgL_offsetz00_1476%BgL_n2z00_1489); } } 
{ /* ./Ast/shrinkify.scm 88 */

{ /* ./Ast/shrinkify.scm 88 */
obj_t BgL_bucketz00_1481;
{ /* ./Ast/shrinkify.scm 88 */
int BgL_kz00_1491;
BgL_kz00_1491 = 
(int)(BgL_modz00_1477); 
BgL_bucketz00_1481 = 
VECTOR_REF(BgL_arg2096z00_1472,BgL_kz00_1491); } 
{ /* ./Ast/shrinkify.scm 88 */
int BgL_kz00_1493;
BgL_kz00_1493 = 
(int)(BgL_restz00_1479); 
BgL_method2736z00_1469 = 
VECTOR_REF(BgL_bucketz00_1481,BgL_kz00_1493); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 88 */
obj_t BgL_xz00_2481;
BgL_xz00_2481 = 
PROCEDURE_ENTRY(BgL_method2736z00_1469)(BgL_method2736z00_1469, 
(obj_t)(BgL_arg3218z00_1124), BEOA); 
BgL_res3589z00_1494 = BUNSPEC; } } BgL_res3589z00_1494; } } 
return BUNSPEC;} } 
}



/* shrink-node!-app2746 */
obj_t BGl_shrinkzd2nodez12zd2app2746z12zzast_shrinkifyz00(obj_t BgL_envz00_2441, obj_t BgL_nodez00_2442)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 76 */
{ 
BgL_appz00_bglt BgL_nodez00_1103;
BgL_nodez00_1103 = 
(BgL_appz00_bglt)(BgL_nodez00_2442); 
{ /* ./Ast/shrinkify.scm 77 */
bool_t BgL_test3173z00_1106;
{ /* ./Ast/shrinkify.scm 77 */
bool_t BgL_testz00_3397;
{ /* ./Ast/shrinkify.scm 77 */
obj_t BgL_auxz00_3398;
{ /* ./Ast/shrinkify.scm 77 */
BgL_objectz00_bglt BgL_auxz00_3399;
BgL_auxz00_3399 = 
(BgL_objectz00_bglt)(BgL_nodez00_1103); 
BgL_auxz00_3398 = 
BGL_OBJECT_WIDENING(BgL_auxz00_3399); } 
BgL_testz00_3397 = 
CBOOL(BgL_auxz00_3398); } 
if(BgL_testz00_3397)
{ /* ./Ast/shrinkify.scm 77 */
BgL_test3173z00_1106 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 77 */
BgL_test3173z00_1106 = ((bool_t)0); } } 
if(BgL_test3173z00_1106)
{ /* ./Ast/shrinkify.scm 77 */
{ /* ./Ast/shrinkify.scm 77 */
long BgL_arg3175z00_1108;
{ /* ./Ast/shrinkify.scm 77 */
obj_t BgL_arg3178z00_1109;
{ /* ./Ast/shrinkify.scm 77 */
obj_t BgL_arg3181z00_1110;
{ /* ./Ast/shrinkify.scm 77 */
BgL_objectz00_bglt BgL_objectz00_1387;
BgL_objectz00_1387 = 
(BgL_objectz00_bglt)(BgL_nodez00_1103); 
{ /* ./Ast/shrinkify.scm 77 */
long BgL_arg2114z00_1388;
{ /* ./Ast/shrinkify.scm 77 */
long BgL_arg2117z00_1389;
BgL_arg2117z00_1389 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_1387); 
BgL_arg2114z00_1388 = 
(BgL_arg2117z00_1389-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 77 */
obj_t BgL_vectorz00_1393;int BgL_kz00_1394;
BgL_vectorz00_1393 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_1394 = 
(int)(BgL_arg2114z00_1388); 
BgL_arg3181z00_1110 = 
VECTOR_REF(BgL_vectorz00_1393,BgL_kz00_1394); } } } 
BgL_arg3178z00_1109 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3181z00_1110); } 
BgL_arg3175z00_1108 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3178z00_1109); } 
{ /* ./Ast/shrinkify.scm 77 */
BgL_objectz00_bglt BgL_objz00_1395;
BgL_objz00_1395 = 
(BgL_objectz00_bglt)(BgL_nodez00_1103); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_1395, BgL_arg3175z00_1108); } } 
{ /* ./Ast/shrinkify.scm 77 */
BgL_objectz00_bglt BgL_auxz00_3413;
BgL_auxz00_3413 = 
(BgL_objectz00_bglt)(BgL_nodez00_1103); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_3413, BFALSE); } 
(obj_t)(BgL_nodez00_1103); }  else 
{ /* ./Ast/shrinkify.scm 77 */BFALSE; } } 
{ /* ./Ast/shrinkify.scm 78 */
BgL_varz00_bglt BgL_arg3187z00_1111;
BgL_arg3187z00_1111 = 
(((BgL_appz00_bglt)CREF(BgL_nodez00_1103))->BgL_funz00); 
{ /* ./Ast/shrinkify.scm 78 */
obj_t BgL_res3582z00_1424;
{ /* ./Ast/shrinkify.scm 78 */
BgL_nodez00_bglt BgL_nodez00_1398;
BgL_nodez00_1398 = 
(BgL_nodez00_bglt)(BgL_arg3187z00_1111); 
{ /* ./Ast/shrinkify.scm 78 */
obj_t BgL_method2736z00_1399;
{ /* ./Ast/shrinkify.scm 78 */
BgL_objectz00_bglt BgL_objz00_1400;
BgL_objz00_1400 = 
(BgL_objectz00_bglt)(BgL_nodez00_1398); 
{ /* ./Ast/shrinkify.scm 78 */
long BgL_objzd2classzd2numz00_1401;
BgL_objzd2classzd2numz00_1401 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1400); 
{ /* ./Ast/shrinkify.scm 78 */
obj_t BgL_arg2096z00_1402;
BgL_arg2096z00_1402 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 78 */
int BgL_offsetz00_1405;
BgL_offsetz00_1405 = 
(int)(BgL_objzd2classzd2numz00_1401); 
{ /* ./Ast/shrinkify.scm 78 */
long BgL_offsetz00_1406;
BgL_offsetz00_1406 = 
(
(long)(BgL_offsetz00_1405)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 78 */
long BgL_modz00_1407;
{ /* ./Ast/shrinkify.scm 78 */
int BgL_arg2107z00_1408;
BgL_arg2107z00_1408 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 78 */
long BgL_n2z00_1416;
BgL_n2z00_1416 = 
(long)(BgL_arg2107z00_1408); 
BgL_modz00_1407 = 
(BgL_offsetz00_1406/BgL_n2z00_1416); } } 
{ /* ./Ast/shrinkify.scm 78 */
long BgL_restz00_1409;
{ /* ./Ast/shrinkify.scm 78 */
int BgL_arg2103z00_1410;
BgL_arg2103z00_1410 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 78 */
long BgL_n2z00_1419;
BgL_n2z00_1419 = 
(long)(BgL_arg2103z00_1410); 
BgL_restz00_1409 = 
(BgL_offsetz00_1406%BgL_n2z00_1419); } } 
{ /* ./Ast/shrinkify.scm 78 */

{ /* ./Ast/shrinkify.scm 78 */
obj_t BgL_bucketz00_1411;
{ /* ./Ast/shrinkify.scm 78 */
int BgL_kz00_1421;
BgL_kz00_1421 = 
(int)(BgL_modz00_1407); 
BgL_bucketz00_1411 = 
VECTOR_REF(BgL_arg2096z00_1402,BgL_kz00_1421); } 
{ /* ./Ast/shrinkify.scm 78 */
int BgL_kz00_1423;
BgL_kz00_1423 = 
(int)(BgL_restz00_1409); 
BgL_method2736z00_1399 = 
VECTOR_REF(BgL_bucketz00_1411,BgL_kz00_1423); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 78 */
obj_t BgL_xz00_2482;
BgL_xz00_2482 = 
PROCEDURE_ENTRY(BgL_method2736z00_1399)(BgL_method2736z00_1399, 
(obj_t)(BgL_nodez00_1398), BEOA); 
BgL_res3582z00_1424 = BUNSPEC; } } } BgL_res3582z00_1424; } } 
{ /* ./Ast/shrinkify.scm 79 */
obj_t BgL_arg3191z00_1112;
BgL_arg3191z00_1112 = 
(((BgL_appz00_bglt)CREF(BgL_nodez00_1103))->BgL_argsz00); 
BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3191z00_1112); } 
return BUNSPEC;} } 
}



/* shrink-node!-sequence2744 */
obj_t BGl_shrinkzd2nodez12zd2sequence2744z12zzast_shrinkifyz00(obj_t BgL_envz00_2443, obj_t BgL_nodez00_2444)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 69 */
{ 
BgL_sequencez00_bglt BgL_nodez00_1097;
BgL_nodez00_1097 = 
(BgL_sequencez00_bglt)(BgL_nodez00_2444); 
{ /* ./Ast/shrinkify.scm 70 */
obj_t BgL_arg3164z00_1382;
BgL_arg3164z00_1382 = 
(((BgL_sequencez00_bglt)CREF(BgL_nodez00_1097))->BgL_nodesz00); 
BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3164z00_1382); } 
return BUNSPEC;} } 
}



/* shrink-node!-kwote2742 */
obj_t BGl_shrinkzd2nodez12zd2kwote2742z12zzast_shrinkifyz00(obj_t BgL_envz00_2445, obj_t BgL_nodez00_2446)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 63 */
return BUNSPEC;} 
}



/* shrink-node!-var2740 */
obj_t BGl_shrinkzd2nodez12zd2var2740z12zzast_shrinkifyz00(obj_t BgL_envz00_2447, obj_t BgL_nodez00_2448)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 57 */
return BUNSPEC;} 
}



/* shrink-node!-atom2738 */
obj_t BGl_shrinkzd2nodez12zd2atom2738z12zzast_shrinkifyz00(obj_t BgL_envz00_2449, obj_t BgL_nodez00_2450)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 51 */
return BUNSPEC;} 
}



/* shrink-variable! */
obj_t BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(BgL_variablez00_bglt BgL_variablez00_2)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 37 */
{ /* ./Ast/shrinkify.scm 37 */
obj_t BgL_method2734z00_2304;
{ /* ./Ast/shrinkify.scm 37 */
BgL_objectz00_bglt BgL_objz00_2305;
BgL_objz00_2305 = 
(BgL_objectz00_bglt)(BgL_variablez00_2); 
{ /* ./Ast/shrinkify.scm 37 */
long BgL_objzd2classzd2numz00_2306;
BgL_objzd2classzd2numz00_2306 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2305); 
{ /* ./Ast/shrinkify.scm 37 */
obj_t BgL_arg2096z00_2307;
BgL_arg2096z00_2307 = 
PROCEDURE_REF(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 37 */
int BgL_offsetz00_2310;
BgL_offsetz00_2310 = 
(int)(BgL_objzd2classzd2numz00_2306); 
{ /* ./Ast/shrinkify.scm 37 */
long BgL_offsetz00_2311;
BgL_offsetz00_2311 = 
(
(long)(BgL_offsetz00_2310)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 37 */
long BgL_modz00_2312;
{ /* ./Ast/shrinkify.scm 37 */
int BgL_arg2107z00_2313;
BgL_arg2107z00_2313 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 37 */
long BgL_n2z00_2321;
BgL_n2z00_2321 = 
(long)(BgL_arg2107z00_2313); 
BgL_modz00_2312 = 
(BgL_offsetz00_2311/BgL_n2z00_2321); } } 
{ /* ./Ast/shrinkify.scm 37 */
long BgL_restz00_2314;
{ /* ./Ast/shrinkify.scm 37 */
int BgL_arg2103z00_2315;
BgL_arg2103z00_2315 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 37 */
long BgL_n2z00_2324;
BgL_n2z00_2324 = 
(long)(BgL_arg2103z00_2315); 
BgL_restz00_2314 = 
(BgL_offsetz00_2311%BgL_n2z00_2324); } } 
{ /* ./Ast/shrinkify.scm 37 */

{ /* ./Ast/shrinkify.scm 37 */
obj_t BgL_bucketz00_2316;
{ /* ./Ast/shrinkify.scm 37 */
int BgL_kz00_2326;
BgL_kz00_2326 = 
(int)(BgL_modz00_2312); 
BgL_bucketz00_2316 = 
VECTOR_REF(BgL_arg2096z00_2307,BgL_kz00_2326); } 
{ /* ./Ast/shrinkify.scm 37 */
int BgL_kz00_2328;
BgL_kz00_2328 = 
(int)(BgL_restz00_2314); 
BgL_method2734z00_2304 = 
VECTOR_REF(BgL_bucketz00_2316,BgL_kz00_2328); } } } } } } } } } } 
return 
PROCEDURE_ENTRY(BgL_method2734z00_2304)(BgL_method2734z00_2304, 
(obj_t)(BgL_variablez00_2), BEOA);} } 
}



/* _shrink-variable!3677 */
obj_t BGl__shrinkzd2variablez123677zc0zzast_shrinkifyz00(obj_t BgL_envz00_2387, obj_t BgL_variablez00_2388)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 37 */
return 
BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(
(BgL_variablez00_bglt)(BgL_variablez00_2388));} 
}



/* shrink-variable!-default2733 */
obj_t BGl_shrinkzd2variablez12zd2default2733z12zzast_shrinkifyz00(BgL_variablez00_bglt BgL_variablez00_3)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
{ /* ./Ast/shrinkify.scm 38 */
bool_t BgL_test3534z00_1277;
{ /* ./Ast/shrinkify.scm 38 */
bool_t BgL_testz00_3467;
{ /* ./Ast/shrinkify.scm 38 */
obj_t BgL_auxz00_3468;
{ /* ./Ast/shrinkify.scm 38 */
BgL_objectz00_bglt BgL_auxz00_3469;
BgL_auxz00_3469 = 
(BgL_objectz00_bglt)(BgL_variablez00_3); 
BgL_auxz00_3468 = 
BGL_OBJECT_WIDENING(BgL_auxz00_3469); } 
BgL_testz00_3467 = 
CBOOL(BgL_auxz00_3468); } 
if(BgL_testz00_3467)
{ /* ./Ast/shrinkify.scm 38 */
BgL_test3534z00_1277 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 38 */
BgL_test3534z00_1277 = ((bool_t)0); } } 
if(BgL_test3534z00_1277)
{ /* ./Ast/shrinkify.scm 38 */
{ /* ./Ast/shrinkify.scm 39 */
long BgL_arg3536z00_1279;
{ /* ./Ast/shrinkify.scm 39 */
obj_t BgL_arg3539z00_1280;
{ /* ./Ast/shrinkify.scm 39 */
obj_t BgL_arg3542z00_1281;
{ /* ./Ast/shrinkify.scm 39 */
BgL_objectz00_bglt BgL_objectz00_2332;
BgL_objectz00_2332 = 
(BgL_objectz00_bglt)(BgL_variablez00_3); 
{ /* ./Ast/shrinkify.scm 39 */
long BgL_arg2114z00_2333;
{ /* ./Ast/shrinkify.scm 39 */
long BgL_arg2117z00_2334;
BgL_arg2117z00_2334 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_2332); 
BgL_arg2114z00_2333 = 
(BgL_arg2117z00_2334-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 39 */
obj_t BgL_vectorz00_2338;int BgL_kz00_2339;
BgL_vectorz00_2338 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_2339 = 
(int)(BgL_arg2114z00_2333); 
BgL_arg3542z00_1281 = 
VECTOR_REF(BgL_vectorz00_2338,BgL_kz00_2339); } } } 
BgL_arg3539z00_1280 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3542z00_1281); } 
BgL_arg3536z00_1279 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3539z00_1280); } 
{ /* ./Ast/shrinkify.scm 39 */
BgL_objectz00_bglt BgL_objz00_2340;
BgL_objz00_2340 = 
(BgL_objectz00_bglt)(BgL_variablez00_3); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2340, BgL_arg3536z00_1279); } } 
{ /* ./Ast/shrinkify.scm 39 */
BgL_objectz00_bglt BgL_auxz00_3483;
BgL_auxz00_3483 = 
(BgL_objectz00_bglt)(BgL_variablez00_3); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_3483, BFALSE); } 
(obj_t)(BgL_variablez00_3); }  else 
{ /* ./Ast/shrinkify.scm 38 */BFALSE; } } 
{ /* ./Ast/shrinkify.scm 40 */
bool_t BgL_test3547z00_1282;
{ /* ./Ast/shrinkify.scm 40 */
bool_t BgL_testz00_3487;
{ /* ./Ast/shrinkify.scm 40 */
obj_t BgL_auxz00_3488;
{ /* ./Ast/shrinkify.scm 40 */
BgL_objectz00_bglt BgL_auxz00_3489;
{ /* ./Ast/shrinkify.scm 40 */
BgL_valuez00_bglt BgL_auxz00_3490;
BgL_auxz00_3490 = 
(((BgL_variablez00_bglt)CREF(BgL_variablez00_3))->BgL_valuez00); 
BgL_auxz00_3489 = 
(BgL_objectz00_bglt)(BgL_auxz00_3490); } 
BgL_auxz00_3488 = 
BGL_OBJECT_WIDENING(BgL_auxz00_3489); } 
BgL_testz00_3487 = 
CBOOL(BgL_auxz00_3488); } 
if(BgL_testz00_3487)
{ /* ./Ast/shrinkify.scm 40 */
BgL_test3547z00_1282 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 40 */
BgL_test3547z00_1282 = ((bool_t)0); } } 
if(BgL_test3547z00_1282)
{ /* ./Ast/shrinkify.scm 41 */
BgL_valuez00_bglt BgL_o2709z00_1283;
BgL_o2709z00_1283 = 
(((BgL_variablez00_bglt)CREF(BgL_variablez00_3))->BgL_valuez00); 
{ /* ./Ast/shrinkify.scm 41 */
long BgL_arg3549z00_1284;
{ /* ./Ast/shrinkify.scm 41 */
obj_t BgL_arg3552z00_1285;
{ /* ./Ast/shrinkify.scm 41 */
obj_t BgL_arg3555z00_1286;
{ /* ./Ast/shrinkify.scm 41 */
BgL_objectz00_bglt BgL_objectz00_2347;
BgL_objectz00_2347 = 
(BgL_objectz00_bglt)(BgL_o2709z00_1283); 
{ /* ./Ast/shrinkify.scm 41 */
long BgL_arg2114z00_2348;
{ /* ./Ast/shrinkify.scm 41 */
long BgL_arg2117z00_2349;
BgL_arg2117z00_2349 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_2347); 
BgL_arg2114z00_2348 = 
(BgL_arg2117z00_2349-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 41 */
obj_t BgL_vectorz00_2353;int BgL_kz00_2354;
BgL_vectorz00_2353 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_2354 = 
(int)(BgL_arg2114z00_2348); 
BgL_arg3555z00_1286 = 
VECTOR_REF(BgL_vectorz00_2353,BgL_kz00_2354); } } } 
BgL_arg3552z00_1285 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3555z00_1286); } 
BgL_arg3549z00_1284 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3552z00_1285); } 
{ /* ./Ast/shrinkify.scm 41 */
BgL_objectz00_bglt BgL_objz00_2355;
BgL_objz00_2355 = 
(BgL_objectz00_bglt)(BgL_o2709z00_1283); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2355, BgL_arg3549z00_1284); } } 
{ /* ./Ast/shrinkify.scm 41 */
BgL_objectz00_bglt BgL_auxz00_3506;
BgL_auxz00_3506 = 
(BgL_objectz00_bglt)(BgL_o2709z00_1283); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_3506, BFALSE); } 
return 
(obj_t)(BgL_o2709z00_1283);}  else 
{ /* ./Ast/shrinkify.scm 40 */
return BFALSE;} } } 
}



/* _shrink-variable!-default2733 */
obj_t BGl__shrinkzd2variablez12zd2default2733z12zzast_shrinkifyz00(obj_t BgL_envz00_2451, obj_t BgL_variablez00_2452)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
return 
BGl_shrinkzd2variablez12zd2default2733z12zzast_shrinkifyz00(
(BgL_variablez00_bglt)(BgL_variablez00_2452));} 
}



/* shrink-node! */
obj_t BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(BgL_nodez00_bglt BgL_nodez00_4)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 46 */
{ /* ./Ast/shrinkify.scm 46 */
obj_t BgL_method2736z00_2357;
{ /* ./Ast/shrinkify.scm 46 */
BgL_objectz00_bglt BgL_objz00_2358;
BgL_objz00_2358 = 
(BgL_objectz00_bglt)(BgL_nodez00_4); 
{ /* ./Ast/shrinkify.scm 46 */
long BgL_objzd2classzd2numz00_2359;
BgL_objzd2classzd2numz00_2359 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2358); 
{ /* ./Ast/shrinkify.scm 46 */
obj_t BgL_arg2096z00_2360;
BgL_arg2096z00_2360 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, 
(int)(((long)1))); 
{ /* ./Ast/shrinkify.scm 46 */
int BgL_offsetz00_2363;
BgL_offsetz00_2363 = 
(int)(BgL_objzd2classzd2numz00_2359); 
{ /* ./Ast/shrinkify.scm 46 */
long BgL_offsetz00_2364;
BgL_offsetz00_2364 = 
(
(long)(BgL_offsetz00_2363)-OBJECT_TYPE); 
{ /* ./Ast/shrinkify.scm 46 */
long BgL_modz00_2365;
{ /* ./Ast/shrinkify.scm 46 */
int BgL_arg2107z00_2366;
BgL_arg2107z00_2366 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 46 */
long BgL_n2z00_2374;
BgL_n2z00_2374 = 
(long)(BgL_arg2107z00_2366); 
BgL_modz00_2365 = 
(BgL_offsetz00_2364/BgL_n2z00_2374); } } 
{ /* ./Ast/shrinkify.scm 46 */
long BgL_restz00_2367;
{ /* ./Ast/shrinkify.scm 46 */
int BgL_arg2103z00_2368;
BgL_arg2103z00_2368 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 46 */
long BgL_n2z00_2377;
BgL_n2z00_2377 = 
(long)(BgL_arg2103z00_2368); 
BgL_restz00_2367 = 
(BgL_offsetz00_2364%BgL_n2z00_2377); } } 
{ /* ./Ast/shrinkify.scm 46 */

{ /* ./Ast/shrinkify.scm 46 */
obj_t BgL_bucketz00_2369;
{ /* ./Ast/shrinkify.scm 46 */
int BgL_kz00_2379;
BgL_kz00_2379 = 
(int)(BgL_modz00_2365); 
BgL_bucketz00_2369 = 
VECTOR_REF(BgL_arg2096z00_2360,BgL_kz00_2379); } 
{ /* ./Ast/shrinkify.scm 46 */
int BgL_kz00_2381;
BgL_kz00_2381 = 
(int)(BgL_restz00_2367); 
BgL_method2736z00_2357 = 
VECTOR_REF(BgL_bucketz00_2369,BgL_kz00_2381); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 46 */
obj_t BgL_xz00_2483;
BgL_xz00_2483 = 
PROCEDURE_ENTRY(BgL_method2736z00_2357)(BgL_method2736z00_2357, 
(obj_t)(BgL_nodez00_4), BEOA); 
return BUNSPEC;} } } 
}



/* _shrink-node!3679 */
obj_t BGl__shrinkzd2nodez123679zc0zzast_shrinkifyz00(obj_t BgL_envz00_2389, obj_t BgL_nodez00_2390)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 46 */
return 
BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
(BgL_nodez00_bglt)(BgL_nodez00_2390));} 
}



/* shrink-node!-default2735 */
obj_t BGl_shrinkzd2nodez12zd2default2735z12zzast_shrinkifyz00(BgL_nodez00_bglt BgL_nodez00_5)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
{ /* ./Ast/shrinkify.scm 15 */
obj_t BgL_procz00_2382;obj_t BgL_objectz00_2384;
BgL_procz00_2382 = 
CNST_TABLE_REF(((long)0)); 
BgL_objectz00_2384 = 
(obj_t)(BgL_nodez00_5); 
FAILURE(BgL_procz00_2382,BGl_string4249z00zzast_shrinkifyz00,BgL_objectz00_2384);} } 
}



/* _shrink-node!-default2735 */
obj_t BGl__shrinkzd2nodez12zd2default2735z12zzast_shrinkifyz00(obj_t BgL_envz00_2453, obj_t BgL_nodez00_2454)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
return 
BGl_shrinkzd2nodez12zd2default2735z12zzast_shrinkifyz00(
(BgL_nodez00_bglt)(BgL_nodez00_2454));} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00()
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19090), 
BSTRING_TO_STRING(BGl_string4250z00zzast_shrinkifyz00)); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)44246), 
BSTRING_TO_STRING(BGl_string4250z00zzast_shrinkifyz00)); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)50868), 
BSTRING_TO_STRING(BGl_string4250z00zzast_shrinkifyz00)); 
return 
BGl_modulezd2initializa7ationz75zzast_envz00(((long)62031), 
BSTRING_TO_STRING(BGl_string4250z00zzast_shrinkifyz00));} 
}

